package dominio;

import java.io.Serializable;
import java.util.Hashtable;

import dominio.exceptions.CitaConFechaNoAsignadaException;
import dominio.exceptions.CitaYaAsigndaException;

public class Lista implements Serializable{

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	private Hashtable<Integer,Cita> asignados;

	private int dia;
	private String mes;
	private int ao;

	private int cantidadMaxima;


	private Hashtable<Integer, Cita> especiales;

	public Lista(int dia, String mes, int ao, int cm){
		this.dia = dia;
		this.mes = mes;
		this.ao = ao;
		this.cantidadMaxima = cm;
		this.asignados = new  Hashtable<Integer, Cita>();
		this.especiales = new Hashtable<Integer, Cita>();
	}

	public void addAsignado(Cita a) throws CitaConFechaNoAsignadaException, CitaYaAsigndaException{

		if(asignados.size() == this.cantidadMaxima){
			throw new CitaConFechaNoAsignadaException("La lista est completa para este da ("+dia+"/"+mes+"/"+ao+"). Intente asignar la cita otro da o de manera especial");
		}
		if(this.asignados.containsKey(a.getNumeroHistoria())){
			throw new CitaYaAsigndaException("Ya se ha asignado un paciente con el nmero de historia "+a.getNumeroHistoria()+" este da ("+dia+"/"+mes+"/"+ao+"). Intente asignar la nueva cita otro da.");
		}
		if(this.especiales.containsKey(a.getNumeroHistoria())){
			throw new CitaYaAsigndaException("Ya se ha asignado un paciente con el nmero de historia "+a.getNumeroHistoria()+" este da ("+dia+"/"+mes+"/"+ao+"). Intente asignar la nueva cita otro da.");
		}


		this.asignados.put(a.getNumeroHistoria(), a);
	}

	public void addEspecial(Cita a) throws CitaYaAsigndaException{

		if(this.asignados.containsKey(a.getNumeroHistoria())){
			throw new CitaYaAsigndaException("Ya se ha asignado un paciente con el nmero de historia "+a.getNumeroHistoria()+" este da ("+dia+"/"+mes+"/"+ao+"). Intente asignar la nueva cita otro da.");
		}
		if(this.especiales.containsKey(a.getNumeroHistoria())){
			throw new CitaYaAsigndaException("Ya se ha asignado un paciente con el nmero de historia "+a.getNumeroHistoria()+" este da ("+dia+"/"+mes+"/"+ao+"). Intente asignar la nueva cita otro da.");
		}

		this.especiales.put(a.getNumeroHistoria(), a);
	}

	public int getNumeroAsignados(){
		return this.asignados.size();
	}

	public int getNumeroEspeciales(){
		return this.especiales.size();
	}

	public int getNumeroTotal(){
		return this.asignados.size()+this.especiales.size();
	}

	public Hashtable<Integer, Cita> getAsignados() {
		return asignados;
	}



	public int getDia() {
		return dia;
	}

	public void setDia(int dia) {
		this.dia = dia;
	}

	public String getMes() {
		return mes;
	}

	public void setMes(String mes) {
		this.mes = mes;
	}

	public int getAo() {
		return ao;
	}

	public void setAo(int ao) {
		this.ao = ao;
	}

	public int getCantidadMaxima() {
		return cantidadMaxima;
	}

	public void setCantidadMaxima(int cantidadMaxima) {
		this.cantidadMaxima = cantidadMaxima;
	}

	public Hashtable<Integer, Cita> getEspeciales() {
		return especiales;
	}


	public Cita borrarAsignado(int nh){

		Cita c = this.asignados.remove(nh);
		return c;
	}

	public Cita borrarEspecial(int nh){

		Cita c = this.especiales.remove(nh);
		return c;
	}

	public boolean hayHueco(){
		int huecos = this.cantidadMaxima - this.asignados.size();

		boolean hayHueco = true;
		if(huecos == 0){
			hayHueco = false;
		}

		return hayHueco;
	}

}
