package dominio;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;

import com.jrefinery.report.JFreeReport;
import com.jrefinery.report.ReportProcessingException;
import com.jrefinery.report.function.FunctionInitializeException;
import com.jrefinery.report.targets.pageable.OutputTargetException;
import com.jrefinery.report.targets.pageable.PageableReportProcessor;
import com.jrefinery.report.targets.pageable.ReportStateList;
import com.jrefinery.report.targets.pageable.output.G2OutputTarget;

public class Printer implements Printable
{
	PageableReportProcessor prp;
	PageFormat pf;

	public Printer() {
		prp = null;
		pf = null;
	}

	public Printer(JFreeReport jfreereport, PageFormat pageformat) {
		try {
			prp = new PageableReportProcessor(jfreereport);
			pf = pageformat;
		} catch (ReportProcessingException reportprocessingexception) {
			reportprocessingexception.printStackTrace();
		} catch (FunctionInitializeException functioninitializeexception) {
			functioninitializeexception.printStackTrace();
		}
	}

	public int print(Graphics g, PageFormat pf, int nPage) throws PrinterException {

		G2OutputTarget target = new G2OutputTarget((Graphics2D) g, pf);

		this.prp.setOutputTarget(target);

		try {
			target.open();

			ReportStateList list = this.prp.repaginate();
			if(list.size()>nPage){
				this.prp.processPage(list.get(nPage), target);

			}else{
				return Printable.NO_SUCH_PAGE;
			}

		} catch (OutputTargetException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ReportProcessingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return Printable.PAGE_EXISTS;
	}

	public int getNPages() {
		G2OutputTarget g2outputtarget = new G2OutputTarget(G2OutputTarget.createEmptyGraphics(), pf);
		prp.setOutputTarget(g2outputtarget);
		try {
			g2outputtarget.open();
		} catch (OutputTargetException outputtargetexception) {
			outputtargetexception.printStackTrace();
		}
		ReportStateList reportstatelist = null;
		try {
			reportstatelist = prp.repaginate();
		} catch (ReportProcessingException reportprocessingexception) {
			reportprocessingexception.printStackTrace();
		}
		return reportstatelist.size();
	}
}
