package persistencia;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Hashtable;

import configuracion.Configuracion;
import dominio.Mes;

public class Persistencia {

	public static boolean debug = false;


	public static Configuracion getConfiguration() throws FileNotFoundException, IOException, ClassNotFoundException{

		ObjectInputStream ois = new ObjectInputStream(new FileInputStream(new File("./configurationCitasMed")));
		Configuracion c = (Configuracion) ois.readObject();
		return c;


	}
	public static boolean saveConfiguration(Configuracion c) throws FileNotFoundException, IOException{
		File f = new File("./configurationCitasMed");
		if(!f.exists()){
			f.createNewFile();
		}

		ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(f));
		oos.writeObject(c);
		oos.close();
		return true;
	}



	public static boolean saveDataBase(File f, Hashtable<String, Mes> meses) throws IOException{

		if(!Persistencia.debug){
			try{

				if(!f.exists()){
					f.createNewFile();
				}

				ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(f));
				oos.writeObject(meses);
				oos.close();
				return true;
			}catch(IOException e){
				e.printStackTrace();
				throw e;
			}
		}

		return true;

	}

	public static Hashtable<String, Mes> readDataBase(File f) throws IOException, ClassNotFoundException{
		ObjectInputStream ois = new ObjectInputStream(new FileInputStream(f));
		Hashtable<String, Mes> meses = (Hashtable<String, Mes>) ois.readObject();
		return meses;
	}

	public static void borrarDataBase(File f){
		f.delete();
	}
	public static boolean  existeConfiguracion() {
		// TODO Auto-generated method stub
		File f = new File("./configurationCitasMed");
		return f.exists();
	}

}
