package presentacion;

import java.awt.event.KeyEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Event;
import javax.swing.SwingUtilities;
import javax.swing.KeyStroke;
import java.awt.Point;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JFrame;
import javax.swing.JDialog;
import javax.swing.JSpinner;
import javax.swing.JTextPane;
import javax.swing.SpinnerListModel;

import java.awt.Dimension;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JScrollPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;

import java.awt.Color;
import java.io.File;
import java.io.IOException;
import java.util.Calendar;
import java.util.Vector;
import javax.swing.JList;
import javax.swing.ListSelectionModel;

import dominio.Cita;
import dominio.Control;
import dominio.Lista;
import dominio.Mes;

import javax.swing.JTable;
import javax.swing.JTextArea;

import presentacion.configuration.JDConfiguration;

public class CitasMEd implements IVentana, IContenedorDias{

	private JFrame jFrame = null;
	private JMenuBar jJMenuBar = null;
	private JMenu fileMenu = null;
	private JMenu helpMenu = null;
	private JMenuItem exitMenuItem = null;
	private JMenuItem aboutMenuItem = null;
	private JMenuItem saveMenuItem = null;
	private JDialog aboutDialog = null;  //  @jve:decl-index=0:visual-constraint="10,220"
	private JPanel aboutContentPane = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JScrollPane jScrollPane = null;
	private JMenu jMenuCitas = null;
	private JMenuItem jMenuItemCrearCita = null;
	private JMenuItem jMenuItemCrearCitaE = null;
	private JMenuItem jMenuItemBuscar = null;
	private JMenuItem jMenuItemBorrar = null;
	private JMenuItem jMenuItemP = null;
	private JMenuItem jMenuItemN = null;
	private JMenu jMenuLitas = null;
	private JMenuItem jMenuItemC = null;
	private JMenuItem jMenuItemE = null;
	private JMenuItem jMenuItemSBD = null;
	private JMenuItem jMenuItemADCE = null;
	private JPanel jContenPanel = null;
	private JLabel jLabelAo = null;

	private JSpinner aoSelector = null;
	private JList jListMese = null;
	private JLabel Jlabelm = null;

	private Control control;

	private JTextPane sinDias;



	private JDiasComponent dias = null;



	/**
	 * This method initializes jFrame
	 *
	 * @return javax.swing.JFrame
	 */
	private JFrame getJFrame() {
		if (jFrame == null) {
			jFrame = new JFrame();
			//jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			jFrame.setJMenuBar(getJJMenuBar());
			jFrame.setSize(1100, 650);
			jFrame.setContentPane(getJScrollPane());



			String dataBase = this.control.getPathDBCitas();
			dataBase = dataBase.replace("\\", "/");
			String [] dataBaseName = dataBase.split("/");
			String name = dataBaseName[dataBaseName.length-1];
			jFrame.setTitle("CitasMed - base de datos de citas: "+name);

			jFrame.addWindowListener(new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent e) {
					cerrarApp();
				}
			});
			diaSelected(sinDias, "-1");
		}
		return jFrame;
	}

	/**
	 * This method initializes jJMenuBar
	 *
	 * @return javax.swing.JMenuBar
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getFileMenu());
			jJMenuBar.add(getJMenuCitas());
			jJMenuBar.add(getJMenuLitas());
			jJMenuBar.add(getJMenuImprimir());
			jJMenuBar.add(getHelpMenu());



		}
		return jJMenuBar;
	}

	/**
	 * This method initializes jMenu
	 *
	 * @return javax.swing.JMenu
	 */
	private JMenu getFileMenu() {
		if (fileMenu == null) {
			fileMenu = new JMenu();
			fileMenu.setText("Archivo");
			fileMenu.add(getJMenuItemN());
			fileMenu.add(getJMenuItemSBD());
			fileMenu.add(getJMenuItemP());
			//fileMenu.add(getSaveMenuItem());
			//fileMenu.add(getJMenuItemGuardarComo());
			fileMenu.add(getExitMenuItem());




		}
		return fileMenu;
	}

	/**
	 * This method initializes jMenu
	 *
	 * @return javax.swing.JMenu
	 */
	private JMenu getHelpMenu() {
		if (helpMenu == null) {
			helpMenu = new JMenu();
			helpMenu.setText("Ayuda");
			helpMenu.add(getAboutMenuItem());
		}
		return helpMenu;
	}

	/**
	 * This method initializes jMenuItem
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getExitMenuItem() {
		if (exitMenuItem == null) {
			exitMenuItem = new JMenuItem();
			exitMenuItem.setText("Salir");
			exitMenuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {

					cerrarApp();
				}
			});
		}
		return exitMenuItem;
	}

	/**
	 * This method initializes jMenuItem
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getAboutMenuItem() {
		if (aboutMenuItem == null) {
			aboutMenuItem = new JMenuItem();
			aboutMenuItem.setText("Acerca de CitasMed");
			aboutMenuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					JDialog aboutDialog = getAboutDialog();
					aboutDialog.pack();
					Point loc = getJFrame().getLocation();
					loc.translate(20, 20);
					aboutDialog.setLocation(loc);
					aboutDialog.setVisible(true);
					System.out.println("Lo he ejecutado!!!");
				}
			});
		}
		return aboutMenuItem;
	}

	/**
	 * This method initializes aboutDialog
	 *
	 * @return javax.swing.JDialog
	 */
	private JDialog getAboutDialog() {
		if (aboutDialog == null) {
			aboutDialog = new JDialog(getJFrame(), true);
			aboutDialog.setTitle("Acerca de Citas Med");
			aboutDialog.setSize(new Dimension(444, 107));
			aboutDialog.setContentPane(getAboutContentPane());
		}
		return aboutDialog;
	}

	/**
	 * This method initializes aboutContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getAboutContentPane() {
		if (aboutContentPane == null) {
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.fill = GridBagConstraints.NONE;
			gridBagConstraints11.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints11.gridy = 0;
			jLabel1 = new JLabel();
			jLabel1.setText("Version 1.0");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.ipadx = 0;
			gridBagConstraints1.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints1.gridwidth = 0;
			gridBagConstraints1.gridheight = 0;
			gridBagConstraints1.fill = GridBagConstraints.NONE;
			gridBagConstraints1.gridy = 1;
			jLabel = new JLabel();
			jLabel.setText("Desarrollado por Pedro Reales Mateo (pedro.reales@gmail.com)");
			aboutContentPane = new JPanel();
			aboutContentPane.setLayout(new GridBagLayout());
			aboutContentPane.setBackground(Color.white);
			aboutContentPane.add(jLabel, gridBagConstraints1);
			aboutContentPane.add(jLabel1, gridBagConstraints11);
		}
		return aboutContentPane;
	}

	/**
	 * This method initializes jMenuItem
	 *
	 * @return javax.swing.JMenuItem
	 *
	private JMenuItem getSaveMenuItem() {
		if (saveMenuItem == null) {
			saveMenuItem = new JMenuItem();
			saveMenuItem.setText("Guardar");
			saveMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
					Event.CTRL_MASK, true));
			saveMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					guardar();
				}
			});
		}
		return saveMenuItem;
	}*/

	/**
	 * This method initializes jScrollPane
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJContenPanel());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jMenuCitas
	 *
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenuCitas() {
		if (jMenuCitas == null) {
			jMenuCitas = new JMenu();
			jMenuCitas.setText("Citas");
			jMenuCitas.add(getJMenuItemCrearCita());
			jMenuCitas.add(getJMenuItemCrearCitaE());
			jMenuCitas.add(getJMenuItemBuscar());
			jMenuCitas.add(getJMenuItemBorrar());
			jMenuCitas.add(getJMenuItemADCE());
			jMenuCitas.add(getJMenuItemA());
		}
		return jMenuCitas;
	}

	/**
	 * This method initializes jMenuItemCrearCita
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemCrearCita() {
		if (jMenuItemCrearCita == null) {
			jMenuItemCrearCita = new JMenuItem();
			jMenuItemCrearCita.setText("Nueva cita");
			jMenuItemCrearCita.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					crearCita(false);
				}
			});
		}
		return jMenuItemCrearCita;
	}

	/**
	 * This method initializes jMenuItemCrearCitaE
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemCrearCitaE() {
		if (jMenuItemCrearCitaE == null) {
			jMenuItemCrearCitaE = new JMenuItem();
			jMenuItemCrearCitaE.setText("Nueva cita especial");
			jMenuItemCrearCitaE.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					crearCita(true);
				}
			});
		}
		return jMenuItemCrearCitaE;
	}

	/**
	 * This method initializes jMenuItemBuscar
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemBuscar() {
		if (jMenuItemBuscar == null) {
			jMenuItemBuscar = new JMenuItem();
			jMenuItemBuscar.setText("Buscar cita...");
			jMenuItemBuscar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					buscarCitas();
				}
			});
		}
		return jMenuItemBuscar;
	}

	/**
	 * This method initializes jMenuItemBorrar
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemBorrar() {
		if (jMenuItemBorrar == null) {
			jMenuItemBorrar = new JMenuItem();
			jMenuItemBorrar.setText("Borrar cita");
			jMenuItemBorrar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					borrarCita();
				}
			});
		}
		return jMenuItemBorrar;
	}

	/**
	 * This method initializes jMenuItemP
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemP() {
		if (jMenuItemP == null) {
			jMenuItemP = new JMenuItem();
			jMenuItemP.setText("Preferencias");
			jMenuItemP.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					preferencias();
				}
			});
		}
		return jMenuItemP;
	}

	/**
	 * This method initializes jMenuItemN
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemN() {
		if (jMenuItemN == null) {
			jMenuItemN = new JMenuItem();
			jMenuItemN.setText("Nueva base de datos de citas");
			jMenuItemN.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					nuevaDataBase();
				}
			});
		}
		return jMenuItemN;
	}

	/**
	 * This method initializes jMenuLitas
	 *
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenuLitas() {
		if (jMenuLitas == null) {
			jMenuLitas = new JMenu();
			jMenuLitas.setText("Listas");
			jMenuLitas.add(getJMenuItemC());
			jMenuLitas.add(getJMenuItemE());
			jMenuLitas.add(getJMenuItemCM());
			jMenuLitas.add(getJMenuItemB());
		}
		return jMenuLitas;
	}

	/**
	 * This method initializes jMenuItemC
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemC() {
		if (jMenuItemC == null) {
			jMenuItemC = new JMenuItem();
			jMenuItemC.setText("Crear listas");
			jMenuItemC.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					crearListas();
				}
			});
		}
		return jMenuItemC;
	}

	/**
	 * This method initializes jMenuItemE
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemE() {
		if (jMenuItemE == null) {
			jMenuItemE = new JMenuItem();
			jMenuItemE.setText("Mover lista de da");
			jMenuItemE.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					moverLista();
				}
			});
		}
		return jMenuItemE;
	}

	/**
	 * This method initializes jMenuItemSBD
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemSBD() {
		if (jMenuItemSBD == null) {
			jMenuItemSBD = new JMenuItem();
			jMenuItemSBD.setText("Cambiar base de datos de citas");
			jMenuItemSBD.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					cambiarDataBase();
				}
			});
		}
		return jMenuItemSBD;
	}

	/**
	 * This method initializes jMenuItemADCE
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemADCE() {
		if (jMenuItemADCE == null) {
			jMenuItemADCE = new JMenuItem();
			jMenuItemADCE.setText("Asignar da a cita");
			jMenuItemADCE.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					asignarDiaACita();
				}
			});
		}
		return jMenuItemADCE;
	}

	/**
	 * This method initializes jContenPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContenPanel() {
		if (jContenPanel == null) {
			GridBagConstraints gridBagConstraints111 = new GridBagConstraints();
			gridBagConstraints111.gridx = 4;
			gridBagConstraints111.fill = GridBagConstraints.BOTH;
			gridBagConstraints111.gridheight = 8;
			gridBagConstraints111.weightx = 1.0D;
			gridBagConstraints111.gridy = 0;
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.fill = GridBagConstraints.BOTH;
			gridBagConstraints22.gridy = 7;
			gridBagConstraints22.weightx = 0.0D;
			gridBagConstraints22.weighty = 2.0D;
			gridBagConstraints22.gridheight = 1;
			gridBagConstraints22.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints22.gridwidth = 2;
			gridBagConstraints22.ipadx = 0;
			gridBagConstraints22.gridx = 1;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints6.gridwidth = 3;
			gridBagConstraints6.anchor = GridBagConstraints.EAST;
			gridBagConstraints6.gridy = 6;
			jLabel2 = new JLabel();
			jLabel2.setText("Observaciones");
			JLabelCS = new JLabel();
			JLabelCS.setText("Personas citadas especiales");
			jLabel2PC = new JLabel();
			jLabel2PC.setText("Personas Citadas");
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 1;
			gridBagConstraints2.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints2.anchor = GridBagConstraints.WEST;
			gridBagConstraints2.gridy = 2;
			Jlabelm = new JLabel();
			Jlabelm.setText("Mes: ");
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.fill = GridBagConstraints.NONE;
			gridBagConstraints12.gridy = 3;
			gridBagConstraints12.weightx = 0;
			gridBagConstraints12.weighty = 0;
			gridBagConstraints12.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints12.anchor = GridBagConstraints.EAST;
			gridBagConstraints12.gridx = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 1;
			gridBagConstraints.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints.anchor = GridBagConstraints.EAST;
			gridBagConstraints.gridy = 0;
			jLabelAo = new JLabel();
			jLabelAo.setText("Ao: ");
			jContenPanel = new JPanel();
			jContenPanel.setLayout(new GridBagLayout());
			GridBagConstraints gridBagConstraintsAo = new GridBagConstraints();
			gridBagConstraintsAo.gridx = 1;
			gridBagConstraintsAo.insets = new Insets(5, 5, 5, 5);
			gridBagConstraintsAo.anchor = GridBagConstraints.EAST;
			gridBagConstraintsAo.gridy = 1;
			jContenPanel.add(jLabelAo, gridBagConstraints);
			jContenPanel.add(getAoSelector(), gridBagConstraintsAo);
			GridBagConstraints gridBagConstraintsD = new GridBagConstraints();
			gridBagConstraintsD.gridx = 2;
			gridBagConstraintsD.insets = new Insets(5, 5, 5, 5);
			gridBagConstraintsD.gridy = 0;
			gridBagConstraintsD.gridheight = 6;
			gridBagConstraintsD.gridwidth = 1;
			gridBagConstraintsD.anchor = GridBagConstraints.WEST;
			jContenPanel.add(getJListMese(), gridBagConstraints12);
			jContenPanel.add(Jlabelm, gridBagConstraints2);
			jContenPanel.add(this.getDias(),gridBagConstraintsD);

			GridBagConstraints gbcSD = new GridBagConstraints();
			gbcSD.fill = GridBagConstraints.NONE;
			gbcSD.gridy = 4;
			gbcSD.gridx = 0;
			gbcSD.insets = new Insets(5, 5, 5, 5);
			gbcSD.gridwidth = 2;
			gbcSD.anchor = GridBagConstraints.NORTHEAST;
			GridBagConstraints gbcSDT = new GridBagConstraints();
			gbcSDT.fill = GridBagConstraints.NONE;
			gbcSDT.gridy = 5;
			gbcSDT.gridx = 1;
			gbcSDT.anchor = GridBagConstraints.NORTHEAST;
			gbcSDT.insets = new Insets(5, 5, 5, 5);
			jContenPanel.add(new JLabel("Citas sin das: "), gbcSD);
			jContenPanel.add(getSinDias(), gbcSDT);
			jContenPanel.add(jLabel2, gridBagConstraints6);
			jContenPanel.add(getJScrollPaneComments(), gridBagConstraints22);
			jContenPanel.add(getJPanelTablas(), gridBagConstraints111);
		}
		return jContenPanel;
	}


	public JTextPane getSinDias(){
		if(this.sinDias == null){
			sinDias = new JTextPane();
			sinDias.setName("99");
			sinDias.setPreferredSize(new Dimension(100, 68));
			sinDias.setEditable(false);
			sinDias.setBorder(BorderFactory.createLineBorder(Color.black));

			sinDias.addFocusListener(new java.awt.event.FocusAdapter() {


				public void focusGained(java.awt.event.FocusEvent e) {
					diaSelected(sinDias, "-1");
				}
			});
			sinDias.setText("0 citas");
		}
		return sinDias;
	}

	/**
	 * This method initializes jListMese
	 *
	 * @return javax.swing.JList
	 */
	private JList getJListMese() {
		if (jListMese == null) {
			DefaultListModel lm = new DefaultListModel();
			lm.addElement("Enero");
			lm.addElement("Febrero");
			lm.addElement("Marzo");
			lm.addElement("Abril");
			lm.addElement("Mayo");
			lm.addElement("Junio");
			lm.addElement("Julio");
			lm.addElement("Agosto");
			lm.addElement("Septiembre");
			lm.addElement("Octubre");
			lm.addElement("Noviembre");
			lm.addElement("Diciembre");
			jListMese = new JList(lm);
			jListMese.setSelectedIndex(Calendar.getInstance().get(Calendar.MONTH));
			jListMese.setPreferredSize(new Dimension(100, 230));
			jListMese.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			jListMese.setBorder(BorderFactory.createLineBorder(Color.black));
			jListMese
					.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
						public void valueChanged(javax.swing.event.ListSelectionEvent e) {
							updateUI();
						}
					});
		}
		return jListMese;
	}

	/**
	 * This method initializes jScrollPane1PC
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1PC() {
		if (jScrollPane1PC == null) {
			jScrollPane1PC = new JScrollPane();
			jScrollPane1PC.setPreferredSize(new Dimension(40, 40));
			jScrollPane1PC.setViewportView(getJTablePC());
		}
		return jScrollPane1PC;
	}

	/**
	 * This method initializes jTablePC
	 *
	 * @return javax.swing.JTable
	 */

	private DefaultTableModel modelPC;

	private JTable getJTablePC() {
		if (jTablePC == null) {

			String  [] colums = new String [2];
			colums[0] = "Nombre";
			colums[1] = "Nmero de Historia";

			modelPC = new DefaultTableModel(colums, 0);

			jTablePC = new JTable(modelPC);
			jTablePC.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			jTablePC.setAutoCreateRowSorter(true);

			jTablePC.getSelectionModel().addListSelectionListener(
			        new ListSelectionListener() {
			            public void valueChanged(ListSelectionEvent event) {

			            	int viewRow = jTablePC.getSelectedRow();
			            	 if (viewRow >= 0){
			            		 jTablePCS.clearSelection();
			            		 int modelRow =jTablePC.convertRowIndexToModel(viewRow);
			                    citaSelected((Integer)jTablePC.getModel().getValueAt(modelRow, 1));
			                }
			            }
			        }
			);
			
			jTablePC.setName("tablePC");
		}
		return jTablePC;
	}

	/**
	 * This method initializes jScrollPane1PCS
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1PCS() {
		if (jScrollPane1PCS == null) {
			jScrollPane1PCS = new JScrollPane();
			jScrollPane1PCS.setPreferredSize(new Dimension(40, 40));
			jScrollPane1PCS.setViewportView(getJTablePCS());



		}
		return jScrollPane1PCS;
	}

	/**
	 * This method initializes jTablePCS
	 *
	 * @return javax.swing.JTable
	 */

	private DefaultTableModel modelPCS;
	private JTable getJTablePCS() {
		if (jTablePCS == null) {
			String  [] colums = new String [2];
			colums[0] = "Nombre";
			colums[1] = "Nmero de Historia";

			modelPCS = new DefaultTableModel(colums, 0);

			jTablePCS = new JTable(modelPCS);
			jTablePCS.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			jTablePCS.setAutoCreateRowSorter(true);

			jTablePCS.getSelectionModel().addListSelectionListener(
			        new ListSelectionListener() {
			            public void valueChanged(ListSelectionEvent event) {
			            	int viewRow = jTablePCS.getSelectedRow();
			                if (viewRow >= 0){
			                	jTablePC.clearSelection();

			                	int modelRow =jTablePCS.convertRowIndexToModel(viewRow);
			                    citaSelected((Integer)jTablePCS.getModel().getValueAt(modelRow, 1));
			                }
			            }
			        }
			);
			jTablePCS.setName("tablePCS");

		}
		return jTablePCS;
	}

	/**
	 * This method initializes jScrollPaneComments
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPaneComments() {
		if (jScrollPaneComments == null) {
			jScrollPaneComments = new JScrollPane();
			jScrollPaneComments.setPreferredSize(new Dimension(0, 0));
			jScrollPaneComments.setViewportView(getJTextAreaComments());
		}
		return jScrollPaneComments;
	}

	/**
	 * This method initializes jTextAreaComments
	 *
	 * @return javax.swing.JTextArea
	 */
	private JTextArea getJTextAreaComments() {
		if (jTextAreaComments == null) {
			jTextAreaComments = new JTextArea();
			jTextAreaComments.setName("textObservaciones");
		}
		return jTextAreaComments;
	}

	/**
	 * This method initializes jMenuItemCM
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemCM() {
		if (jMenuItemCM == null) {
			jMenuItemCM = new JMenuItem();
			jMenuItemCM.setText("Cambiar el n\u00FAmero m\u00E1ximo de citas");
			jMenuItemCM.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					cambiarMaxCitas();
				}
			});
		}
		return jMenuItemCM;
	}

	/**
	 * This method initializes jMenuItemB
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemB() {
		if (jMenuItemB == null) {
			jMenuItemB = new JMenuItem();
			jMenuItemB.setText("Borrar lista");
			jMenuItemB.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					borrarLista();
				}
			});
		}
		return jMenuItemB;
	}

	/**
	 * This method initializes jMenuItemA
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemA() {
		if (jMenuItemA == null) {
			jMenuItemA = new JMenuItem();
			jMenuItemA.setText("Organizar citas autom\u00E1ticamente");
			jMenuItemA.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					organizarCitas();
				}
			});
		}
		return jMenuItemA;
	}

	/**
	 * This method initializes jPanelTablas
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelTablas() {
		if (jPanelTablas == null) {
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.fill = GridBagConstraints.BOTH;
			gridBagConstraints4.gridwidth = 3;
			gridBagConstraints4.gridx = 1;
			gridBagConstraints4.gridy = 5;
			gridBagConstraints4.weightx = 1.0D;
			gridBagConstraints4.weighty = 1.0D;
			gridBagConstraints4.insets = new Insets(5, 5, 5, 5);
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints3.gridx = 1;
			gridBagConstraints3.gridy = 4;
			gridBagConstraints3.gridwidth = 2;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.fill = GridBagConstraints.BOTH;
			gridBagConstraints7.gridheight = 3;
			gridBagConstraints7.gridwidth = 3;
			gridBagConstraints7.gridx = 1;
			gridBagConstraints7.gridy = 1;
			gridBagConstraints7.weightx = 1.0D;
			gridBagConstraints7.weighty = 3.0D;
			gridBagConstraints7.insets = new Insets(5, 5, 5, 5);
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.gridy = 0;
			gridBagConstraints5.gridwidth = 2;
			jPanelTablas = new JPanel();
			jPanelTablas.setLayout(new GridBagLayout());
			jPanelTablas.setPreferredSize(new Dimension(200, 0));
			jPanelTablas.add(jLabel2PC, gridBagConstraints5);
			jPanelTablas.add(getJScrollPane1PC(), gridBagConstraints7);
			jPanelTablas.add(JLabelCS, gridBagConstraints3);
			jPanelTablas.add(getJScrollPane1PCS(), gridBagConstraints4);
		}
		return jPanelTablas;
	}

	/**
	 * This method initializes jMenuItemGuardarComo
	 *
	 * @return javax.swing.JMenuItem
	 *
	private JMenuItem getJMenuItemGuardarComo() {
		if (jMenuItemGuardarComo == null) {
			jMenuItemGuardarComo = new JMenuItem();
			jMenuItemGuardarComo.setText("Guardar como");
			jMenuItemGuardarComo.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					guardarComo();
				}
			});
		}
		return jMenuItemGuardarComo;
	}*/

	/**
	 * This method initializes jMenuImprimir
	 *
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenuImprimir() {
		if (jMenuImprimir == null) {
			jMenuImprimir = new JMenu();
			jMenuImprimir.setText("Imprimir");
			jMenuImprimir.add(this.getJMenuItemImprimir());
			jMenuImprimir.add(this.getJMenuItemImprimirMes());

		}
		return jMenuImprimir;
	}

	/**
	 * This method initializes jMenuItemImprimir
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemImprimir() {
		if (jMenuItemImprimir == null) {
			jMenuItemImprimir = new JMenuItem();
			jMenuItemImprimir.setText("Imprimir da");
			jMenuItemImprimir.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					imprimirDia();
				}
			});
		}
		return jMenuItemImprimir;
	}

	/**
	 * This method initializes jMenuItemImprimir
	 *
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItemImprimirMes() {
		if (jMenuItemImprimirMes == null) {
			jMenuItemImprimirMes = new JMenuItem();
			jMenuItemImprimirMes.setText("Imprimir mes");
			jMenuItemImprimirMes.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					imprimirMes();
				}
			});
		}
		return jMenuItemImprimirMes;
	}

	/**
	 * Launches this application
	 */
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				CitasMEd application = new CitasMEd();
				Control c = new Control(application);
				application.setControl(c);
				application.getJFrame().setVisible(true);
			}
		});
	}

	public void setControl(Control c){
		this.control = c;
	}

	@Override
	public void showError(Throwable e) {
		// TODO Auto-generated method stub
		JOptionPane.showMessageDialog(this.jFrame, e.getMessage(), "Ha ocurrido un pequeo error", JOptionPane.INFORMATION_MESSAGE);
	}

	@Override
	public void refresh() {
		// TODO Auto-generated method stub
		this.updateUI();
	}

	@Override
	public void showMensaje(String m) {
		// TODO Auto-generated method stub
		JOptionPane.showMessageDialog(this.jFrame, m, "Informacin", JOptionPane.INFORMATION_MESSAGE);
	}


	private JSpinner getAoSelector(){
		if(this.aoSelector == null){

			Vector<Integer> list=new Vector<Integer>();
			for(int i = 2000;i<2150;i++){
				list.add(i);
			}
			SpinnerListModel sm = new SpinnerListModel(list);
			sm.setValue(Calendar.getInstance().get(Calendar.YEAR));

			this.aoSelector = new JSpinner(sm);
			this.aoSelector.addChangeListener(new ChangeListener() {
				@Override
				public void stateChanged(ChangeEvent e) {
					// Ponemos el valor del JSpinner en el JTextField
					updateUI();
				}

			});

		}
		return this.aoSelector;
	}


	private JDiasComponent getDias(){
		if(this.dias == null){


			int ao = Integer.parseInt(this.aoSelector.getValue().toString());
			String mes = (String)this.jListMese.getSelectedValue();

			Mes m = this.control.getMes(mes, ao);

			this.dias = new JDiasComponent(m, this, JDiasComponent.NORMALMODE);
		}
		return dias;
	}



	public void updateUI(){

		int ao = (Integer)this.aoSelector.getValue();
		String mes = (String)this.jListMese.getSelectedValue();

		Mes m = this.control.getMes(mes, ao);
		this.dias.updateMes(m);

		int cs = m.getSinAsignarDa().size()+m.getSinAsignarDaEspecial().size();
		this.sinDias.setText(cs+" citas");


		diaSelected(sinDias, "-1");

	}



	private JTextPane selectedDay;
	private JLabel jLabel2PC = null;
	private JScrollPane jScrollPane1PC = null;
	private JTable jTablePC = null;
	private JLabel JLabelCS = null;
	private JScrollPane jScrollPane1PCS = null;
	private JTable jTablePCS = null;
	private JLabel jLabel2 = null;
	private JScrollPane jScrollPaneComments = null;
	private JTextArea jTextAreaComments = null;

	private int daSeleccionado;
	private JMenuItem jMenuItemCM = null;
	private JMenuItem jMenuItemB = null;
	private JMenuItem jMenuItemA = null;
	private JPanel jPanelTablas = null;
	private JMenuItem jMenuItemGuardarComo = null;
	private JMenu jMenuImprimir = null;
	private JMenuItem jMenuItemImprimir = null;  //  @jve:decl-index=0:visual-constraint="250,101"
	private JMenuItem jMenuItemImprimirMes = null;  //  @jve:decl-index=0:visual-constraint="250,101"
	@Override
	public void diaSelected(JTextPane day, String da) {
		// TODO Auto-generated method stub
		if(selectedDay != null){
			selectedDay.setBackground(Color.white);
		}
		selectedDay = day;
		selectedDay.setBackground(Color.lightGray);

		this.daSeleccionado = Integer.parseInt(da);


		this.jTextAreaComments.setText("");

		//Llenar los modelos de las tablas
		int nrows = this.modelPC.getRowCount();
		for(;nrows>0;nrows--){
			this.modelPC.removeRow(nrows-1);
		}

		 nrows = this.modelPCS.getRowCount();
		for(;nrows>0;nrows--){
			this.modelPCS.removeRow(nrows-1);
		}

		Mes m = this.control.getMes((String)this.jListMese.getSelectedValue(), Integer.parseInt(this.aoSelector.getValue().toString()));

		if(this.daSeleccionado == -1){
			for(Cita c:m.getSinAsignarDa().values()){
				Vector<Object> row = new Vector<Object>();
				row.add(c.getNombre());
				row.add(c.getNumeroHistoria());
				this.modelPC.addRow(row);
			}
			for(Cita c:m.getSinAsignarDaEspecial().values()){
				Vector<Object> row = new Vector<Object>();
				row.add(c.getNombre());
				row.add(c.getNumeroHistoria());
				this.modelPCS.addRow(row);
			}
		}else{
			Lista l = m.getListas().get(this.daSeleccionado);
			for(Cita c:l.getAsignados().values()){
				Vector<Object> row = new Vector<Object>();
				row.add(c.getNombre());
				row.add(c.getNumeroHistoria());
				this.modelPC.addRow(row);
			}
			for(Cita c:l.getEspeciales().values()){
				Vector<Object> row = new Vector<Object>();
				row.add(c.getNombre());
				row.add(c.getNumeroHistoria());
				this.modelPCS.addRow(row);
			}
		}


	}


	public void citaSelected(int nh){



		Mes m = this.control.getMes((String)this.jListMese.getSelectedValue(), Integer.parseInt(this.aoSelector.getValue().toString()));
		Cita c = m.buscarCitaPorNH(nh).get(0).getC();
		String comm = c.getComment();

		int pref = c.getPreferencia();
		String pre = "";
		if(pref == Cita.DAIGUAL){
			pre = "Sin preferencias para ser citado.\n";
		}else if(pref == Cita.APRINCIPIOS){
			pre = "Preferencia para ser citado A PRINCIPIOS.\n";
		}else if(pref == Cita.AFINALES){
			pre = "Preferencia para ser citado A FINALES.\n";
		}
		this.jTextAreaComments.setText(pre+"\n"+comm);


	}


	public void crearCita(boolean especial){
		int ao = Integer.parseInt(this.aoSelector.getValue().toString());
		String mes = (String)this.jListMese.getSelectedValue();

		if(daSeleccionado == -1 && especial == true){
			JOptionPane.showMessageDialog(this.jFrame, "Una cita especial no se puede crear sin seleccionar un da concreto. Intente seleccionar un da del calendario que haya consulta.", "Ha ocurrido un pequeo error", JOptionPane.INFORMATION_MESSAGE);
		}else{
			boolean conDia = true;
			if(daSeleccionado == -1){
				conDia = false;
			}
			JDCrearCita cc = new JDCrearCita(this.jFrame, this.control, ao, mes, especial, conDia, daSeleccionado);
			cc.setModal(true);
			cc.setVisible(true);




			Mes m = this.control.getMes(mes, ao);
			this.dias.updateMes(m);

			int cs = m.getSinAsignarDa().size()+m.getSinAsignarDaEspecial().size();
			if(cs == 1){
				this.sinDias.setText(cs+" cita");
			}else{
				this.sinDias.setText(cs+" citas");
			}


			this.diaSelected(this.selectedDay, this.daSeleccionado+"");


		}

	}

	public void crearListas(){
		int ao = Integer.parseInt(this.aoSelector.getValue().toString());
		String mes = (String)this.jListMese.getSelectedValue();
		Mes m = this.control.getMes(mes, ao);

		JDLists lc = new JDLists(this.jFrame, this.control, m);
		lc.setModal(true);
		lc.setVisible(true);


		this.dias.updateMes(m);

		int cs = m.getSinAsignarDa().size()+m.getSinAsignarDaEspecial().size();
		if(cs == 1){
			this.sinDias.setText(cs+" cita");
		}else{
			this.sinDias.setText(cs+" citas");
		}


		this.diaSelected(this.selectedDay, this.daSeleccionado+"");

	}

	public void moverLista(){
		int ao = Integer.parseInt(this.aoSelector.getValue().toString());
		String mes = (String)this.jListMese.getSelectedValue();
		Mes m = this.control.getMes(mes, ao);

		Lista l = m.getListas().get(this.daSeleccionado);

		if(l==null){
			this.showError(new Exception("Ha de seleccionar un da que haya consulta para canbiarlo."));
		}else{

			JDMoverLista lc = new JDMoverLista(this.jFrame, this.control, m, l);
			lc.setModal(true);
			lc.setVisible(true);


			this.dias.updateMes(m);

			int cs = m.getSinAsignarDa().size()+m.getSinAsignarDaEspecial().size();
			if(cs == 1){
				this.sinDias.setText(cs+" cita");
			}else{
				this.sinDias.setText(cs+" citas");
			}


			diaSelected(sinDias, "-1");
		}
	}


	public void cambiarMaxCitas(){
		int ao = Integer.parseInt(this.aoSelector.getValue().toString());
		String mes = (String)this.jListMese.getSelectedValue();
		Mes m = this.control.getMes(mes, ao);

		Lista l = m.getListas().get(this.daSeleccionado);

		if(l==null){
			this.showError(new Exception("Ha de seleccionar un da que haya consulta para canbiarlo."));
		}else{

			JDCambiarMaxLists lc = new JDCambiarMaxLists(this.jFrame, this.control, m, l);
			lc.setModal(true);
			lc.setVisible(true);


			this.dias.updateMes(m);

			int cs = m.getSinAsignarDa().size()+m.getSinAsignarDaEspecial().size();
			if(cs == 1){
				this.sinDias.setText(cs+" cita");
			}else{
				this.sinDias.setText(cs+" citas");
			}


			this.diaSelected(this.selectedDay, this.daSeleccionado+"");
		}
	}

	public void borrarLista(){
		int ao = Integer.parseInt(this.aoSelector.getValue().toString());
		String mes = (String)this.jListMese.getSelectedValue();
		Mes m = this.control.getMes(mes, ao);

		Lista l = m.getListas().get(this.daSeleccionado);

		if(l==null){
			this.showError(new Exception("Ha de seleccionar un da que haya consulta para canbiarlo."));
		}else{

			boolean borrada = this.control.borrarLista(ao, mes, l.getDia());

			if(borrada){
				this.dias.updateMes(m);

				int cs = m.getSinAsignarDa().size()+m.getSinAsignarDaEspecial().size();
				if(cs == 1){
					this.sinDias.setText(cs+" cita");
				}else{
					this.sinDias.setText(cs+" citas");
				}


				diaSelected(sinDias, "-1");

			}
		}
	}

	public void asignarDiaACita(){
		boolean error = false;
		int ao = Integer.parseInt(this.aoSelector.getValue().toString());
		String mes = (String)this.jListMese.getSelectedValue();

		Mes m = control.getMes(mes, ao);

		if(daSeleccionado != -1){
			JOptionPane.showMessageDialog(this.jFrame, "Para asignar un da a una cita sedebe seleccionar una cita sin da asignado.", "Ha ocurrido un pequeo error", JOptionPane.INFORMATION_MESSAGE);
		}else{
			int nh = -1;
			boolean especial;
			int sr = this.jTablePC.getSelectedRow();
			if(sr>=0){
				nh = (Integer)jTablePC.getModel().getValueAt(sr,1);
			}else{
				sr = jTablePCS.getSelectedRow();
				if(sr>=0){
					nh = (Integer)jTablePCS.getModel().getValueAt(sr,1);
				}else{
					error = true;
					this.showError(new Exception("No hay ninguna cita seleccionada. Por favor, seleccione una cita de las tablas con los nmeros de historia"));
					
				}
			}

			if(!error){
				Cita c = m.buscarCitaPorNH(nh).get(0).getC();

				JDAsignarDia cc = new JDAsignarDia(this.jFrame, this.control,m,c );
				cc.setModal(true);
				cc.setVisible(true);


				this.dias.updateMes(m);

				int cs = m.getSinAsignarDa().size()+m.getSinAsignarDaEspecial().size();
				if(cs == 1){
					this.sinDias.setText(cs+" cita");
				}else{
					this.sinDias.setText(cs+" citas");
				}


				this.diaSelected(this.selectedDay, this.daSeleccionado+"");
			}
			


		}
	}

	public void organizarCitas(){
		int ao = Integer.parseInt(this.aoSelector.getValue().toString());
		String mes = (String)this.jListMese.getSelectedValue();





		boolean organizado = this.control.oganizarAsignados(ao, mes);

		if(organizado){
			Mes m = this.control.getMes(mes, ao);

			this.dias.updateMes(m);

			int cs = m.getSinAsignarDa().size()+m.getSinAsignarDaEspecial().size();
			if(cs == 1){
				this.sinDias.setText(cs+" cita");
			}else{
				this.sinDias.setText(cs+" citas");
			}


			this.diaSelected(this.selectedDay, this.daSeleccionado+"");


		}
	}

	public void borrarCita(){
		int ao = Integer.parseInt(this.aoSelector.getValue().toString());
		String mes = (String)this.jListMese.getSelectedValue();

		Mes m = control.getMes(mes, ao);


		boolean especial = true;
		boolean error = false;
		int nh = -1;
		int sr = this.jTablePC.getSelectedRow();
		if(sr>=0){
			nh = (Integer)jTablePC.getModel().getValueAt(sr,1);
			especial = false;
		}else{
			sr = jTablePCS.getSelectedRow();
			if(sr>=0){
				nh = (Integer)jTablePCS.getModel().getValueAt(sr,1);
				especial = true;
			}else{
				this.showError(new Exception("No hay ninguna cita seleccionada. Por favor, seleccione una cita de las tablas con los nmeros de historia"));
				error = true;
			}
		}

		if(!error){



			boolean borrada = this.control.borrarCita(mes, ao, nh, especial,this.daSeleccionado);

			if(borrada){

				this.dias.updateMes(m);

				int cs = m.getSinAsignarDa().size()+m.getSinAsignarDaEspecial().size();
				if(cs == 1){
					this.sinDias.setText(cs+" cita");
				}else{
					this.sinDias.setText(cs+" citas");
				}


				this.diaSelected(this.selectedDay, this.daSeleccionado+"");

			}
		}


	}


	public void buscarCitas(){

		JDBuscarCitas bc = new JDBuscarCitas(this.jFrame, this.control);
		bc.setModal(true);
		bc.setVisible(true);


		int ao = Integer.parseInt(this.aoSelector.getValue().toString());
		String mes = (String)this.jListMese.getSelectedValue();

		Mes m = control.getMes(mes, ao);





		this.dias.updateMes(m);

		int cs = m.getSinAsignarDa().size()+m.getSinAsignarDaEspecial().size();
		if(cs == 1){
			this.sinDias.setText(cs+" cita");
		}else{
			this.sinDias.setText(cs+" citas");
		}


		this.diaSelected(this.selectedDay, this.daSeleccionado+"");



	}

	public void preferencias(){
		JDConfiguration jdc = new JDConfiguration(this.jFrame, this.control);
		jdc.setModal(true);
		jdc.setVisible(true);
	}




	public void nuevaDataBase(){
		JFileChooser fc = new JFileChooser();
		fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Archivos de tipo CitasMed", "citasMed");
		fc.setFileFilter(filter);
		int seleccion = fc.showSaveDialog(this.jFrame);
		if(seleccion == JFileChooser.APPROVE_OPTION){
			File fichero = fc.getSelectedFile();
			if(!fichero.getAbsolutePath().endsWith(".citasMed")){
				fichero = new File(fichero.getAbsolutePath()+".citasMed");
			}
			try {
				control.nuevaDataBase(fichero);
			} catch (Exception e) {

			}
		}
	}


	/*public void guardarComo(){
		JFileChooser fc = new JFileChooser();
		fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Archivos de tipo CitasMed", "citasMed");
		fc.setFileFilter(filter);
		int seleccion = fc.showSaveDialog(this.jFrame);
		if(seleccion == JFileChooser.APPROVE_OPTION){
			File fichero = fc.getSelectedFile();
			if(!fichero.getAbsolutePath().endsWith(".citasMed")){
				fichero = new File(fichero.getAbsolutePath()+".citasMed");
			}
			try {
				control.guardarComo(fichero);
			} catch (Exception e) {

			}
		}
	}*/

	public void cambiarDataBase(){
		JFileChooser fc = new JFileChooser();
		fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Archivos de tipo CitasMed", "citasMed");
		fc.setFileFilter(filter);
		int seleccion = fc.showOpenDialog(this.jFrame);

		if(seleccion == JFileChooser.APPROVE_OPTION){
			File fichero = fc.getSelectedFile();
			try {
				control.cambiarDataBase(fichero);
				cambiarNombreDataBase();
			} catch (Exception e) {

			}
		}
	}

	public void cerrarApp(){
		try {
			this.control.guardarDataBase();
			this.control.cerrarApplicacion();
			System.exit(0);
		} catch (IOException e) {
			int op = JOptionPane.showOptionDialog(this.jFrame, "La base de datos no se ha podido guardar correctamente antes de cerrar.\nDesea cerrar la apliacin sin guardar los cambios no guardados?", "Ha ocurrido un pequeo error al guardar la base de datos", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, new Object[] { "Si", "No"}, null);
			if(op == JOptionPane.YES_OPTION){
				System.exit(0);
			}
		}

	}

	/*public void guardar(){
		try {
			this.control.guardarDataBase();
		} catch (IOException e) {

		}
	}*/

	public void imprimirMes(){
		int ao = Integer.parseInt(this.aoSelector.getValue().toString());
		String mes = (String)this.jListMese.getSelectedValue();

		JDPrint jdp = new JDPrint(this.jFrame, this.control, mes, ao);
		jdp.setModal(true);
		jdp.setVisible(true);
	}

	public void imprimirDia(){
		int ao = Integer.parseInt(this.aoSelector.getValue().toString());
		String mes = (String)this.jListMese.getSelectedValue();

		Mes m = this.control.getMes(mes, ao);

		Lista l = m.getListas().get(this.daSeleccionado);

		if(l==null){
			this.showError(new Exception("Ha de seleccionar un da que haya consulta para imprimirlo."));
		}else{

			JDPrint jdp = new JDPrint(this.jFrame, this.control, mes, ao, l);
			jdp.setModal(true);
			jdp.setVisible(true);
		}
	}

	private void cambiarNombreDataBase(){
		String dataBase = this.control.getPathDBCitas();
		dataBase = dataBase.replace("\\", "/");
		String [] dataBaseName = dataBase.split("/");
		String name = dataBaseName[dataBaseName.length-1];
		jFrame.setTitle("CitasMed - base de datos de citas: "+name);

	}
}
