package presentacion;

import javax.swing.JPanel;
import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.Window;

import javax.swing.JDialog;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.Dimension;
import java.util.Calendar;
import java.util.Vector;

import javax.swing.JOptionPane;
import javax.swing.JToggleButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;

import dominio.Cita;
import dominio.Control;
import dominio.Mes;
import dominio.ResultadoBusqueda;

public class JDBuscarCitas extends JDialog {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jLabelBPN = null;
	private JTextField jTextFieldN = null;
	private JLabel jLabelN = null;
	private JButton jButtonBPN = null;
	private JLabel jLabelBCNH = null;
	private JLabel jLabelNH = null;
	private JTextField jTextFieldBNH = null;
	private JButton jButtonBNH = null;
	private JLabel jLabelRB = null;
	private JScrollPane jScrollPaneRB = null;
	private JTable jTableRB = null;
	private JLabel jLabelO = null;
	private JScrollPane jScrollPaneTA = null;
	private JTextArea jTextAreaO = null;
	private JButton jButton = null;
	private JButton jButtonCerrar = null;


	private Control control;
	private DefaultTableModel modelPC;


	/**
	 * @param owner
	 */
	public JDBuscarCitas(Window owner, Control c) {
		super(owner);
		control = c;
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
		this.setSize(600, 600);
		this.setTitle("Buscar citas");
		this.setContentPane(getJContentPane());
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				cerrar();
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.gridx = 3;
			gridBagConstraints17.anchor = GridBagConstraints.EAST;
			gridBagConstraints17.gridy = 7;
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.gridx = 0;
			gridBagConstraints16.gridwidth = 2;
			gridBagConstraints16.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints16.anchor = GridBagConstraints.WEST;
			gridBagConstraints16.gridy = 7;
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.fill = GridBagConstraints.BOTH;
			gridBagConstraints15.gridy = 6;
			gridBagConstraints15.weightx = 1.0;
			gridBagConstraints15.weighty = 1.0;
			gridBagConstraints15.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints15.gridwidth = 4;
			gridBagConstraints15.gridx = 0;
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.gridx = 0;
			gridBagConstraints14.gridwidth = 2;
			gridBagConstraints14.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints14.anchor = GridBagConstraints.WEST;
			gridBagConstraints14.gridy = 5;
			jLabelO = new JLabel();
			jLabelO.setText("Observaciones");
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.fill = GridBagConstraints.BOTH;
			gridBagConstraints13.gridy = 4;
			gridBagConstraints13.weightx = 1.0;
			gridBagConstraints13.weighty = 2.0D;
			gridBagConstraints13.gridwidth = 4;
			gridBagConstraints13.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints13.gridx = 0;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 0;
			gridBagConstraints12.insets = new Insets(20, 5, 5, 5);
			gridBagConstraints12.gridwidth = 3;
			gridBagConstraints12.anchor = GridBagConstraints.WEST;
			gridBagConstraints12.gridy = 3;
			jLabelRB = new JLabel();
			jLabelRB.setText("Resultados de la bsqueda:");
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 3;
			gridBagConstraints7.gridy = 2;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints6.gridy = 1;
			gridBagConstraints6.weightx = 1.0;
			gridBagConstraints6.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints6.gridx = 3;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 2;
			gridBagConstraints5.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints5.anchor = GridBagConstraints.EAST;
			gridBagConstraints5.gridy = 1;
			jLabelNH = new JLabel();
			jLabelNH.setText("Nmero de historia:");
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 2;
			gridBagConstraints4.gridwidth = 2;
			gridBagConstraints4.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints4.gridy = 0;
			jLabelBCNH = new JLabel();
			jLabelBCNH.setText("Buscar citas por nmero de historia");
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 1;
			gridBagConstraints3.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints3.gridy = 2;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints2.anchor = GridBagConstraints.EAST;
			gridBagConstraints2.gridy = 1;
			jLabelN = new JLabel();
			jLabelN.setText("Nombre: ");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints1.gridx = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints.gridwidth = 2;
			gridBagConstraints.gridy = 0;
			jLabelBPN = new JLabel();
			jLabelBPN.setText("Buscar citas por nombre");
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.setPreferredSize(new Dimension(800, 200));
			jContentPane.add(jLabelBPN, gridBagConstraints);
			jContentPane.add(getJTextFieldN(), gridBagConstraints1);
			jContentPane.add(jLabelN, gridBagConstraints2);
			jContentPane.add(getJButtonBPN(), gridBagConstraints3);
			jContentPane.add(jLabelBCNH, gridBagConstraints4);
			jContentPane.add(jLabelNH, gridBagConstraints5);
			jContentPane.add(getJTextFieldBNH(), gridBagConstraints6);
			jContentPane.add(getJButtonBNH(), gridBagConstraints7);
			jContentPane.add(jLabelRB, gridBagConstraints12);
			jContentPane.add(getJScrollPaneRB(), gridBagConstraints13);
			jContentPane.add(jLabelO, gridBagConstraints14);
			jContentPane.add(getJScrollPaneTA(), gridBagConstraints15);
			jContentPane.add(getJButton(), gridBagConstraints16);
			jContentPane.add(getJButtonCerrar(), gridBagConstraints17);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jTextFieldN
	 *
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextFieldN() {
		if (jTextFieldN == null) {
			jTextFieldN = new JTextField();
			jTextFieldN.setName("fieldN");
		}
		return jTextFieldN;
	}

	/**
	 * This method initializes jButtonBPN
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonBPN() {
		if (jButtonBPN == null) {
			jButtonBPN = new JButton();
			jButtonBPN.setText("Buscar por nombre");
			jButtonBPN.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					buscarPorNombre();
				}
			});
		}
		return jButtonBPN;
	}

	/**
	 * This method initializes jTextFieldBNH
	 *
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextFieldBNH() {
		if (jTextFieldBNH == null) {
			jTextFieldBNH = new JTextField();
			jTextFieldBNH.setName("fieldNH");
		}
		return jTextFieldBNH;
	}

	/**
	 * This method initializes jButtonBNH
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonBNH() {
		if (jButtonBNH == null) {
			jButtonBNH = new JButton();
			jButtonBNH.setText("Buscar por n\u00FAmero de historia");
			jButtonBNH.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					buscarPorNH();
				}
			});
		}
		return jButtonBNH;
	}

	/**
	 * This method initializes jScrollPaneRB
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPaneRB() {
		if (jScrollPaneRB == null) {
			jScrollPaneRB = new JScrollPane();
			jScrollPaneRB.setViewportView(getJTableRB());
		}
		return jScrollPaneRB;
	}

	/**
	 * This method initializes jTableRB
	 *
	 * @return javax.swing.JTable
	 */
	private JTable getJTableRB() {
		if (jTableRB == null) {

			String  [] colums = new String [4];
			colums[0] = "Fecha";
			colums[1] = "Nombre";
			colums[2] = "Nmero de Historia";
			colums[3] = "Tipo de cita";

			modelPC = new DefaultTableModel(colums, 0);


			jTableRB = new JTable(modelPC);

			jTableRB.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			jTableRB.setAutoCreateRowSorter(true);

			jTableRB.getSelectionModel().addListSelectionListener(
			        new ListSelectionListener() {
			            public void valueChanged(ListSelectionEvent event) {

			            	int viewRow = jTableRB.getSelectedRow();
			            	 if (viewRow >= 0){

			            		 int modelRow =jTableRB.convertRowIndexToModel(viewRow);
			                    citaSelected((Integer)jTableRB.getModel().getValueAt(modelRow, 2));
			                }
			            }
			        }
			);
		}
		return jTableRB;
	}

	/**
	 * This method initializes jScrollPaneTA
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPaneTA() {
		if (jScrollPaneTA == null) {
			jScrollPaneTA = new JScrollPane();
			jScrollPaneTA.setViewportView(getJTextAreaO());
		}
		return jScrollPaneTA;
	}

	/**
	 * This method initializes jTextAreaO
	 *
	 * @return javax.swing.JTextArea
	 */
	private JTextArea getJTextAreaO() {
		if (jTextAreaO == null) {
			jTextAreaO = new JTextArea();
			jTextAreaO.setName("fieldO");
		}
		return jTextAreaO;
	}

	/**
	 * This method initializes jButton
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Borrar cita seleccionada");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					borrarCita();
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jButtonCerrar
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonCerrar() {
		if (jButtonCerrar == null) {
			jButtonCerrar = new JButton();
			jButtonCerrar.setText("Cerrar");
			jButtonCerrar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					cerrar();
				}
			});
		}
		return jButtonCerrar;
	}

	public void cerrar(){
		this.dispose();
	}

	public void buscarPorNombre(){
		String nombre = this.jTextFieldN.getText();
		Vector<ResultadoBusqueda> rbus = this.control.buscarCitasPorNombre(nombre);
		this.actualizarBusqueda(rbus);
	}

	public void buscarPorNH(){
		try{
			int nh = Integer.parseInt(this.jTextFieldBNH.getText());
			Vector<ResultadoBusqueda> rbus = this.control.buscarCitasPorNH(nh);
			this.actualizarBusqueda(rbus);
		}catch(Exception e){
			JOptionPane.showMessageDialog(this, "El nmero de historia no es un nmero vlido. Intente escribir un nmero lido", "Ha ocurrido un pequeo error.", JOptionPane.INFORMATION_MESSAGE);
		}
	}


	public void actualizarBusqueda(Vector<ResultadoBusqueda> rb){

		int nrows = this.modelPC.getRowCount();
		for(;nrows>0;nrows--){
			this.modelPC.removeRow(nrows-1);
		}

		for(ResultadoBusqueda r:rb){

			String fecha = "";
			if(r.getL()==null){
				fecha="Sin da_";
			}else{
				fecha = r.getL().getDia()+"_";
			}
			fecha+=r.getM().getMes()+"_"+r.getM().getAo();

			Object [] row = new Object[4];
			row[0] = fecha;
			row[1] = r.getC().getNombre();
			row[2] = r.getC().getNumeroHistoria();
			if(r.isEspecial()){
				row[3] = "especial";
			}else{
				row[3] = "normal";
			}

			this.modelPC.addRow(row);
		}
	}


	public void borrarCita(){
		int r = this.jTableRB.getSelectedRow();
		int nh = (Integer)this.modelPC.getValueAt(r, 2);
		String fecha = (String) this.modelPC.getValueAt(r, 0);

		String [] partes = fecha.split("_");
		int ao = Integer.parseInt(partes[2]);
		String mes = partes[1];

		String es = (String) this.modelPC.getValueAt(r, 3);
		boolean especial = false;
		if(es.equals("especial")){
			especial=true;
		}

		int dia = 0;
		if(partes[0].equals("Sin da")){
			dia = -1;
		}else{
			dia = Integer.parseInt(partes[0]);
		}

		boolean borrada = this.control.borrarCita(mes, ao, nh, especial,dia);
		if(borrada){
			this.modelPC.removeRow(r);
		}
	}

	public void citaSelected(int nh){

		Cita c = this.control.buscarCitasPorNH(nh).get(0).getC();


		String comm = c.getComment();

		int pref = c.getPreferencia();
		String pre = "";
		if(pref == Cita.DAIGUAL){
			pre = "Sin preferencias para ser citado.\n";
		}else if(pref == Cita.APRINCIPIOS){
			pre = "Preferencia para ser citado A PRINCIPIOS.\n";
		}else if(pref == Cita.AFINALES){
			pre = "Preferencia para ser citado A FINALES.\n";
		}
		this.jTextAreaO.setText(pre+"\n"+comm);


	}
}
