package presentacion;

import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextPane;
import javax.swing.SpinnerNumberModel;

import java.awt.Color;
import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.Window;

import javax.swing.JDialog;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JButton;

import dominio.Control;
import dominio.Lista;
import dominio.Mes;

import java.awt.Dimension;
import java.util.Vector;

public class JDCambiarMaxLists extends JDialog{

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jLabelMax = null;
	private JLabel jLabelTitulo = null;
	private JLabel jLabelD = null;

	private JSpinner jpDias = null;
	private JButton jButtonOk = null;
	private JButton jButtonCancel = null;



	private Control c;
	private Mes m;
	private Lista l;

	/**
	 * @param owner
	 */
	public JDCambiarMaxLists(Window owner,Control c, Mes m, Lista l ) {
		super(owner);
		this.c = c;
		this.m = m;
		this.l = l;
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
		this.setSize(500, 200);
		this.setTitle("Cambiar el mximo nmero de citas");
		this.setContentPane(getJContentPane());
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				cerrar();
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.gridx = 1;
			gridBagConstraints8.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints8.anchor = GridBagConstraints.WEST;
			gridBagConstraints8.gridy = 4;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 0;
			gridBagConstraints7.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints7.anchor = GridBagConstraints.EAST;
			gridBagConstraints7.gridy = 4;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridwidth = 2;
			gridBagConstraints2.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints2.gridy = 2;

			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridwidth = 2;
			gridBagConstraints1.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints1.gridy = 0;
			jLabelTitulo = new JLabel();
			jLabelTitulo.setText("Cambiar el nmero mximo de citas para el "+this.l.getDia()+" de "+this.m.getMes()+" de "+m.getAo());
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.anchor = GridBagConstraints.EAST;
			gridBagConstraints.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints.gridy = 1;
			jLabelMax = new JLabel();
			jLabelMax.setText("Nmero de citas mximo para la lista: ");
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(jLabelMax, gridBagConstraints);
			jContentPane.add(jLabelTitulo, gridBagConstraints1);
			GridBagConstraints gridBagConstraintsS = new GridBagConstraints();
			gridBagConstraintsS.gridx = 1;
			gridBagConstraintsS.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraintsS.insets = new Insets(5, 5, 5, 5);
			gridBagConstraintsS.gridy = 1;
			jContentPane.add(getJsDias(), gridBagConstraintsS);
			jContentPane.add(getJButtonOk(), gridBagConstraints7);
			jContentPane.add(getJButtonCancel(), gridBagConstraints8);



		}
		return jContentPane;
	}

	private JSpinner getJsDias(){
		if(this.jpDias == null){
			SpinnerNumberModel sm = new SpinnerNumberModel(this.l.getCantidadMaxima(), 1, Integer.MAX_VALUE, 1);
			this.jpDias = new JSpinner(sm);
		}
		return this.jpDias;
	}

	/**
	 * This method initializes jButtonOk
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonOk() {
		if (jButtonOk == null) {
			jButtonOk = new JButton();
			jButtonOk.setText("Aceptar");
			jButtonOk.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					okAction();
				}
			});
		}
		return jButtonOk;
	}

	/**
	 * This method initializes jButtonCancel
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonCancel() {
		if (jButtonCancel == null) {
			jButtonCancel = new JButton();
			jButtonCancel.setText("Cancel");
			jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					cerrar();
				}
			});
		}
		return jButtonCancel;
	}




	public void okAction(){



		boolean cerrar = this.c.cambiarMaxLista(this.m.getAo(), this.m.getMes(), l.getDia(), (Integer)this.jpDias.getValue());

		if(cerrar){
			this.cerrar();
		}
	}

	public void cerrar(){
		this.dispose();
	}
}


