package presentacion;

import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextPane;

import java.awt.Color;
import java.awt.Frame;
import java.awt.BorderLayout;
import java.awt.Window;

import javax.swing.JDialog;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JButton;

import dominio.Control;
import dominio.Lista;
import dominio.Mes;

public class JDMoverLista extends JDialog implements IContenedorDias{

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jLabelS = null;
	private JButton jButtonOk = null;
	private JButton jButtonC = null;


	private Control c;
	private Mes m;
	private Lista l;

	private JDiasComponent dias;

	/**
	 * @param owner
	 */
	public JDMoverLista(Window owner, Control c, Mes m, Lista l) {
		super(owner);
		this.c = c;
		this.m=m;
		this.l=l;
		initialize();

		JTextPane p = this.dias.getPanel(this.l.getDia());
		p.setBackground(Color.cyan);
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
		this.setSize(800, 640);
		this.setTitle("Seleccionar el nuevo da");
		this.setContentPane(getJContentPane());
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				cerrar();
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.gridx = 1;
			gridBagConstraints10.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints10.anchor = GridBagConstraints.WEST;
			gridBagConstraints10.gridy = 2;
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.gridx = 0;
			gridBagConstraints9.anchor = GridBagConstraints.EAST;
			gridBagConstraints9.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints9.gridy = 2;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints.gridwidth = 2;
			gridBagConstraints.gridy = 0;
			jLabelS = new JLabel();
			jLabelS.setText("Selecciona el nuevo da");
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(jLabelS, gridBagConstraints);
			jContentPane.add(getJButtonOk(), gridBagConstraints9);
			jContentPane.add(getJButtonC(), gridBagConstraints10);

			GridBagConstraints gridBagConstraintsD = new GridBagConstraints();
			gridBagConstraintsD.gridx = 0;
			gridBagConstraintsD.insets = new Insets(5, 5, 5, 5);
			gridBagConstraintsD.gridwidth = 2;
			gridBagConstraintsD.gridy = 1;
			jContentPane.add(this.getDias(),gridBagConstraintsD);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jButtonOk
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonOk() {
		if (jButtonOk == null) {
			jButtonOk = new JButton();
			jButtonOk.setText("Aceptar");
			jButtonOk.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					okAction();
				}
			});
		}
		return jButtonOk;
	}

	/**
	 * This method initializes jButtonC
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonC() {
		if (jButtonC == null) {
			jButtonC = new JButton();
			jButtonC.setText("Cancelar");
			jButtonC.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					cerrar();
				}
			});
		}
		return jButtonC;
	}


	private JDiasComponent getDias(){
		if(this.dias == null){
			dias = new JDiasComponent(m, this, JDiasComponent.MOVERLISTAMODE);
		}
		return dias;
	}

	public void okAction(){

		boolean cerrar = this.c.cambiarListaDeDa(m.getAo(), m.getMes(), l.getDia(), this.dia);

		if(cerrar){
			cerrar();
		}
	}

	public void cerrar(){
		this.dispose();
	}


	private JTextPane selectedDay;
	private int dia;
	@Override
	public void diaSelected(JTextPane day, String da) {
		// TODO Auto-generated method stub
		if(selectedDay != null){
			selectedDay.setBackground(Color.white);
		}

		selectedDay = day;
		selectedDay.setBackground(Color.lightGray);
		dia = Integer.parseInt(da);
	}

	public int getSelectedDay(){
		return this.dia;
	}

}
