package presentacion;

import javax.swing.JPanel;
import java.awt.Frame;
import java.awt.BorderLayout;
import javax.swing.JDialog;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Dimension;
import java.awt.Window;
import java.awt.print.PageFormat;
import java.awt.print.Paper;
import java.awt.print.PrinterJob;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.JCheckBox;
import javax.swing.JButton;

import com.jrefinery.report.util.PageFormatFactory;

import dominio.Control;
import dominio.Lista;

public class JDPrint extends JDialog {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jLabel = null;
	private JRadioButton jRadioButtonCN = null;
	private JRadioButton jRadioButtonCE = null;
	private JRadioButton jRadioButtonTodas = null;
	private JCheckBox jCheckBox = null;
	private JButton jButtonOK = null;
	private JButton jButtonCancel = null;


	private Control c;
	private String mes;
	private int ao;

	private PageFormat pf;  //  @jve:decl-index=0:
	private JButton jButtonCP = null;

	private Lista lista = null;

	public JDPrint(Window owner, Control c, String m, int a, Lista l) {

		super(owner);
		this.lista = l;
		this.c = c;
		this.mes = m;
		this.ao= a;
		//this.pf = new PageFormat();
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		this.pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);



		initialize();

		ButtonGroup bg = new ButtonGroup();
		bg.add(this.jRadioButtonCN);
		bg.add(this.jRadioButtonCE);
		bg.add(this.jRadioButtonTodas);

	}

	/**
	 * @param owner
	 */
	public JDPrint(Window owner, Control c, String m, int a) {
		super(owner);
		this.c = c;
		this.mes = m;
		this.ao= a;
		//this.pf = new PageFormat();
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		this.pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);



		initialize();

		ButtonGroup bg = new ButtonGroup();
		bg.add(this.jRadioButtonCN);
		bg.add(this.jRadioButtonCE);
		bg.add(this.jRadioButtonTodas);

	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
		this.setSize(485, 300);
		this.setTitle("Opciones de impresin");
		this.setContentPane(getJContentPane());
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				cerrar();
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 2;
			gridBagConstraints12.anchor = GridBagConstraints.EAST;
			gridBagConstraints12.insets = new Insets(5, 30, 5, 5);
			gridBagConstraints12.gridy = 4;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 1;
			gridBagConstraints7.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints7.anchor = GridBagConstraints.WEST;
			gridBagConstraints7.gridy = 4;
			GridBagConstraints gridBagConstraints61 = new GridBagConstraints();
			gridBagConstraints61.gridx = 0;
			gridBagConstraints61.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints61.anchor = GridBagConstraints.EAST;
			gridBagConstraints61.gridy = 4;
			GridBagConstraints gridBagConstraints51 = new GridBagConstraints();
			gridBagConstraints51.gridx = 0;
			gridBagConstraints51.gridwidth = 3;
			gridBagConstraints51.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints51.gridy = 3;
			GridBagConstraints gridBagConstraints41 = new GridBagConstraints();
			gridBagConstraints41.gridx = 1;
			gridBagConstraints41.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints41.anchor = GridBagConstraints.WEST;
			gridBagConstraints41.gridwidth = 2;
			gridBagConstraints41.gridy = 2;
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.gridx = 1;
			gridBagConstraints31.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints31.anchor = GridBagConstraints.WEST;
			gridBagConstraints31.gridwidth = 2;
			gridBagConstraints31.gridy = 1;
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.gridx = 1;
			gridBagConstraints21.anchor = GridBagConstraints.WEST;
			gridBagConstraints21.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints21.gridwidth = 2;
			gridBagConstraints21.gridy = 0;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints11.anchor = GridBagConstraints.EAST;
			gridBagConstraints11.gridy = 0;
			jLabel = new JLabel();
			jLabel.setText("Citas que se imprimirn:");
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.anchor = GridBagConstraints.WEST;
			gridBagConstraints6.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints6.gridy = 4;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints5.anchor = GridBagConstraints.EAST;
			gridBagConstraints5.gridy = 4;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints4.gridwidth = 2;
			gridBagConstraints4.gridy = 3;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 1;
			gridBagConstraints3.anchor = GridBagConstraints.WEST;
			gridBagConstraints3.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints3.gridy = 2;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 1;
			gridBagConstraints2.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints2.anchor = GridBagConstraints.WEST;
			gridBagConstraints2.gridy = 1;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 1;
			gridBagConstraints1.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints1.anchor = GridBagConstraints.WEST;
			gridBagConstraints1.gridy = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints.gridy = 0;
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(jLabel, gridBagConstraints11);
			jContentPane.add(getJRadioButtonCN(), gridBagConstraints21);
			jContentPane.add(getJRadioButtonCE(), gridBagConstraints31);
			jContentPane.add(getJRadioButtonTodas(), gridBagConstraints41);
			jContentPane.add(getJCheckBox(), gridBagConstraints51);
			jContentPane.add(getJButtonOK(), gridBagConstraints61);
			jContentPane.add(getJButtonCancel(), gridBagConstraints7);
			jContentPane.add(getJButtonCP(), gridBagConstraints12);
		}
		return jContentPane;
	}

	public void okAction(){

		int s=0;
		if(this.jRadioButtonCN.isSelected()){
			s = Control.CITAS_NORMALES;
		}else if(this.jRadioButtonCE.isSelected()){
			s = Control.CITAS_ESPECIALES;
		}else if(this.jRadioButtonTodas.isSelected()){
			s = Control.CITAS_TODAS;
		}

		if(this.lista==null){
			this.c.imprimirMes(mes, ao, s, this.jCheckBox.isSelected(), this.pf);
		}else{
			this.c.imprimirDia(mes, ao, s, this.jCheckBox.isSelected(), this.pf, this.lista);

		}


		this.cerrar();
	}

	public void cerrar(){
		this.dispose();
	}

	/**
	 * This method initializes jRadioButtonCN
	 *
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonCN() {
		if (jRadioButtonCN == null) {
			jRadioButtonCN = new JRadioButton();
			jRadioButtonCN.setText("Citas normales");
			jRadioButtonCN.setSelected(true);
		}
		return jRadioButtonCN;
	}

	/**
	 * This method initializes jRadioButtonCE
	 *
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonCE() {
		if (jRadioButtonCE == null) {
			jRadioButtonCE = new JRadioButton();
			jRadioButtonCE.setText("Citas especiales");
		}
		return jRadioButtonCE;
	}

	/**
	 * This method initializes jRadioButtonTodas
	 *
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButtonTodas() {
		if (jRadioButtonTodas == null) {
			jRadioButtonTodas = new JRadioButton();
			jRadioButtonTodas.setText("Citas normales y especiales");
		}
		return jRadioButtonTodas;
	}

	/**
	 * This method initializes jCheckBox
	 *
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText("Imprimir comentarios");
		}
		return jCheckBox;
	}

	/**
	 * This method initializes jButtonOK
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonOK() {
		if (jButtonOK == null) {
			jButtonOK = new JButton();
			jButtonOK.setText("Imprimir");
			jButtonOK.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					okAction();
				}
			});
		}
		return jButtonOK;
	}

	/**
	 * This method initializes jButtonCancel
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonCancel() {
		if (jButtonCancel == null) {
			jButtonCancel = new JButton();
			jButtonCancel.setText("Cancel");
			jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					cerrar();
				}
			});
		}
		return jButtonCancel;
	}

	/**
	 * This method initializes jButtonCP
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonCP() {
		if (jButtonCP == null) {
			jButtonCP = new JButton();
			jButtonCP.setText("Configurar pgina");
			jButtonCP.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					configurarPagina();
				}
			});
		}
		return jButtonCP;
	}

	public void configurarPagina(){
		PrinterJob printerjob = PrinterJob.getPrinterJob();
		this.pf = printerjob.pageDialog(new PageFormat());
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
