package presentacion;

import java.awt.GridBagLayout;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextPane;

import dominio.Lista;
import dominio.Mes;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import java.awt.Insets;
import java.util.Calendar;

public class JDiasComponent extends JPanel {

	private static final long serialVersionUID = 1L;

	public static final int NORMALMODE = 1;
	public static final int CREARLISTASMODE = 2;
	public static final int MOVERLISTAMODE = 3;
	public static final int MOVERCITAMODE = 4;


	private JTextPane[][] paneles;


	private IContenedorDias cd;

	private Mes mes;

	private int mode;
	/**
	 * This is the default constructor
	 */
	public JDiasComponent(Mes mes, IContenedorDias cd, int mode) {
		super();
		this.cd = cd;
		this.mes = mes;
		this.mode = mode;
		paneles = new JTextPane [7][];
		for(int i = 0 ; i<7;i++){
			paneles[i] = new JTextPane[6];
			for(int j = 0;j<6;j++){
				paneles[i][j] = this.createTestPane(i+""+j);
			}
		}


		this.updateMes(mes);

		/*Calendar c = Calendar.getInstance();

		int m = 0;
		String mesN = this.mes.getMes();
		if(mesN.equals("Enero")){
			m = 0;
		}else if(mesN.equals("Febrero")){
			m = 1;
		}else if(mesN.equals("Marzo")){
			m = 2;
		}else if(mesN.equals("Abril")){
			m = 3;
		}else if(mesN.equals("Mayo")){
			m = 4;
		}else if(mesN.equals("Junio")){
			m = 5;
		}else if(mesN.equals("Julio")){
			m = 6;
		}else if(mesN.equals("Agosto")){
			m = 7;
		}else if(mesN.equals("Septiembre")){
			m = 8;
		}else if(mesN.equals("Octubre")){
			m = 9;
		}else if(mesN.equals("Noviembre")){
			m = 10;
		}else if(mesN.equals("Diciembre")){
			m = 11;
		}

		c.set(mes.getAo(), m, 0);
		int weekDay = c.get(Calendar.DAY_OF_WEEK);

		int start = 0;

		if(weekDay == Calendar.MONDAY){
			start = 0;
		}else if(weekDay == Calendar.TUESDAY){
			start = 1;
		}else if(weekDay == Calendar.WEDNESDAY){
			start = 2;
		}else if(weekDay == Calendar.THURSDAY){
			start = 3;
		}else if(weekDay == Calendar.FRIDAY){
			start = 4;
		}else if(weekDay == Calendar.SATURDAY){
			start = 5;
		}else if(weekDay == Calendar.SUNDAY){
			start = 6;
		}

		int days = c.getMaximum(Calendar.DAY_OF_MONTH);

		for(int i = 0; i<days;i++){
			int posX = (i+start)%7;
			int posY = (i+start)/7;


			String text ="";
			if(i+start>8){
				text = (i+1)+"_______\n\n  ";
			}else{
				text = (i+1)+"________\n\n  ";
			}

			paneles[posX][posY].setText(text);
			paneles[posX][posY].setEnabled(true);

		}*/



		initialize();
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {

		this.setSize(490, 380);
		this.setLayout(new GridBagLayout());




		GridBagConstraints gbcL = new GridBagConstraints();
		gbcL.fill = GridBagConstraints.HORIZONTAL;
		gbcL.gridy = 0;
		gbcL.gridx = 1;
		this.add(new JLabel("Lunes"),gbcL );
		GridBagConstraints gbcM = new GridBagConstraints();
		gbcM.fill = GridBagConstraints.HORIZONTAL;
		gbcM.gridy = 0;
		gbcM.gridx = 2;
		this.add(new JLabel("Martes"), gbcM);

		GridBagConstraints gbcX = new GridBagConstraints();
		gbcX.fill = GridBagConstraints.HORIZONTAL;
		gbcX.gridy = 0;
		gbcX.gridx = 3;
		this.add(new JLabel("Miercoles"), gbcX);

		GridBagConstraints gbcJ = new GridBagConstraints();
		gbcJ.fill = GridBagConstraints.HORIZONTAL;
		gbcJ.gridy = 0;
		gbcJ.gridx = 4;
		this.add(new JLabel("Jueves"), gbcJ);

		GridBagConstraints gbcV = new GridBagConstraints();
		gbcV.fill = GridBagConstraints.HORIZONTAL;
		gbcV.gridy = 0;
		gbcV.gridx = 5;
		this.add(new JLabel("Viernes"), gbcV);

		GridBagConstraints gbcS = new GridBagConstraints();
		gbcS.fill = GridBagConstraints.HORIZONTAL;
		gbcS.gridy = 0;
		gbcS.gridx = 6;
		this.add(new JLabel("Sabado"), gbcS);

		GridBagConstraints gbcD = new GridBagConstraints();
		gbcD.fill = GridBagConstraints.HORIZONTAL;
		gbcD.gridy = 0;
		gbcD.gridx = 7;
		this.add(new JLabel("Domingo"), gbcD);



		for(int i = 0 ; i<7;i++){
			for(int j = 0;j<6;j++){
				GridBagConstraints gbc = new GridBagConstraints();
				gbc.fill = GridBagConstraints.NONE;
				gbc.gridy = j+1;
				gbc.weightx = 0.0D;
				gbc.weighty = 0.0D;
				gbc.gridheight = 1;
				gbc.gridwidth = 1;
				gbc.gridx = i+1;
				this.add(paneles[i][j],gbc);
			}
		}

	}



	public JTextPane createTestPane(String id){
		JTextPane jtp = new JTextPane();
		jtp.setName(id);
		jtp.setPreferredSize(new Dimension(100, 68));
		jtp.setEditable(false);
		jtp.setBorder(BorderFactory.createLineBorder(Color.black));
		jtp.setText("");
		jtp.setEnabled(false);

		jtp.addFocusListener(new java.awt.event.FocusAdapter() {

			public void focusGained(java.awt.event.FocusEvent e) {
				String n = e.getComponent().getName();
				selectDia(n);
			}


		});

		return jtp;
	}



	public void selectDia(String id){
		int fila = Integer.parseInt(id.substring(0, 1));
		int columna = Integer.parseInt(id.substring(1, 2));

		JTextPane dia = this.paneles[fila][columna];

		String sdia = dia.getText().split("_")[0];

		cd.diaSelected(dia,sdia);
	}



	public void updateMes(Mes me){
		this.mes = me;

		for(int i = 0 ; i<7;i++){

			for(int j = 0;j<6;j++){
				paneles[i][j].setText("");
				paneles[i][j].setEnabled(false);

			}
		}

		Calendar c = Calendar.getInstance();

		int m = 0;
		String mesN = this.mes.getMes();
		if(mesN.equals("Enero")){
			m = Calendar.JANUARY;
		}else if(mesN.equals("Febrero")){
			m = Calendar.FEBRUARY;
		}else if(mesN.equals("Marzo")){
			m = Calendar.MARCH;
		}else if(mesN.equals("Abril")){
			m = Calendar.APRIL;
		}else if(mesN.equals("Mayo")){
			m = Calendar.MAY;
		}else if(mesN.equals("Junio")){
			m = Calendar.JUNE;
		}else if(mesN.equals("Julio")){
			m = Calendar.JULY;
		}else if(mesN.equals("Agosto")){
			m = Calendar.AUGUST;
		}else if(mesN.equals("Septiembre")){
			m = Calendar.SEPTEMBER;
		}else if(mesN.equals("Octubre")){
			m = Calendar.OCTOBER;
		}else if(mesN.equals("Noviembre")){
			m = Calendar.NOVEMBER;
		}else if(mesN.equals("Diciembre")){
			m = Calendar.DECEMBER;
		}

		c.set(Calendar.YEAR,mes.getAo());
		c.set(Calendar.MONTH, m);
		c.set(Calendar.DAY_OF_MONTH, 1);

		int weekDay = c.get(Calendar.DAY_OF_WEEK);

		int start = 0;

		if(weekDay == Calendar.MONDAY){
			start = 0;
		}else if(weekDay == Calendar.TUESDAY){
			start = 1;
		}else if(weekDay == Calendar.WEDNESDAY){
			start = 2;
		}else if(weekDay == Calendar.THURSDAY){
			start = 3;
		}else if(weekDay == Calendar.FRIDAY){
			start = 4;
		}else if(weekDay == Calendar.SATURDAY){
			start = 5;
		}else if(weekDay == Calendar.SUNDAY){
			start = 6;
		}

		int days = c.getActualMaximum(Calendar.DAY_OF_MONTH);



		for(int i = 0; i<days;i++){
			int posX = (i+start)%7;
			int posY = (i+start)/7;


			String text ="";
			if(i+start>8){
				text = (i+1)+"___________\n\n ";
			}else{
				text = (i+1)+"____________\n\n ";
			}

			paneles[posX][posY].setText(text);



			switch(this.mode){
			case JDiasComponent.NORMALMODE:
				if(mes.getListas().containsKey(i+1)){
					paneles[posX][posY].setEnabled(true);
					Lista l = mes.getListas().get(i+1);
					int citas = l.getNumeroAsignados();

					int max = l.getCantidadMaxima();

					if(citas == 1){
						paneles[posX][posY].setText(paneles[posX][posY].getText()+citas+"/"+max+" cita\n");
					}else{
						paneles[posX][posY].setText(paneles[posX][posY].getText()+citas+"/"+max+" citas\n");
					}

					int citasE = l.getNumeroEspeciales();
					if(citasE == 1){
						paneles[posX][posY].setText(paneles[posX][posY].getText()+citasE+" cita esp.");
					}else{
						paneles[posX][posY].setText(paneles[posX][posY].getText()+citasE+" citas esp.");
					}
				}
				break;
			case JDiasComponent.CREARLISTASMODE:
				if(mes.getListas().containsKey(i+1)){
					paneles[posX][posY].setEnabled(false);
					Lista l = mes.getListas().get(i+1);
					int citas = l.getNumeroTotal();

					if(citas == 1){
						paneles[posX][posY].setText(paneles[posX][posY].getText()+citas+" cita");
					}else{
						paneles[posX][posY].setText(paneles[posX][posY].getText()+citas+" citas");
					}

				}else{
					paneles[posX][posY].setEnabled(true);
				}
				break;
			case JDiasComponent.MOVERLISTAMODE:
				if(mes.getListas().containsKey(i+1)){
					paneles[posX][posY].setEnabled(false);
					Lista l = mes.getListas().get(i+1);
					int citas = l.getNumeroTotal();

					if(citas == 1){
						paneles[posX][posY].setText(paneles[posX][posY].getText()+citas+" cita");
					}else{
						paneles[posX][posY].setText(paneles[posX][posY].getText()+citas+" citas");
					}

				}else{
					paneles[posX][posY].setEnabled(true);
				}

				break;
			case JDiasComponent.MOVERCITAMODE:
				if(mes.getListas().containsKey(i+1)){
					paneles[posX][posY].setEnabled(true);
					Lista l = mes.getListas().get(i+1);
					int citas = l.getNumeroTotal();

					if(citas == 1){
						paneles[posX][posY].setText(paneles[posX][posY].getText()+citas+" cita");
					}else{
						paneles[posX][posY].setText(paneles[posX][posY].getText()+citas+" citas");
					}

				}
				break;
			}


		}
	}

	public JTextPane getPanel(int dia){
		JTextPane ret = null;
		for(int i = 0 ; i<7 && ret == null;i++){
			for(int j = 0;j<6 && ret == null;j++){
				if(paneles[i][j].getText().startsWith(dia+"_")){
					ret = paneles[i][j];
				}

			}
		}
		return ret;
	}

}
