package presentacion.configuration;

import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

import javax.swing.JDialog;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Window;

import javax.swing.JButton;

import dominio.Control;
import java.awt.Dimension;

public class JDConfiguration extends JDialog {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jLabel = null;
	private JLabel jLabel3 = null;
	private JButton jButtonOK = null;
	private JButton jButtonCancel = null;


	private JSpinner nAos = null;
	private Control c;
	/**
	 * @param owner
	 */
	public JDConfiguration(Window owner, Control c) {
		super(owner);
		this.c = c;
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
		this.setSize(800, 200);
		this.setMinimumSize(new Dimension(900, 87));
		this.setPreferredSize(new Dimension(1000, 87));
		this.setTitle("Configuraci\u00F3n");
		this.setContentPane(getJContentPane());
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				cerrar();
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 2;
			gridBagConstraints5.anchor = GridBagConstraints.WEST;
			gridBagConstraints5.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints5.gridy = 2;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 1;
			gridBagConstraints4.anchor = GridBagConstraints.EAST;
			gridBagConstraints4.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints4.gridy = 2;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 2;
			gridBagConstraints3.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints3.gridy = 0;
			jLabel3 = new JLabel();
			jLabel3.setText("meses (No se aplica hasta que se reinicie la aplicaci\u00F3n o cambie de base de datos)");
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints.gridy = 0;
			jLabel = new JLabel();
			jLabel.setText("Mantener las citas de los ltimos ");
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(jLabel, gridBagConstraints);
			jContentPane.add(jLabel3, gridBagConstraints3);
			jContentPane.add(getJButtonOK(), gridBagConstraints4);
			jContentPane.add(getJButtonCancel(), gridBagConstraints5);
			GridBagConstraints gridBagConstraintsT2 = new GridBagConstraints();
			gridBagConstraintsT2.gridx = 1;
			gridBagConstraintsT2.insets = new Insets(5, 5, 5, 5);
			gridBagConstraintsT2.gridy = 0;

			jContentPane.add(this.getNAos(),gridBagConstraintsT2);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jButtonOK
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonOK() {
		if (jButtonOK == null) {
			jButtonOK = new JButton();
			jButtonOK.setText("Aceptar");
			jButtonOK.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					okAction();
				}
			});
		}
		return jButtonOK;
	}

	/**
	 * This method initializes jButtonCancel
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButtonCancel() {
		if (jButtonCancel == null) {
			jButtonCancel = new JButton();
			jButtonCancel.setText("Cancelar");
			jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					cerrar();
				}
			});
		}
		return jButtonCancel;
	}

	private JSpinner getNAos(){
		if(this.nAos == null){
			int y = this.c.getMesesToStore();
			SpinnerNumberModel m = new SpinnerNumberModel(y, 1, Integer.MAX_VALUE, 1);
			this.nAos = new JSpinner(m);
			this.nAos.setSize(50, 20);
		}
		return this.nAos;
	}

	public void cerrar(){
		this.dispose();
	}

	public void okAction(){

		int aos = (Integer)this.nAos.getValue();


		this.c.setConfiguration(aos);

		this.cerrar();
	}
}
