package pruebas.cobertura.dominio;


import java.util.Calendar;

import javax.swing.JFileChooser;

import junit.framework.TestCase;


import mockit.Mockit;


import persistencia.Persistencia;
import pruebas.cobertura.MyCalendar;
import pruebas.cobertura.MyFileChooser;
import pruebas.cobertura.MySystem;
import pruebas.cobertura.PersistenciaStubsInterface1;
import pruebas.cobertura.PersistenciaStubsInterface3;
import pruebas.cobertura.VentanaStub;
import dominio.Control;

public class TestControlConstructor extends TestCase{


	Control c;
	
	public void setUp(){
		
		c = null;
		MyFileChooser mfc = new MyFileChooser();
		
		
		Mockit.setUpMock(Calendar.class,MyCalendar.class);
		Mockit.setUpMock(JFileChooser.class,mfc);
		Mockit.setUpMock(System.class,MySystem.class);
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		Mockit.tearDownMocks(Calendar.class);
		Mockit.tearDownMocks(JFileChooser.class);
		Mockit.tearDownMocks(System.class);
	}
	
	
	public void testErroresConstructor(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface1.class);
		VentanaStub v = new VentanaStub();
		try{
			this.c = new Control(v);
			fail();
		}catch(Exception e){
			assertTrue(v.errors.get(0).equals("No se ha podido leer la base datos. Compruebe que hay acceso al archivo donde est almacenada la nueva base de datos. Si el problema persiste puede que el archivo de base de datos est daado. Intente utilizar la copia de seguridad."));
			assertTrue(v.errors.get(1).equals("No se ha podido leer la copia de seguridad."));
		}
		
		
	}
	
	
	
	public void testNoHayDataBase(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface3.class);
		
		VentanaStub v = new VentanaStub();
		this.c = new Control(v);
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==0);
		
	}

}
