package pruebas.cobertura.dominio;

import java.awt.print.PageFormat;
import java.awt.print.Paper;
import java.util.Calendar;

import com.jrefinery.report.util.PageFormatFactory;

import mockit.Mockit;
import persistencia.Persistencia;
import pruebas.cobertura.MyCalendar;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;
import pruebas.cobertura.WPrinterJobMy;
import pruebas.cobertura.WPrinterJobMy2;
import sun.awt.windows.WPrinterJob;
import sun.print.RasterPrinterJob;
import dominio.Control;
import junit.framework.TestCase;


public class TestControlImprimir extends TestCase{
	
	

	
	Control c;
	VentanaStub v;
	private PageFormat pf;
	
	public void setUp(){
		
		c = null;
		v = null;
		pf = null;
		
		WPrinterJobMy2 mpj = new WPrinterJobMy2();
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		Mockit.setUpMock(Calendar.class,MyCalendar.class);
		v = new VentanaStub();
		c = new Control(v);
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		this.pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		Mockit.tearDownMocks(Calendar.class);
		Mockit.tearDownMocks(WPrinterJob.class);
		Mockit.tearDownMocks(RasterPrinterJob.class);
	}
	
	
	public void testImprimirDia(){
		
		
		boolean r = c.imprimirDia("Enero", 2011, Control.CITAS_TODAS, true, pf, c.getMes("Enero", 2011).getListas().get(15));
		assertTrue(r == true);
	}
	
	public void testImprimirMes(){
		
		c.borrarLista(2011, "Enero", 14);
		boolean r = c.imprimirMes("Enero", 2011, Control.CITAS_TODAS, true, pf);
		assertTrue(r == true);
	}
	

}
