package pruebas.cobertura.dominio;

import dominio.exceptions.CitaConFechaNoAsignadaException;
import dominio.exceptions.CitaNoExisteException;
import dominio.exceptions.CitaYaAsigndaException;
import dominio.exceptions.DemasiadasCitasException;
import dominio.exceptions.ListaNoCambiadaException;
import dominio.exceptions.ListasException;
import junit.framework.TestCase;

public class TestCubrirExcepciones extends TestCase{

	
	
	public void testCitaConFechaNoAsignadaException(){
		
		CitaConFechaNoAsignadaException ex = new CitaConFechaNoAsignadaException();
		assertTrue(ex.getMessage()==null);
		
		ex = new CitaConFechaNoAsignadaException("msg");
		assertTrue(ex.getMessage().equals("msg"));
		
	}
	
	public void testCitaNoExisteException(){
		
		CitaNoExisteException ex = new CitaNoExisteException();
		assertTrue(ex.getMessage()==null);
		
		ex = new CitaNoExisteException("msg");
		assertTrue(ex.getMessage().equals("msg"));
		
		Exception e = new Exception("msgCausa");
		ex = new CitaNoExisteException(e);
		assertTrue(ex.getCause().getMessage().equals("msgCausa"));
		assertTrue(ex.getMessage().equals("java.lang.Exception: msgCausa"));
		
		ex = new CitaNoExisteException("msg",e);
		assertTrue(ex.getCause().getMessage().equals("msgCausa"));
		assertTrue(ex.getMessage().equals("msg"));
		
	}
	
	public void testCitaYaAsignadaException(){
		
		CitaYaAsigndaException ex = new CitaYaAsigndaException();
		assertTrue(ex.getMessage()==null);
		
		ex = new CitaYaAsigndaException("msg");
		assertTrue(ex.getMessage().equals("msg"));
		
		Exception e = new Exception("msgCausa");
		ex = new CitaYaAsigndaException(e);
		assertTrue(ex.getCause().getMessage().equals("msgCausa"));
		assertTrue(ex.getMessage().equals("java.lang.Exception: msgCausa"));
		
		ex = new CitaYaAsigndaException("msg",e);
		assertTrue(ex.getCause().getMessage().equals("msgCausa"));
		assertTrue(ex.getMessage().equals("msg"));
		
	}
	
	public void testDemasiadasCitasException(){
		
		DemasiadasCitasException ex = new DemasiadasCitasException();
		assertTrue(ex.getMessage()==null);
		
		ex = new DemasiadasCitasException("msg");
		assertTrue(ex.getMessage().equals("msg"));
		
		Exception e = new Exception("msgCausa");
		ex = new DemasiadasCitasException(e);
		assertTrue(ex.getCause().getMessage().equals("msgCausa"));
		assertTrue(ex.getMessage().equals("java.lang.Exception: msgCausa"));
		
		ex = new DemasiadasCitasException("msg",e);
		assertTrue(ex.getCause().getMessage().equals("msgCausa"));
		assertTrue(ex.getMessage().equals("msg"));
		
	}
	
	public void testListaNoCambiadaException(){
		
		ListaNoCambiadaException ex = new ListaNoCambiadaException();
		assertTrue(ex.getMessage()==null);
		
		ex = new ListaNoCambiadaException("msg");
		assertTrue(ex.getMessage().equals("msg"));
		
		Exception e = new Exception("msgCausa");
		ex = new ListaNoCambiadaException(e);
		assertTrue(ex.getCause().getMessage().equals("msgCausa"));
		assertTrue(ex.getMessage().equals("java.lang.Exception: msgCausa"));
		
		ex = new ListaNoCambiadaException("msg",e);
		assertTrue(ex.getCause().getMessage().equals("msgCausa"));
		assertTrue(ex.getMessage().equals("msg"));
		
	}
	
	public void testListasException(){
		
		ListasException ex = new ListasException();
		assertTrue(ex.getMessage()==null);
		
		ex = new ListasException("msg");
		assertTrue(ex.getMessage().equals("msg"));
		
		Exception e = new Exception("msgCausa");
		ex = new ListasException(e);
		assertTrue(ex.getCause().getMessage().equals("msgCausa"));
		assertTrue(ex.getMessage().equals("java.lang.Exception: msgCausa"));
		
		ex = new ListasException("msg",e);
		assertTrue(ex.getCause().getMessage().equals("msgCausa"));
		assertTrue(ex.getMessage().equals("msg"));
		
	}
}
