package pruebas.cobertura.dominio;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Hashtable;

import persistencia.Persistencia;
import configuracion.Configuracion;
import dominio.Mes;
import junit.framework.TestCase;

public class TestCubrirPersistencia extends TestCase{

	
	
	public void setUp(){
		File f2 = new File("./configurationCitasMed_test");
		if(f2.exists()){
			f2.delete();
		}
		File f = new File("./configurationCitasMed");
		if(f.exists()){
			f.renameTo(f2);
		}

		File fdb = new File("./dataBase_test");
		if(fdb.exists()){
			fdb.delete();
		}

	}

	public void tearDown(){
		File f = new File("./configurationCitasMed");
		if(f.exists()){
			f.delete();
		}
		
		File f2 = new File("./configurationCitasMed_test");
		if(f2.exists()){
			f2.renameTo(f);
		}
		
		File fdb = new File("./dataBase_test");
		if(fdb.exists()){
			fdb.delete();
		}
	}
	
	public void testGuardarConfig() throws FileNotFoundException, IOException, ClassNotFoundException{
		
		boolean r = Persistencia.existeConfiguracion();
		assertTrue(r == false);
		
		
		Configuracion c = new Configuracion();
		c.setPathBaseCitas("MyBaseCitas");
		
		Persistencia.saveConfiguration(c);
		
		r = Persistencia.existeConfiguracion();
		assertTrue(r == true);
		
		Configuracion c1 = Persistencia.getConfiguration();
		assertTrue(c1.getPathBaseCitas().equals("MyBaseCitas"));
		
	}
	
	public void testBD() throws IOException, ClassNotFoundException{
		
		 Hashtable<String, Mes> meses = new Hashtable<String, Mes>();
		 meses.put("2011Enero", new Mes("Enero", 2011));
		 File f = new File("./dataBase_test");
		 boolean r = Persistencia.saveDataBase(f, meses);
		 assertTrue(r == true);
		 
		 
		 Hashtable<String, Mes> meses2 = Persistencia.readDataBase(f);
		 assertTrue(meses2.size()==1);
		 
		 Persistencia.borrarDataBase(f);
		
	}
}
