package pruebas.cobertura.dominio;

import junit.framework.TestCase;


import dominio.Cita;
import dominio.Lista;
import dominio.Mes;
import dominio.ResultadoBusqueda;
import dominio.exceptions.CitaConFechaNoAsignadaException;
import dominio.exceptions.CitaYaAsigndaException;

public class TestCubrirResultadosBusqueda extends TestCase{

	public void testRB() throws CitaConFechaNoAsignadaException, CitaYaAsigndaException{
		
		Cita cita = new Cita("c1", 1, "cm1", 0);
		Lista l = new Lista(5, "Enero", 2011, 10);
		l.addAsignado(cita);
		Mes m = new Mes("Enero", 2011);
		
		ResultadoBusqueda rb = new ResultadoBusqueda(cita, l, m, false);
		
		assertTrue(rb.getC()== cita);
		assertTrue(rb.getL() == l);
		assertTrue(rb.getM() == m);
		assertTrue(rb.isEspecial() == false);
		
		rb.setC(null);
		assertTrue(rb.getC()== null);
		
		rb.setEspecial(true);
		assertTrue(rb.isEspecial() == true);
		
		rb.setL(null);
		assertTrue(rb.getL() == null);
		
		rb.setM(null);
		assertTrue(rb.getM() == null);
	}

	
	
}
