package pruebas.cobertura.dominio;


import java.io.File;
import java.util.Calendar;

import persistencia.Persistencia;
import presentacion.IVentana;
import pruebas.cobertura.MyCalendar;
import pruebas.cobertura.MyCalendar2;
import pruebas.cobertura.PersistenciaStubsInterfaceF;
import pruebas.cobertura.VentanaStub;
import dominio.Control;

import mockit.Mockit;
import junit.framework.TestCase;



public class TestFechas extends TestCase{


	Control c;
	
	public void setUp(){
		c = null;
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceF.class);
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		Mockit.tearDownMocks(Calendar.class);
		
	}
	
	public void testEnero(){
		
		
		Mockit.setUpMock(Calendar.class,MyCalendar.class);
		IVentana v = new VentanaStub();
		c = new Control(v);
		
		c.setConfiguration(2);
		try {
			c.cambiarDataBase(new File("."));
			
			assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==6);
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void test2012(){
		
		
		Mockit.setUpMock(Calendar.class,MyCalendar2.class);
		IVentana v = new VentanaStub();
		c = new Control(v);
		
		c.setConfiguration(2);
		try {
			c.cambiarDataBase(new File("."));
			
			assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==0);
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	
	

}
