package pruebas.cobertura.dominio;

import java.io.File;
import java.util.Calendar;

import mockit.Mockit;
import persistencia.Persistencia;
import pruebas.cobertura.MyCalendar;
import pruebas.cobertura.PersistenciaStubsInterfaceGA;
import pruebas.cobertura.PersistenciaStubsInterfaceGA2;
import pruebas.cobertura.PersistenciaStubsInterfaceGA3;
import pruebas.cobertura.PersistenciaStubsInterfaceGA4;
import pruebas.cobertura.VentanaStub;
import dominio.Control;
import junit.framework.TestCase;


public class TestGuardarArchivos extends TestCase{

	
	Control c;
	VentanaStub v;
	public void setUp(){
		
		
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceGA.class);
		Mockit.setUpMock(Calendar.class,MyCalendar.class);
		c = null;
		v = null;
		
		v = new VentanaStub();
		c = new Control(v);
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		Mockit.tearDownMocks(Calendar.class);
	}
	
	public void testNuevaDataBase() {
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceGA.class);
		try {
			c.nuevaDataBase(new File("./ndb"));
			
			assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==0);
		} catch (Exception e) {
			fail();
		}
	}
	
	public void testNuevaDataBaseGuardarError1() {
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceGA2.class);
		try {
			c.nuevaDataBase(new File("./ndb"));
			fail();
			
		} catch (Exception e) {
			
		}
	}
	
	public void testNuevaDataBaseGuardarError2() {
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceGA3.class);
		try {
			c.nuevaDataBase(new File("./ndb"));
			fail();
			
		} catch (Exception e) {
			
		}
	}
	
	public void testGuardarDataBaseCeroError() {
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceGA2.class);
		try {
			c.nuevaDataBaseCero(new File("./ndb"));
			fail();
			
		} catch (Exception e) {
			
		}
	}
	
	public void testCambiarDataBase() {
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceGA.class);
		try {
			c.getMes("Enero", 2011).getSinAsignarDa().clear();
			c.cambiarDataBase(new File("."));
			assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==6);
			
		} catch (Exception e) {
			fail();
		}
	}
	
	public void testCambiarDataBaseError1() {
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceGA2.class);
		try {
			c.cambiarDataBase(new File("."));
			fail();
		} catch (Exception e) {
			
		}
	}
	
	public void testCambiarDataBaseError2() {
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceGA4.class);
		try {
			c.cambiarDataBase(new File("."));
			fail();
		} catch (Exception e) {
			assertTrue(v.errors.size()==1);
			assertTrue(v.errors.get(0).equals("No se ha podido leer la nueva base datos. Compruebe que hay acceso al disco donde se quiere almacenada la nueva base de datos. Si el problema persiste puede que el archivo de base de datos est daado y no se pueda utilizar"));
		}
	}
	
	public void testCerrarAplicacion(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceGA.class);
		c.cerrarApplicacion();
		assertTrue(v.errors.size()==0);
	}
	
	public void testCerrarAplicacionError(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceGA4.class);
		c.cerrarApplicacion();
		assertTrue(v.errors.size()==1);
		
	}

}
