package pruebas.cobertura.presentacion;

import java.awt.Component;
import java.awt.print.PageFormat;
import java.io.IOException;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.Properties;
import java.util.Vector;

import javax.swing.JDialog;
import javax.swing.JFrame;

import mockit.Mock;
import mockit.Mockit;

import org.uispec4j.MenuItem;
import org.uispec4j.Panel;
import org.uispec4j.Spinner;
import org.uispec4j.Table;
import org.uispec4j.TextBox;
import org.uispec4j.Trigger;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.Window;
import org.uispec4j.finder.ComponentMatcher;
import org.uispec4j.interception.BasicHandler;
import org.uispec4j.interception.FileChooserHandler;
import org.uispec4j.interception.WindowHandler;
import org.uispec4j.interception.WindowInterceptor;

import dominio.Cita;
import dominio.Control;
import dominio.Lista;
import dominio.Mes;

import persistencia.Persistencia;
import presentacion.CitasMEd;
import presentacion.JDiasComponent;
import pruebas.cobertura.MyControlError;
import pruebas.cobertura.MySystem;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.WindowCloser;

public class TestCitasMed extends UISpecTestCase{

	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		Mockit.tearDownMocks(System.class);
		Mockit.tearDownMocks(Control.class);

		
	}
	
	public static JFrame getFrame(CitasMEd cm){
		JFrame jf = null;
		
		try {
			Method f = cm.getClass().getDeclaredMethod("getJFrame");
			f.setAccessible(true);
			jf = (JFrame)f.invoke(cm);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		return jf;
	}
	
	public void testAbout(){
		
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		//jf.setVisible(true);
		Window p = new Window(jf);
		
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
    	MenuItem m = p.getMenuBar().getMenu("Ayuda");
		MenuItem mp = m.getSubMenu("Acerca de CitasMed");
    	
		WindowInterceptor
	      .init(mp.triggerClick())
	      .process(new WindowHandler() {
	        public Trigger process(Window window) {
	          
	        	/*class MyTrigger implements Trigger{
	        		Window w;
	        		public MyTrigger(Window w){
	        			super();
	        			this.w = w;
	        		}
					@Override
					public void run() throws Exception {
						// TODO Auto-generated method stub
						((JDialog)w.getAwtComponent()).dispose();
					}
	        		
	        	}*/
	        	return new WindowCloser(window);
	        }
	      })
	      .run();
	}
	
	public void testMenusCitas(){
		
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		//jf.setVisible(true);
		Window p = new Window(jf);
		
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
    	MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Nueva cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==6);
		
		mp = m.getSubMenu("Nueva cita especial");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDaEspecial().size()==0);
		
		mp = m.getSubMenu("Buscar cita...");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cerrar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==6);
		
		mp = m.getSubMenu("Borrar cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==6);
		
		p.getTable("tablePC").selectRow(0);
		mp = m.getSubMenu("Asignar da a cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancelar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==6);
		
		mp = m.getSubMenu("Organizar citas automticamente");
		mp.click();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==0);
	}
	
	
	public void testMenusListas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
    	MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Crear listas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getListas().size()==2);
		
		mp = m.getSubMenu("Mover lista de da");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getListas().size()==2);
		
		mp = m.getSubMenu("Cambiar el nmero mximo de citas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getListas().size()==2);
		
		mp = m.getSubMenu("Borrar lista");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getListas().size()==2);
	}
	
	public void testMenusArchivo(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
    	MenuItem m = p.getMenuBar().getMenu("Archivo");
		MenuItem mp = m.getSubMenu("Nueva base de datos de citas");
		WindowInterceptor wib = WindowInterceptor.init(mp.triggerClick());
		wib.process(FileChooserHandler.init().cancelSelection()).run();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==6);
		
		mp = m.getSubMenu("Cambiar base de datos de citas");
		wib = WindowInterceptor.init(mp.triggerClick());
		wib.process(FileChooserHandler.init().cancelSelection()).run();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==6);
		
		mp = m.getSubMenu("Preferencias");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancelar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getListas().size()==2);
		
		
	}
	
	
	
	public void testMenusImprimir(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
    	MenuItem m = p.getMenuBar().getMenu("Imprimir");
		MenuItem mp = m.getSubMenu("Imprimir da");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getListas().size()==2);
		
		mp = m.getSubMenu("Imprimir mes");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getListas().size()==2);
	}
	
	public void testRefres(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		cm.refresh();
		
	}
	
	public void testShowMensaje(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		
		
		class MyTrigger2 implements Trigger{
    		CitasMEd cm;
    		public MyTrigger2(CitasMEd cm){
    			super();
    			this.cm = cm;
    		}
			@Override
			public void run() throws Exception {
				// TODO Auto-generated method stub
				cm.showMensaje("mensaje");
			}
    	}
		
		WindowInterceptor.init(new MyTrigger2(cm)).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		
	}

	
	public void testSelectCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		TextBox tb = p.getTextBox("textObservaciones");
		
		cm.citaSelected(315);
		assertTrue(tb.getText().contains("A PRINCIPIOS"));
		
		cm.citaSelected(415);
		assertTrue(tb.getText().contains("A FINALES"));
	}
	
	public void testSelectCitaEspecialEntabla(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		
		Table t = p.getTable("tablePCS");
		t.selectRow(0);
		
		TextBox tb = p.getTextBox("textObservaciones");
		
		assertTrue(tb.getText().contains("Sin preferencias para ser citado."));
		
		
	}
	
	public void testBorrarLista(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		cm.borrarLista();
		
		cm.diaSelected(cm.getSinDias(), "-1");
		
		Table t = p.getTable("tablePCS");
		assertTrue(t.rowCountEquals(1));
		
		
	}
	
	public void testCrearListaUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Crear listas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().size()==0);
		
		
	}
	
	public void testCrearCitaUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Nueva cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==1);
		
		
	}
	
	
	public void testMoverListaUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Mover lista de da");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().containsKey(5));
		
		
	}
	
	public void testMoverLista(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Mover lista de da");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getListas().containsKey(14));
		
		
	}
	
	public void testCambiarMaxUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Cambiar el nmero mximo de citas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().get(5).getCantidadMaxima()==10);
		
		
	}
	
	public void testCambiarMax(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Cambiar el nmero mximo de citas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getListas().get(14).getCantidadMaxima() == 10);
		
		
	}
	
	public void testBorrarListaUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Borrar lista");
		mp.click();
		assertTrue(c.getMes("Enero", 2012).getListas().size()==0);
		
		
	}
	
	public void testAsignarDiaACitaError(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Asignar da a cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()== 6);
		
		
	}
	
	public void testAsignarDiaACitaEspecial(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(123, new Cita("test123",123,"comment123",0));
		
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePCS").selectRow(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Asignar da a cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDaEspecial().size()== 1);
		
		
	}
	
	
	public void testAsignarDiaACitaError2(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Asignar da a cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
			public Trigger process(Window window) {
				return window.getButton("Aceptar").triggerClick();
			}
		}).run();

		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()== 6);
		
		
	}
	
	public void testOrganizarCitasUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(123, new Cita("test123",123,"comment123",0));
		
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Organizar citas automticamente");
		mp.click();
		/*WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();*/
		
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDaEspecial().size()== 1);
		
		
	}
	
	public void testBorrarCitaEspecial(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(123, new Cita("test123",123,"comment123",0));
		
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePCS").selectRow(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Borrar cita");
		mp.click();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDaEspecial().size()== 0);
		
		
	}
	
	public void testBorrarCitaNormal(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDa().put(123, new Cita("test123",123,"comment123",0));
		
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePC").selectRow(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Borrar cita");
		mp.click();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()== 0);
		
		
	}
	
	public void testBorrarCitaNormalUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDa().put(123, new Cita("test123",123,"comment123",0));
		c.getMes("Enero", 2012).getSinAsignarDa().put(143, new Cita("test143",143,"comment143",0));
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePC").selectRow(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Borrar cita");
		mp.click();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()== 1);
		
		
	}
	
	public void testBuscarCitaUnaCita(){
		
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDa().put(123, new Cita("test123",123,"comment123",0));
		
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePC").selectRow(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Buscar cita...");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cerrar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==1);
	}
	
	public void testNuevaBaseDatos(){

		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		
		MenuItem m = p.getMenuBar().getMenu("Archivo");
		MenuItem mp = m.getSubMenu("Nueva base de datos de citas");
		WindowInterceptor wib = WindowInterceptor.init(mp.triggerClick());
		wib.process(FileChooserHandler.init().select("./")).run();
		
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==0);
	}
	
	public void testCambiarBaseDatos(){

		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		MenuItem m = p.getMenuBar().getMenu("Archivo");
		MenuItem mp = m.getSubMenu("Cambiar base de datos de citas");
		WindowInterceptor wib = WindowInterceptor.init(mp.triggerClick());
		wib.process(FileChooserHandler.init().select("./")).run();
		
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==6);
	}
	
	public void testImprimirDiaValido(){

		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		MenuItem m = p.getMenuBar().getMenu("Imprimir");
		MenuItem mp = m.getSubMenu("Imprimir da");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getListas().size()==2);
		
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==6);
	}
	
	
	
	public void testCerrarApp(){
		
		
		Mockit.setUpMock(System.class,MySystem.class);
		
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		MenuItem m = p.getMenuBar().getMenu("Archivo");
		MenuItem mp = m.getSubMenu("Salir");
		mp.click();

		

		
		
		
	}
	
	
	public void testCerrarAppErrorNo(){
		
		MyControlError mce = new MyControlError();
		Mockit.setUpMock(Control.class,mce);
		
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		MenuItem m = p.getMenuBar().getMenu("Archivo");
		MenuItem mp = m.getSubMenu("Salir");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("No").triggerClick();
	        }
	      }).run();
			
		
	}
	
	public void testCerrarAppErrorSi(){
		
		MyControlError mce = new MyControlError();
		Mockit.setUpMock(System.class,MySystem.class);
		Mockit.setUpMock(Control.class,mce);
		
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		MenuItem m = p.getMenuBar().getMenu("Archivo");
		MenuItem mp = m.getSubMenu("Salir");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Si").triggerClick();
	        }
	      }).run();
		
	}
	
}
