package pruebas.cobertura.presentacion;

import java.awt.Component;

import mockit.Mockit;

import org.uispec4j.Panel;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.finder.ComponentMatcher;

import dominio.Cita;
import dominio.Control;
import dominio.Mes;

import persistencia.Persistencia;
import presentacion.JDAsignarDia;
import presentacion.JDiasComponent;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;

public class TestJDAsignarDia extends UISpecTestCase{

	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}
	
	
	public void testAsignarDa(){
		
		Control c = new Control(new VentanaStub());
		Mes m = c.getMes("Enero", 2011);
		int size = m.getSinAsignarDa().size();
		Cita ci = m.getSinAsignarDa().values().iterator().next();
		JDAsignarDia jdad = new JDAsignarDia(null, c, m, ci);
		Panel p = new Panel(jdad);
		
		Panel pjd = p.getPanel(new ComponentMatcher(){
			  public boolean matches(Component component) {
				  boolean ret = false;
				  if(component instanceof JDiasComponent){
					  ret = true;
				  }
				  return ret;
				  }
				});
		
		JDiasComponent jdc = (JDiasComponent)pjd.getAwtComponent();
		jdc.selectDia("42");
		
		p.getButton("Aceptar").click();
		
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==size-1);
		

	}
	
	public void testCancelar(){

		Control c = new Control(new VentanaStub());
		Mes m = c.getMes("Enero", 2011);
		int size = m.getSinAsignarDa().size();
		Cita ci = m.getSinAsignarDa().values().iterator().next();
		JDAsignarDia jdad = new JDAsignarDia(null, c, m, ci);
		Panel p = new Panel(jdad);
		
		p.getButton("Cancelar").click();
		
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==size);
		
		
	}
	
	
	public void testSelect2Dias(){
		
		Control c = new Control(new VentanaStub());
		Mes m = c.getMes("Enero", 2011);
		int size = m.getSinAsignarDa().size();
		Cita ci = m.getSinAsignarDa().values().iterator().next();
		JDAsignarDia jdad = new JDAsignarDia(null, c, m, ci);
		Panel p = new Panel(jdad);
		
		Panel pjd = p.getPanel(new ComponentMatcher(){
			  public boolean matches(Component component) {
				  boolean ret = false;
				  if(component instanceof JDiasComponent){
					  ret = true;
				  }
				  return ret;
				  }
				});
		
		JDiasComponent jdc = (JDiasComponent)pjd.getAwtComponent();
		jdc.selectDia("42");
		int diaSelected = jdad.getSelectedDay();
		jdc = (JDiasComponent)pjd.getAwtComponent();
		jdc.selectDia("52");
		int diaSelected2 = jdad.getSelectedDay();
		assertTrue(diaSelected+1 == diaSelected2);
		

	}
	
	
}
