package pruebas.cobertura.presentacion;

import mockit.Mockit;

import org.uispec4j.Button;
import org.uispec4j.Panel;
import org.uispec4j.Table;
import org.uispec4j.TextBox;
import org.uispec4j.Trigger;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.Window;
import org.uispec4j.interception.WindowHandler;
import org.uispec4j.interception.WindowInterceptor;

import dominio.Control;

import persistencia.Persistencia;
import presentacion.JDBuscarCitas;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;


public class TestJDBuscarCIta extends UISpecTestCase{

	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}
	
	
	public void testBuscarCitaPorNombre(){
		
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		
		JDBuscarCitas jdbc = new JDBuscarCitas(null, c);
		Panel p = new Panel(jdbc);
		
		p.getTextBox("fieldN").setText("test");
		
		Button b1 = p.getButton("Buscar por nombre");
		b1.click();
		
		Table t = p.getTable();
		assertTrue(t.rowCountEquals(10));
		
		t.selectRowsWithText(2,"515");
		TextBox tb = p.getInputTextBox("fieldO");
		assertTrue(tb.getText().equals("Sin preferencias para ser citado.\n\ntestcoment"));
		
		t.selectRowsWithText(2,"315");
		tb = p.getInputTextBox("fieldO");
		assertTrue(tb.getText().equals("Preferencia para ser citado A PRINCIPIOS.\n\ntestcoment2"));
		
		
		t.selectRowsWithText(2,"415");
		tb = p.getInputTextBox("fieldO");
		assertTrue(tb.getText().equals("Preferencia para ser citado A FINALES.\n\ntestcoment3"));
		
	}
	
	public void testBuscarCitaPorNH(){
		
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		
		JDBuscarCitas jdbc = new JDBuscarCitas(null, c);
		Panel p = new Panel(jdbc);
		
		p.getTextBox("fieldNH").setText("515");
		Button b1 = p.getButton("Buscar por nmero de historia");
		b1.click();
		
		Table t = p.getTable();
		assertTrue(t.rowCountEquals(1));
		
		t.selectRowsWithText(2,"515");
		b1 = p.getButton("Borrar cita seleccionada");
		b1.click();
		
		t = p.getTable();
		assertTrue(t.getRowCount() == 0);
		
		
	}
	
	public void testBuscarCitaPorNHMalo(){
		
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		
		JDBuscarCitas jdbc = new JDBuscarCitas(null, c);
		Panel p = new Panel(jdbc);
		
		p.getTextBox("fieldNH").setText("515a");
		Button b1 = p.getButton("Buscar por nmero de historia");
		WindowInterceptor wiA = WindowInterceptor.init(b1.triggerClick());
		wiA.process(
				new WindowHandler() {
					public Trigger process(Window dialog) {
						return dialog.getButton("Aceptar").triggerClick();
					}
				})
				.run();
		
		
		
		Table t = p.getTable();
		assertTrue(t.rowCountEquals(0));
		
		
	}
	
	
	public void testBuscarCitaPorNHDosVeces(){
		
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		
		JDBuscarCitas jdbc = new JDBuscarCitas(null, c);
		Panel p = new Panel(jdbc);
		
		p.getTextBox("fieldNH").setText("515");
		Button b1 = p.getButton("Buscar por nmero de historia");
		b1.click();
		
		Table t = p.getTable();
		assertTrue(t.rowCountEquals(1));
		
		p.getTextBox("fieldNH").setText("514");
		b1.click();
		assertTrue(t.rowCountEquals(1));
		
	}
	
	public void testBuscarBorrarCitaEspecial(){
		
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		
		JDBuscarCitas jdbc = new JDBuscarCitas(null, c);
		Panel p = new Panel(jdbc);
		
		p.getTextBox("fieldN").setText("tests");
		Button b1 = p.getButton("Buscar por nombre");
		b1.click();
		
		Table t = p.getTable();
		int  rows = t.getRowCount();
		
		t.selectRowsWithText(2,"215");
		b1 = p.getButton("Borrar cita seleccionada");
		b1.click();
		
		t = p.getTable();
		assertTrue(t.getRowCount() == rows-1);
		
		
	}
	
}
