package pruebas.cobertura.presentacion;

import mockit.Mockit;

import org.uispec4j.Panel;
import org.uispec4j.UISpecTestCase;

import dominio.Cita;
import dominio.Control;
import dominio.Lista;
import dominio.Mes;

import persistencia.Persistencia;
import presentacion.JDCambiarMaxLists;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;

public class TestJDCambiarMaxList extends UISpecTestCase{

	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}
	
	
	public void testCAmbiarMAX(){
		
		Control c = new Control(new VentanaStub());
		Mes m = c.getMes("Enero", 2011);
		Lista l = m.getListas().get(15);
		JDCambiarMaxLists jcml = new JDCambiarMaxLists(null, c, m, l);
		Panel p = new Panel(jcml);
		
		p.getSpinner().setValue(5);
		
		p.getButton("Aceptar").click();
		
		assertTrue(l.getCantidadMaxima()==5);
		
	}
	
	public void testCancelar(){
		
		Control c = new Control(new VentanaStub());
		Mes m = c.getMes("Enero", 2011);
		Lista l = m.getListas().get(15);
		int max = l.getCantidadMaxima();
		JDCambiarMaxLists jcml = new JDCambiarMaxLists(null, c, m, l);
		Panel p = new Panel(jcml);
		
		p.getSpinner().setValue(5);
		
		p.getButton("Cancel").click();
		
		assertTrue(l.getCantidadMaxima()==max);
		
	}
	
	
	
}
