package pruebas.cobertura.presentacion;

import javax.swing.JDialog;
import javax.swing.JFrame;

import mockit.Mockit;

import org.uispec4j.MenuItem;
import org.uispec4j.Panel;
import org.uispec4j.Spinner;
import org.uispec4j.Trigger;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.Window;
import org.uispec4j.interception.WindowHandler;
import org.uispec4j.interception.WindowInterceptor;

import dominio.Control;

import persistencia.Persistencia;
import presentacion.CitasMEd;
import presentacion.configuration.JDConfiguration;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;
import pruebas.cobertura.WindowCloser;

public class TestJDConfigutation extends UISpecTestCase{

	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}
	
	
	public void testConfigurar(){
		
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		JDConfiguration jdc = new JDConfiguration(null, c);
		Panel p = new Panel(jdc);
		
		Spinner sp = p.getSpinner();
		assertTrue(sp.valueEquals(24));
		
		sp.setValue(10);
		
		p.getButton("Aceptar").click();
		
		assertTrue(c.getMesesToStore()==10);
		
	}
	
	public void testConfigurarCancelar(){
		
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		JDConfiguration jdc = new JDConfiguration(null, c);
		Panel p = new Panel(jdc);
		
		Spinner sp = p.getSpinner();
		assertTrue(sp.valueEquals(24));
		
		sp.setValue(10);
		
		p.getButton("Cancelar").click();
		
		assertTrue(c.getMesesToStore()==24);
		
	}
	
}
