package pruebas.cobertura.presentacion;

import mockit.Mockit;

import org.uispec4j.Button;
import org.uispec4j.Panel;
import org.uispec4j.Trigger;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.Window;
import org.uispec4j.interception.WindowHandler;
import org.uispec4j.interception.WindowInterceptor;

import dominio.Control;
import dominio.Mes;

import persistencia.Persistencia;
import presentacion.JDCrearCita;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;

public class TestJDCrearCita extends UISpecTestCase{

	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}
	
	
	public void testCrearCItaSinD(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2011);
		
		JDCrearCita jdcc = new JDCrearCita(null, c, 2011, "Enero", false, false, -1);
		Panel p = new Panel(jdcc);
		
		p.getTextBox("fieldN").setText("testX");
		p.getTextBox("fieldNH").setText("1011");
		p.getTextBox("fieldC").setText("ComentarioX");
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getSinAsignarDa().containsKey(1011));
		
	}
	
	public void testCrearCItaConD(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2011);
		
		JDCrearCita jdcc = new JDCrearCita(null, c, 2011, "Enero", false, true, 15);
		Panel p = new Panel(jdcc);
		
		p.getTextBox("fieldN").setText("testX");
		p.getTextBox("fieldNH").setText("1011");
		p.getTextBox("fieldC").setText("ComentarioX");
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getListas().get(15).getAsignados().containsKey(1011));
		
	}
	
	public void testCrearCItaAPrincipios(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2011);
		
		JDCrearCita jdcc = new JDCrearCita(null, c, 2011, "Enero", false, false, -1);
		Panel p = new Panel(jdcc);
		
		p.getTextBox("fieldN").setText("testX");
		p.getTextBox("fieldNH").setText("1011");
		p.getTextBox("fieldC").setText("ComentarioX");
		p.getRadioButton("A primeros").click();
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getSinAsignarDa().get(1011).getPreferencia()==1);
		
	}
	
	public void testCrearCItaAFinales(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2011);
		
		JDCrearCita jdcc = new JDCrearCita(null, c, 2011, "Enero", false, false, -1);
		Panel p = new Panel(jdcc);
		
		p.getTextBox("fieldN").setText("testX");
		p.getTextBox("fieldNH").setText("1011");
		p.getTextBox("fieldC").setText("ComentarioX");
		p.getRadioButton("A ltimos").click();
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getSinAsignarDa().get(1011).getPreferencia()==2);
		
	}
	
	public void testAddCitaSpecial(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2011);
		
		JDCrearCita jdcc = new JDCrearCita(null, c, 2011, "Enero", true, true, 15);
		Panel p = new Panel(jdcc);
		
		p.getTextBox("fieldN").setText("testX");
		p.getTextBox("fieldNH").setText("1011");
		p.getTextBox("fieldC").setText("ComentarioX");
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getListas().get(15).getEspeciales().containsKey(1011));
	}
	
	
	public void testNHmalo(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2011);
		int s = m.getListas().get(15).getNumeroTotal();
		JDCrearCita jdcc = new JDCrearCita(null, c, 2011, "Enero", true, true, 15);
		Panel p = new Panel(jdcc);
		
		p.getTextBox("fieldN").setText("testX");
		p.getTextBox("fieldNH").setText("1011a");
		p.getTextBox("fieldC").setText("ComentarioX");
		
		Button b = p.getButton("Aceptar");
		WindowInterceptor wi2 = WindowInterceptor.init(b.triggerClick());
		wi2.process(
				new WindowHandler() {
					public Trigger process(Window dialog) {
						
						return dialog.getButton("Aceptar").triggerClick();
					}
				})
				.run();
		
		
		assertTrue(m.getListas().get(15).getNumeroTotal() == s);
	}
	
	
	
	
	
}
