package pruebas.cobertura.presentacion;

import java.awt.Component;

import mockit.Mockit;

import org.uispec4j.Button;
import org.uispec4j.Panel;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.finder.ComponentMatcher;

import dominio.Control;
import dominio.Mes;

import persistencia.Persistencia;
import presentacion.JDLists;
import presentacion.JDiasComponent;
import pruebas.cobertura.PersistenciaStubsInterfaceVacia;
import pruebas.cobertura.VentanaStub;

public class TestJDLists extends UISpecTestCase{

	
	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceVacia.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}
	
	
	public void testCrearListas(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2012);
		JDLists jdl = new JDLists(null, c, m);
		Panel p = new Panel(jdl);
		
		Panel pjd = p.getPanel(new ComponentMatcher(){
			  public boolean matches(Component component) {
				  boolean ret = false;
				  if(component instanceof JDiasComponent){
					  ret = true;
				  }
				  return ret;
				  }
				});
		
		JDiasComponent jdc = (JDiasComponent)pjd.getAwtComponent();
		jdc.selectDia("42");
		jdc.selectDia("52");
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getListas().size() == 2);
		
	}
	
	public void testCancelar(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2012);
		JDLists jdl = new JDLists(null, c, m);
		Panel p = new Panel(jdl);
		
		Panel pjd = p.getPanel(new ComponentMatcher(){
			  public boolean matches(Component component) {
				  boolean ret = false;
				  if(component instanceof JDiasComponent){
					  ret = true;
				  }
				  return ret;
				  }
				});
		
		JDiasComponent jdc = (JDiasComponent)pjd.getAwtComponent();
		jdc.selectDia("33");
		jdc.selectDia("43");
		
		Button b = p.getButton("Cancel");
		b.click();
		
		assertTrue(m.getListas().size() == 0);
		
	}
	
	public void testCrearListasNinguna(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2012);
		JDLists jdl = new JDLists(null, c, m);
		Panel p = new Panel(jdl);
		
		Panel pjd = p.getPanel(new ComponentMatcher(){
			  public boolean matches(Component component) {
				  boolean ret = false;
				  if(component instanceof JDiasComponent){
					  ret = true;
				  }
				  return ret;
				  }
				});
		
		JDiasComponent jdc = (JDiasComponent)pjd.getAwtComponent();
		jdc.selectDia("33");
		jdc.selectDia("33");
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getListas().size() == 0);
		
	}
	
	
	
}
