package pruebas.cobertura.presentacion;

import java.awt.print.PageFormat;
import java.awt.print.Paper;
import java.awt.print.PrinterException;

import org.uispec4j.Button;
import org.uispec4j.Panel;
import org.uispec4j.UISpecTestCase;

import com.jrefinery.report.util.PageFormatFactory;

import dominio.Lista;
import mockit.Mock;
import mockit.Mockit;
import persistencia.Persistencia;
import presentacion.JDPrint;
import pruebas.cobertura.ControlStub;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;
import pruebas.cobertura.WPrinterJobMy4;
import sun.awt.windows.WPrinterJob;

public class TestJDPrint extends UISpecTestCase{

	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		Mockit.tearDownMocks(WPrinterJob.class);
	}
	
	
	
	
	public void testPrintMes(){
		
		VentanaStub vs = new VentanaStub();
		ControlStub c = new ControlStub(vs);
		JDPrint jdp = new JDPrint(null, c, "Enero", 2011);
		Panel p = new Panel(jdp);
		
		Button b = p.getButton("Imprimir");
		b.click();
		
		assertTrue(c.mes);
		assertTrue(!c.comments);
		assertTrue(c.citasOp == c.CITAS_NORMALES);
	}
	
	public void testPrintMesEspeciales(){
		
		VentanaStub vs = new VentanaStub();
		ControlStub c = new ControlStub(vs);
		JDPrint jdp = new JDPrint(null, c, "Enero", 2011);
		Panel p = new Panel(jdp);
		
		p.getRadioButton("Citas especiales").click();
		
		Button b = p.getButton("Imprimir");
		b.click();
		
		assertTrue(c.mes);
		assertTrue(!c.comments);
		assertTrue(c.citasOp == c.CITAS_ESPECIALES);
	}
	
	public void testPrintMesTodas(){
		
		VentanaStub vs = new VentanaStub();
		ControlStub c = new ControlStub(vs);
		JDPrint jdp = new JDPrint(null, c, "Enero", 2011);
		Panel p = new Panel(jdp);
		
		p.getRadioButton("Citas normales y especiales").click();
		
		Button b = p.getButton("Imprimir");
		b.click();
		
		assertTrue(c.mes);
		assertTrue(!c.comments);
		assertTrue(c.citasOp == c.CITAS_TODAS);
	}
	
	public void testPrintMesComments(){
		
		VentanaStub vs = new VentanaStub();
		ControlStub c = new ControlStub(vs);
		JDPrint jdp = new JDPrint(null, c, "Enero", 2011);
		Panel p = new Panel(jdp);
		
		p.getCheckBox().click();
		
		Button b = p.getButton("Imprimir");
		b.click();
		
		assertTrue(c.mes);
		assertTrue(c.comments);
		assertTrue(c.citasOp == c.CITAS_NORMALES);
	}
	
	public void testPrintDia(){
		
		VentanaStub vs = new VentanaStub();
		ControlStub c = new ControlStub(vs);
		Lista l = c.getMes("Enero", 2011).getListas().get(15);
		JDPrint jdp = new JDPrint(null, c, "Enero", 2011,l);
		Panel p = new Panel(jdp);
	
		
		Button b = p.getButton("Imprimir");
		b.click();
		
		assertTrue(!c.mes);
		assertTrue(!c.comments);
		assertTrue(c.citasOp == c.CITAS_NORMALES);
	}
	
	
	

	
	
	public void testPrintMesConfigPag(){

		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy4());
		
		VentanaStub vs = new VentanaStub();
		ControlStub c = new ControlStub(vs);
		JDPrint jdp = new JDPrint(null, c, "Enero", 2011);
		Panel p = new Panel(jdp);
		
		Button b = p.getButton("Configurar pgina");
		b.click();
		
		b = p.getButton("Imprimir");
		b.click();
		
		
		
		assertTrue(c.mes);
		assertTrue(!c.comments);
		assertTrue(c.citasOp == c.CITAS_NORMALES);
		
		
	}
	
	
}
