package pruebas.cobertura.presentacion;


import javax.swing.JTextPane;

import mockit.Mockit;

import org.uispec4j.Panel;
import org.uispec4j.TextBox;
import org.uispec4j.UISpecTestCase;

import persistencia.Persistencia;
import pruebas.cobertura.PersistenciaStubsInterfaceVacia;
import pruebas.cobertura.contenedorDiasStub;

import dominio.Cita;
import dominio.Mes;
import dominio.exceptions.CitaConFechaNoAsignadaException;
import dominio.exceptions.CitaYaAsigndaException;

import presentacion.JDiasComponent;

public class TestJDiasComponent extends UISpecTestCase{

	
	//Window window; 
	
	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceVacia.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}
	


	public void testJDiasComponentNMMeses(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
		}
		
		Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		TextBox tb = panel.getTextBox("50");
		assertTrue(tb.getText().startsWith("1_"));
		
		m.setMes("Febrero");
		panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		tb = panel.getTextBox("50");
		assertTrue(tb.getText().startsWith("5_"));
		
		m.setMes("Marzo");
		panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		tb = panel.getTextBox("50");
		assertTrue(tb.getText().startsWith("5_"));
		
		m.setMes("Abril");
		panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		tb = panel.getTextBox("50");
		assertTrue(tb.getText().startsWith("2_"));
		
		m.setMes("Mayo");
		panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		tb = panel.getTextBox("60");
		assertTrue(tb.getText().startsWith("1_"));
		
		m.setMes("Junio");
		panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		tb = panel.getTextBox("50");
		assertTrue(tb.getText().startsWith("4_"));
		
		
		m.setMes("Julio");
		panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		tb = panel.getTextBox("50");
		assertTrue(tb.getText().startsWith("2_"));
		
		m.setMes("Agosto");
		panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		tb = panel.getTextBox("50");
		assertTrue(tb.getText().startsWith("6_"));
		
		
		m.setMes("Septiembre");
		panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		tb = panel.getTextBox("50");
		assertTrue(tb.getText().startsWith("3_"));
		
		
		m.setMes("Octubre");
		panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		tb = panel.getTextBox("50");
		assertTrue(tb.getText().startsWith("1_"));
		
		m.setMes("Noviembre");
		panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		tb = panel.getTextBox("50");
		assertTrue(tb.getText().startsWith("5_"));
		
		m.setMes("Diciembre");
		panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
		tb = panel.getTextBox("50");
		assertTrue(tb.getText().startsWith("3_"));

	}
	
	public void testJDiasComponentNM(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
		}
		
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
		
		

	}

	public void testJDiasComponentML(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
		}
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERLISTAMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
		
		
	}

	public void testJDiasComponentCL(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
		}
		
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.CREARLISTASMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
		
		
	}

	public void testJDiasComponentMC(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
		}
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERLISTAMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
	}



	public void testJDiasComponentNMUnaCita(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				m.asignarCitaConFecha(new Cita("tests", 200+i, "testcomens", 0), i, true);
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
		
		

	}

	public void testJDiasComponentMLUnaCita(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				m.asignarCitaConFecha(new Cita("tests", 200+i, "testcomens", 0), i, true);
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERLISTAMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
		
		
		
	}

	public void testJDiasComponentCLUnaCita(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				m.asignarCitaConFecha(new Cita("tests", 200+i, "testcomens", 0), i, true);
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.CREARLISTASMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
		
		
	}

	public void testJDiasComponentMCUnaCita(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				m.asignarCitaConFecha(new Cita("tests", 200+i, "testcomens", 0), i, true);
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERCITAMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
		
		
	}
	public void testJDiasComponentNMUnaCitaSolo(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
		
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
		
		

	}

	public void testJDiasComponentMLUnaCitaSolo(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERLISTAMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
		
		
	}

	public void testJDiasComponentCLUnaCitaSolo(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.CREARLISTASMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
		
		
	}

	public void testJDiasComponentMCUnaCitaSolo(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 14;i<15;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		for(int i = 2011; i<2021;i++){
			m.setAo(i);
			Panel panel = new Panel(new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERCITAMODE));
			JTextPane tb = ((JDiasComponent)panel.getAwtComponent()).getPanel(1);
			assertTrue(tb.getText().startsWith("1_"));
		}
		
		
		
		
	}
	
	public void testSElectDia(){
		Mes m = new Mes("Enero", 2011);
		contenedorDiasStub cd = new contenedorDiasStub();
		JDiasComponent jdc = new JDiasComponent(m, cd, JDiasComponent.NORMALMODE);
		Panel panel = new Panel(jdc);
		
		jdc.selectDia("50");
		
		assertTrue(cd.jtp.getText().startsWith("1_"));
		assertTrue(cd.dia.equals("1"));
	}
	
	public void testGetPanel(){
		Mes m = new Mes("Enero", 2011);
		contenedorDiasStub cd = new contenedorDiasStub();
		JDiasComponent jdc = new JDiasComponent(m, cd, JDiasComponent.NORMALMODE);
		Panel panel = new Panel(jdc);
		
		JTextPane panelt = jdc.getPanel(13);
		assertTrue(panelt.getText().startsWith("13_"));
	}
	
	
	
	
}
