package pruebas.mutacion.dominio;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.lang.reflect.Field;
import java.util.Hashtable;

import mockit.Mockit;

import persistencia.Persistencia;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;
import configuracion.Configuracion;
import dominio.Control;
import dominio.Mes;
import junit.framework.TestCase;

public class TestCubrirPersistencia_Mut extends TestCase{

	
	
	public void setUp(){
		File f2 = new File("./configurationCitasMed_test");
		if(f2.exists()){
			f2.delete();
		}
		File f = new File("./configurationCitasMed");
		if(f.exists()){
			f.renameTo(f2);
		}

		File fdb = new File("./dataBase_test");
		if(fdb.exists()){
			fdb.delete();
		}

	}

	public void tearDown(){
		 Mockit.tearDownMocks(Persistencia.class);
		File f = new File("./configurationCitasMed");
		if(f.exists()){
			f.delete();
		}
		
		File f2 = new File("./configurationCitasMed_test");
		if(f2.exists()){
			f2.renameTo(f);
		}
		
		File fdb = new File("./dataBase_test");
		if(fdb.exists()){
			fdb.delete();
		}
	}
	
	
	
	public void testBDCotrol() throws IOException, ClassNotFoundException{
		
		 Hashtable<String, Mes> meses = new Hashtable<String, Mes>();
		 meses.put("2011Enero", new Mes("Enero", 2011));
		 File f = new File("./dataBase_test");
		 boolean r = Persistencia.saveDataBase(f, meses);
		 assertTrue(r == true);
		 
		 Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		 Control c = new Control(new VentanaStub());
		 Mockit.tearDownMocks(Persistencia.class);
		
		 
		 Hashtable<String, Mes> meses2 =  c.leerDataBase(f);
		 assertTrue(meses2.size()==1);
		 
	}
	
	public void testBDCotrolNDB() throws Exception{
		
		 Hashtable<String, Mes> meses = new Hashtable<String, Mes>();
		 meses.put("2011Enero", new Mes("Enero", 2011));
		 File f = new File("./dataBase_test");
		 boolean r = Persistencia.saveDataBase(f, meses);
		 assertTrue(r == true);
		 
		 Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		 VentanaStub v = new VentanaStub();
		 Control c = new Control(v);
		 Mockit.tearDownMocks(Persistencia.class);
		
		 
		 Field fil = c.getClass().getDeclaredField("c");
		 fil.setAccessible(true);
		 Configuracion cf = (Configuracion) fil.get(c);
		 
		 cf.setPathBaseCitas(null);
		 
		 c.nuevaDataBase(f);
		 assertTrue(v.errors.size()==0);
		 
	}
	
	public void testBDCotrolCDB() throws Exception{
		
		 Hashtable<String, Mes> meses = new Hashtable<String, Mes>();
		 meses.put("2011Enero", new Mes("Enero", 2011));
		 File f = new File("./dataBase_test");
		 boolean r = Persistencia.saveDataBase(f, meses);
		 assertTrue(r == true);
		 
		 Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		 VentanaStub v = new VentanaStub();
		 Control c = new Control(v);
		 Mockit.tearDownMocks(Persistencia.class);
		
		 
		 Field fil = c.getClass().getDeclaredField("c");
		 fil.setAccessible(true);
		 Configuracion cf = (Configuracion) fil.get(c);
		 
		 cf.setPathBaseCitas(null);
		 
		 c.cambiarDataBase(f);
		 assertTrue(v.errors.size()==0);
		 
	}
}
