package pruebas.mutacion.dominio;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.awt.print.PageFormat;
import java.awt.print.Paper;
import java.awt.print.PrinterException;
import java.lang.reflect.Field;
import java.text.AttributedCharacterIterator;
import java.util.Calendar;
import java.util.Vector;

import javax.swing.DebugGraphics;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;

import mockit.Mockit;

import junit.framework.TestCase;

import com.jrefinery.report.Group;
import com.jrefinery.report.GroupHeader;
import com.jrefinery.report.ItemBand;
import com.jrefinery.report.JFreeReport;
import com.jrefinery.report.PageHeader;
import com.jrefinery.report.ShapeElement;
import com.jrefinery.report.TextElement;
import com.jrefinery.report.targets.base.bandlayout.StaticLayoutManager;
import com.jrefinery.report.targets.pageable.PageableReportProcessor;
import com.jrefinery.report.targets.style.ElementStyleSheet;
import com.jrefinery.report.util.PageFormatFactory;

import persistencia.Persistencia;
import pruebas.cobertura.MyCalendar;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;
import pruebas.cobertura.WPrinterJobMy;
import pruebas.cobertura.WPrinterJobMy3;
import pruebas.cobertura.WPrinterJobMy5;
import sun.awt.windows.WPrinterJob;
import sun.print.RasterPrinterJob;
import dominio.Cita;
import dominio.Control;
import dominio.Mes;
import dominio.Printer;
import dominio.reportes.ReportePrinter;

public class TestCubrirReportPrinter_Mut extends TestCase{

	Control c;
	VentanaStub v;
	
	public void setUp(){
		
		
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		Mockit.setUpMock(Calendar.class,MyCalendar.class);
		c = null;
		v = null;
		
		
		v = new VentanaStub();
		c = new Control(v);
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		Mockit.tearDownMocks(Calendar.class);
		Mockit.tearDownMocks(WPrinterJob.class);
		Mockit.tearDownMocks(RasterPrinterJob.class);
	}
	
	
	public void testUno(){
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		
		Vector<String[]> datosV = new Vector<String[]>();

		for(int i = 0; i<5;i++){
			String [] s = new String [5];
			s[0] =  "Sin da";
			s[1] = "test"+i;
			s[2] = (1000+i)+"";
			s[3] = "comentario "+i;
			s[4] = "";
			datosV.add(s);
		}
		
		for(int i = 0; i<5;i++){
			for(int j = 0; j<3;j++){
				String [] s = new String [5];
				s[0] =  i+ "";
				s[1] = "test"+i+j;
				s[2] = (2000+(10*i)+j)+"";
				s[3] = "comentario "+i+"_"+j;
				s[4] = "";
				datosV.add(s);
			}
			
		}
		
		for(int i = 0; i<5;i++){
			for(int j = 0; j<3;j++){
				String [] s = new String [5];
				s[0] =  i+ "";
				s[1] = "test"+i+j;
				s[2] = (3000+(10*i)+j)+"";
				s[3] = "comentario especial "+i+"_"+j;
				s[4] = "Cita especial";
				datosV.add(s);
			}
			
		}
		
		String [] columnas = {"dia","nombre", "nh", "comentarios", "especial"};
		String [][] datos = new String[datosV.size()][];
		for(int i = 0; i<datosV.size();i++){
			datos[i] = datosV.get(i);
		}
		DefaultTableModel model	= new DefaultTableModel(datos, columnas);

		
		JFreeReport reporte = rp.createReport(model, "Enero", 2011, true, pf);
		
		PageHeader ph = reporte.getPageHeader();
		assertTrue(ph.getElement(0) instanceof TextElement);
		
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ph.getElement(0)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 15);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ph.getElement(0)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 500);
		assertTrue(((Point2D.Float)((TextElement)ph.getElement(0)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x == 0);
		assertTrue(((Point2D.Float)((TextElement)ph.getElement(0)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y == 0);
		
		
		
		assertTrue(((TextElement)ph.getElement(0)).getDataSource().getValue().equals("Enero de 2011"));
		assertTrue(ph.getElement(1) instanceof ShapeElement);
		assertTrue(((Line2D)((ShapeElement)ph.getElement(1)).getDataSource().getValue()).getX1() == 0);
		assertTrue(((Line2D)((ShapeElement)ph.getElement(1)).getDataSource().getValue()).getY1() == 0);
		assertTrue(((Line2D)((ShapeElement)ph.getElement(1)).getDataSource().getValue()).getX2()+"",((Line2D)((ShapeElement)ph.getElement(1)).getDataSource().getValue()).getX2() == 595);
		assertTrue(((Line2D)((ShapeElement)ph.getElement(1)).getDataSource().getValue()).getY2() == 0);
		
		assertTrue(reporte.getGroups().size()+"",reporte.getGroups().size()==2);
		
		Group g = reporte.getGroup(1);
		assertTrue(g.getFields().size()==1);
		
		GroupHeader gh = g.getHeader();
		
		assertTrue(gh.getElement(0) instanceof TextElement);
		assertTrue(((TextElement)gh.getElement(0)).getDataSource().getValue().equals("Nombre"));
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(0)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 20);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(0)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 257);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(0)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x==85);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(0)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y==20);
		
		
		assertTrue(gh.getElement(1) instanceof TextElement);
		assertTrue(((TextElement)gh.getElement(1)).getDataSource().getValue().equals("Nmero de Historia"));
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(1)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 20);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(1)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 81);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(1)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x == 0);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(1)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y==20);
		
		
		
		assertTrue(gh.getElement(2) instanceof TextElement);
		assertTrue(((TextElement)gh.getElement(2)).getDataSource().getValue().equals("Comentarios"));
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(2)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 20);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(2)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 257);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(2)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x == 290);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(2)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y==20);
		
		
		
		assertTrue(gh.getElement(3) instanceof TextElement);
		assertTrue(((TextElement)gh.getElement(3)).getDataSource().getValue().equals("Da  "));
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(3)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 25);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(3)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 30);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(3)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x == 0);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(3)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y == 5);
		
		
		
		assertTrue(gh.getElement(4) instanceof TextElement);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(4)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 25);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(4)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 100);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(4)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x == 30);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(4)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y==5);
		
		
		
		ItemBand ib = reporte.getItemBand();
		
		assertTrue(ib.getElement(0) instanceof ShapeElement);
		assertTrue(((Line2D)((ShapeElement)ib.getElement(0)).getDataSource().getValue()).getX1() == 0);
		assertTrue(((Line2D)((ShapeElement)ib.getElement(0)).getDataSource().getValue()).getY1() == 0);
		assertTrue(((Line2D)((ShapeElement)ib.getElement(0)).getDataSource().getValue()).getX2() == 595);
		assertTrue(((Line2D)((ShapeElement)ib.getElement(0)).getDataSource().getValue()).getY2() == 0);
		
		
		assertTrue(ib.getElement(1) instanceof TextElement);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ib.getElement(1)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 20);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ib.getElement(1)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 257);
		assertTrue(((Point2D.Float)((TextElement)ib.getElement(1)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x==85);
		assertTrue(((Point2D.Float)((TextElement)ib.getElement(1)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y==5);
				
		
		assertTrue(ib.getElement(2) instanceof TextElement);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ib.getElement(2)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 20);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ib.getElement(2)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 81);
		assertTrue(((Point2D.Float)((TextElement)ib.getElement(2)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x == 5);
		assertTrue(((Point2D.Float)((TextElement)ib.getElement(2)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y== 5);
		
		assertTrue(ib.getElement(3) instanceof TextElement);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ib.getElement(3)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 20);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ib.getElement(3)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 257);
		assertTrue(((Point2D.Float)((TextElement)ib.getElement(3)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x==290);
		assertTrue(((Point2D.Float)((TextElement)ib.getElement(3)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y == 5);
		
		assertTrue(reporte.getData().equals(model));
		
		
	}
	
	
	public void testDos(){
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		
		Vector<String[]> datosV = new Vector<String[]>();

		for(int i = 0; i<5;i++){
			String [] s = new String [5];
			s[0] =  "Sin da";
			s[1] = "test"+i;
			s[2] = (1000+i)+"";
			s[3] = "comentario "+i;
			s[4] = "";
			datosV.add(s);
		}
		
		for(int i = 0; i<5;i++){
			for(int j = 0; j<3;j++){
				String [] s = new String [5];
				s[0] =  i+ "";
				s[1] = "test"+i+j;
				s[2] = (2000+(10*i)+j)+"";
				s[3] = "comentario "+i+"_"+j;
				s[4] = "";
				datosV.add(s);
			}
			
		}
		
		for(int i = 0; i<5;i++){
			for(int j = 0; j<3;j++){
				String [] s = new String [5];
				s[0] =  i+ "";
				s[1] = "test"+i+j;
				s[2] = (3000+(10*i)+j)+"";
				s[3] = "comentario especial "+i+"_"+j;
				s[4] = "Cita especial";
				datosV.add(s);
			}
			
		}
		
		String [] columnas = {"dia","nombre", "nh", "comentarios", "especial"};
		String [][] datos = new String[datosV.size()][];
		for(int i = 0; i<datosV.size();i++){
			datos[i] = datosV.get(i);
		}
		DefaultTableModel model	= new DefaultTableModel(datos, columnas);

		
		JFreeReport reporte = rp.createReport(model, "Enero", 2011, false, pf);
		
		PageHeader ph = reporte.getPageHeader();
		assertTrue(ph.getElement(0) instanceof TextElement);
		
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ph.getElement(0)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 15);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ph.getElement(0)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 500);
		assertTrue(((Point2D.Float)((TextElement)ph.getElement(0)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x == 0);
		assertTrue(((Point2D.Float)((TextElement)ph.getElement(0)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y == 0);
		
		
		
		assertTrue(((TextElement)ph.getElement(0)).getDataSource().getValue().equals("Enero de 2011"));
		assertTrue(ph.getElement(1) instanceof ShapeElement);
		assertTrue(((Line2D)((ShapeElement)ph.getElement(1)).getDataSource().getValue()).getX1() == 0);
		assertTrue(((Line2D)((ShapeElement)ph.getElement(1)).getDataSource().getValue()).getY1() == 0);
		assertTrue(((Line2D)((ShapeElement)ph.getElement(1)).getDataSource().getValue()).getX2()+"",((Line2D)((ShapeElement)ph.getElement(1)).getDataSource().getValue()).getX2() == 595);
		assertTrue(((Line2D)((ShapeElement)ph.getElement(1)).getDataSource().getValue()).getY2() == 0);
		
		assertTrue(reporte.getGroups().size()+"",reporte.getGroups().size()==2);
		
		Group g = reporte.getGroup(1);
		assertTrue(g.getFields().size()==1);
		
		GroupHeader gh = g.getHeader();
		
		assertTrue(gh.getElement(0) instanceof TextElement);
		assertTrue(((TextElement)gh.getElement(0)).getDataSource().getValue().equals("Nombre"));
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(0)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 20);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(0)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 514);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(0)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x==85);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(0)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y==20);
		
		
		
		assertTrue(gh.getElement(1) instanceof TextElement);
		assertTrue(((TextElement)gh.getElement(1)).getDataSource().getValue().equals("Nmero de Historia"));
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(1)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 20);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(1)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 81);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(1)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x == 0);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(1)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y==20);
		
		
		
		/*assertTrue(gh.getElement(2) instanceof TextElement);
		assertTrue(((TextElement)gh.getElement(2)).getDataSource().getValue().equals("Comentarios"));
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(2)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 20);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(2)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 257);
		*/
		
		
		assertTrue(gh.getElement(2) instanceof TextElement);
		assertTrue(((TextElement)gh.getElement(2)).getDataSource().getValue().equals("Da  "));
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(2)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 25);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(2)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 30);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(2)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x == 0);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(2)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y == 5);
		
		assertTrue(gh.getElement(3) instanceof TextElement);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(3)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 25);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)gh.getElement(3)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 100);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(3)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x == 30);
		assertTrue(((Point2D.Float)((TextElement)gh.getElement(3)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y==5);
		
		
		
		ItemBand ib = reporte.getItemBand();
		
		assertTrue(ib.getElement(0) instanceof ShapeElement);
		assertTrue(((Line2D)((ShapeElement)ib.getElement(0)).getDataSource().getValue()).getX1() == 0);
		assertTrue(((Line2D)((ShapeElement)ib.getElement(0)).getDataSource().getValue()).getY1() == 0);
		assertTrue(((Line2D)((ShapeElement)ib.getElement(0)).getDataSource().getValue()).getX2() == 595);
		assertTrue(((Line2D)((ShapeElement)ib.getElement(0)).getDataSource().getValue()).getY2() == 0);
		
		
		assertTrue(ib.getElement(1) instanceof TextElement);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ib.getElement(1)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 20);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ib.getElement(1)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 514);
		assertTrue(((Point2D.Float)((TextElement)ib.getElement(1)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x==85);
		assertTrue(((Point2D.Float)((TextElement)ib.getElement(1)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y==5);
		
		
		assertTrue(ib.getElement(2) instanceof TextElement);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ib.getElement(2)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getHeight() == 20);
		assertTrue(((org.jfree.ui.FloatDimension)((TextElement)ib.getElement(2)).getStyle().getStyleProperty(ElementStyleSheet.MINIMUMSIZE)).getWidth() == 81);
		assertTrue(((Point2D.Float)((TextElement)ib.getElement(2)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).x == 5);
		assertTrue(((Point2D.Float)((TextElement)ib.getElement(2)).getStyle().getStyleProperty(StaticLayoutManager.ABSOLUTE_POS)).y== 5);
		
		
		assertTrue(reporte.getData().equals(model));
		
		
	}
	
	public void testPrintMesAo(){
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		

		boolean ret = rp.imprimirMes("Enero", 2011, Control.CITAS_NORMALES, true, pf,null );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==3);
	}
	
	public void testPrintOpcionesCitas(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = rp.imprimirMes("Enero", 2011, Control.CITAS_NORMALES, true, pf,c.getMes("Enero", 2011).getListas().elements().nextElement() );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==1);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	
	public void testPrintOpcionesCitas2(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = rp.imprimirMes("Enero", 2011, Control.CITAS_ESPECIALES, true, pf,c.getMes("Enero", 2011).getListas().elements().nextElement() );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==1);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void testPrintOpcionesCitasMes(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = rp.imprimirMes("Enero", 2011, Control.CITAS_NORMALES, true, pf,null );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==3);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==8);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	
	public void testPrintOpcionesCitas2Mes(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = rp.imprimirMes("Enero", 2011, Control.CITAS_ESPECIALES, true, pf,null );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==2);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==2);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void testPrintOpcionesCitas2MesEspecialesSinFecha(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		Mes m = c.getMes("Enero", 2011);
		m.getSinAsignarDaEspecial().put(1234, new Cita("testEsSF",1234,"coment",0));
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = rp.imprimirMes("Enero", 2011, Control.CITAS_ESPECIALES, true, pf,null );
		assertTrue(ret == true);
		assertTrue(mpj.printed==true);
		assertTrue(mpj.b.getNumberOfPages()==3);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==3);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	

	public void testControlImprimirMes(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = c.imprimirMes("Enero", 2011, Control.CITAS_ESPECIALES, true, pf);
		
		//boolean ret = rp.imprimirMes("Enero", 2011, Control.CITAS_ESPECIALES, true, pf,null );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==2);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==2);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void testControlImprimirDia(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		c.addCitaEspecial(1234, "test1234", "coment", 0, 2011, "Enero", 14);
		
		boolean ret = c.imprimirDia("Enero", 2011, Control.CITAS_ESPECIALES, true, pf, c.getMes("Enero", 2011).getListas().get(14));
		
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==2);
			assertTrue(reporte.getReportHeader().getElement(0).getDataSource().getValue().equals("Enero de 2011"));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void testControlImprimirDiaTodas(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = c.imprimirDia("Enero", 2011, Control.CITAS_TODAS, true, pf, c.getMes("Enero", 2011).getListas().get(14));
		
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==2);
			assertTrue(reporte.getReportHeader().getElement(0).getDataSource().getValue().equals("Enero de 2011"));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	
	public void testControlImprimirMesTodas(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = c.imprimirDia("Enero", 2011, Control.CITAS_TODAS, true, pf, null);
		
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==3);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==10);
			assertTrue(reporte.getReportHeader().getElement(0).getDataSource().getValue().equals("Enero de 2011"));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void testControlImprimirMesNormalesConEspeciales(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		c.getMes("Enero", 2011).getSinAsignarDaEspecial().put(12345, new Cita("especial",12345, "coment", 0));
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = c.imprimirDia("Enero", 2011, Control.CITAS_NORMALES, true, pf, null);
		
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==3);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==8);
			assertTrue(reporte.getReportHeader().getElement(0).getDataSource().getValue().equals("Enero de 2011"));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void testControlImprimirMesTodas2(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		c.getMes("Enero", 2011).getSinAsignarDaEspecial().put(12345, new Cita("especial",12345, "coment", 0));
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = c.imprimirDia("Enero", 2011, Control.CITAS_TODAS, true, pf, null);
		
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==3);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==11);
			assertTrue(reporte.getReportHeader().getElement(0).getDataSource().getValue().equals("Enero de 2011"));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	
	public void testPrinDialogFalse(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy5());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = c.imprimirDia("Enero", 2011, Control.CITAS_TODAS, true, pf, null);
		
		assertTrue(ret == true);
		assertTrue(mpj.printed==false);
		
		
		
	}
	
	public void testPrinterPage() throws PrinterException{
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = c.imprimirDia("Enero", 2011, Control.CITAS_TODAS, true, pf, null);
		
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==3);
		Printer p = (Printer) mpj.b.getPrintable(0);
		
		BufferedImage image = new BufferedImage((int)pf.getWidth(),(int)pf.getHeight(), BufferedImage.TYPE_INT_ARGB);
		Graphics2D g2 = (Graphics2D) image.getGraphics();
		int i = p.print(g2, pf, 2);
		
		assertTrue(i==0);
		
	}
	
	
	public void testNombreReport(){
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		
		Vector<String[]> datosV = new Vector<String[]>();

		for(int i = 0; i<5;i++){
			String [] s = new String [5];
			s[0] =  "Sin da";
			s[1] = "test"+i;
			s[2] = (1000+i)+"";
			s[3] = "comentario "+i;
			s[4] = "";
			datosV.add(s);
		}
		
		for(int i = 0; i<5;i++){
			for(int j = 0; j<3;j++){
				String [] s = new String [5];
				s[0] =  i+ "";
				s[1] = "test"+i+j;
				s[2] = (2000+(10*i)+j)+"";
				s[3] = "comentario "+i+"_"+j;
				s[4] = "";
				datosV.add(s);
			}
			
		}
		
		for(int i = 0; i<5;i++){
			for(int j = 0; j<3;j++){
				String [] s = new String [5];
				s[0] =  i+ "";
				s[1] = "test"+i+j;
				s[2] = (3000+(10*i)+j)+"";
				s[3] = "comentario especial "+i+"_"+j;
				s[4] = "Cita especial";
				datosV.add(s);
			}
			
		}
		
		String [] columnas = {"dia","nombre", "nh", "comentarios", "especial"};
		String [][] datos = new String[datosV.size()][];
		for(int i = 0; i<datosV.size();i++){
			datos[i] = datosV.get(i);
		}
		DefaultTableModel model	= new DefaultTableModel(datos, columnas);

		
		JFreeReport reporte = rp.createReport(model, "Enero", -2011, false, pf);
		
		assertTrue(reporte.getName().equals("Reporte de Enero de -2011."));
		
		
	}
	
	public void testPrinterPage2() throws PrinterException{
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = c.imprimirMes("Enero", 2011, Control.CITAS_TODAS, true, pf);
		
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==3);
		Printer p = (Printer) mpj.b.getPrintable(0);
		
		BufferedImage image = new BufferedImage((int)pf.getWidth(),(int)pf.getHeight(), BufferedImage.TYPE_INT_ARGB);
		Graphics2D g2 = (Graphics2D) image.getGraphics();
		int i = p.print(g2, pf, 4);
		
		assertTrue(i==1);
		
	}
	
	public void testPrinterPage3() throws PrinterException{
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = c.imprimirMes("Enero", 2011, Control.CITAS_TODAS, true, pf);
		
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==3);
		Printer p = (Printer) mpj.b.getPrintable(0);
		
		BufferedImage image = new BufferedImage((int)pf.getWidth(),(int)pf.getHeight(), BufferedImage.TYPE_INT_ARGB);
		Graphics2D g2 = (Graphics2D) image.getGraphics();
		int i = p.print(g2, pf, 3);
		
		assertTrue(i==1);
		
	}
	
	
	public void testControlImprimirAoNeg(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		c.getMes("Enero", -2011).getSinAsignarDaEspecial().put(12345, new Cita("especial",12345, "coment", 0));
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = c.imprimirDia("Enero", -2011, Control.CITAS_TODAS, true, pf, null);
		
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==1);
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void testPageHeader(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		Vector<String[]> datosV = new Vector<String[]>();

		for(int i = 0; i<5;i++){
			String [] s = new String [5];
			s[0] =  "Sin da";
			s[1] = "test"+i;
			s[2] = (1000+i)+"";
			s[3] = "comentario "+i;
			s[4] = "";
			datosV.add(s);
		}
		
		for(int i = 0; i<5;i++){
			for(int j = 0; j<3;j++){
				String [] s = new String [5];
				s[0] =  i+ "";
				s[1] = "test"+i+j;
				s[2] = (2000+(10*i)+j)+"";
				s[3] = "comentario "+i+"_"+j;
				s[4] = "";
				datosV.add(s);
			}
			
		}
		
		for(int i = 0; i<5;i++){
			for(int j = 0; j<3;j++){
				String [] s = new String [5];
				s[0] =  i+ "";
				s[1] = "test"+i+j;
				s[2] = (3000+(10*i)+j)+"";
				s[3] = "comentario especial "+i+"_"+j;
				s[4] = "Cita especial";
				datosV.add(s);
			}
			
		}
		
		String [] columnas = {"dia","nombre", "nh", "comentarios", "especial"};
		String [][] datos = new String[datosV.size()][];
		for(int i = 0; i<datosV.size();i++){
			datos[i] = datosV.get(i);
		}
		DefaultTableModel model	= new DefaultTableModel(datos, columnas);
		
		JFreeReport reporte = rp.createReport(model, "Enero", -2011, true, pf);
		
		assertTrue(reporte.getPageHeader().getElement(0).getDataSource().getValue().equals("Enero de -2011"));
		
	}
}
