package pruebas.mutacion.dominio;

import junit.framework.TestCase;


import dominio.Cita;
import dominio.Lista;
import dominio.Mes;
import dominio.ResultadoBusqueda;
import dominio.exceptions.CitaConFechaNoAsignadaException;
import dominio.exceptions.CitaYaAsigndaException;

public class TestCubrirResultadosBusqueda_Mut extends TestCase{

	

	
	/**********para mutacion*******************/
	
	public void testRB2() throws CitaConFechaNoAsignadaException, CitaYaAsigndaException{
		
		Cita cita = new Cita("c1", 1, "cm1", 0);
		
		Cita cita2 = new Cita("c21", 2, "cm2", 0);
		Lista l2 = new Lista(5, "Enero", 2011, 10);
		l2.addAsignado(cita2);
		
		Mes m2 = new Mes("Enero", 2011);
		Lista l = new Lista(5, "Enero", 2011, 10);
		l.addAsignado(cita);
		Mes m = new Mes("Enero", 2011);
		
		ResultadoBusqueda rb = new ResultadoBusqueda(cita, l, m, false);
		
		assertTrue(rb.getC()== cita);
		assertTrue(rb.getL() == l);
		assertTrue(rb.getM() == m);
		assertTrue(rb.isEspecial() == false);
		
		rb.setC(cita2);
		assertTrue(rb.getC()== cita2);
		
		rb.setEspecial(true);
		assertTrue(rb.isEspecial() == true);
		
		rb.setL(l2);
		assertTrue(rb.getL() == l2);
		
		rb.setM(m2);
		assertTrue(rb.getM() == m2);
	}
	
}
