package pruebas.mutacion.dominio;


import java.io.File;
import java.lang.reflect.Method;
import java.util.Calendar;

import persistencia.Persistencia;
import presentacion.IVentana;
import pruebas.cobertura.MyCalendar2;
import pruebas.cobertura.MyCalendar3;
import pruebas.cobertura.PersistenciaStubsInterfaceF;
import pruebas.cobertura.VentanaStub;
import dominio.Control;

import mockit.Mockit;
import junit.framework.TestCase;



public class TestFechas_Mut extends TestCase{


	Control c;
	
	public void setUp(){		
		c = null;
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterfaceF.class);

	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		Mockit.tearDownMocks(Calendar.class);
		
	}
	
	
	
	/********************Para mutacin************************/
	
	public void testBorrarMesesDelMismoAo(){
		
		Mockit.setUpMock(Calendar.class,MyCalendar3.class);
		
		IVentana v = new VentanaStub();
		c = new Control(v);
		
		c.setConfiguration(2);
		try {
			
			System.out.println(Calendar.getInstance().get(Calendar.MONTH));
			
			c.cambiarDataBase(new File("."));
				
			assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Febrero", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Marzo", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Abril", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Mayo", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Junio", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Julio", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Agosto", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Septiembre", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Octubre", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Noviembre", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Diciembre", 2011).getSinAsignarDa().size()==6);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	
	public void testBorrarMesesDelMismoAo2(){
		
		Mockit.setUpMock(Calendar.class,MyCalendar2.class);
		
		IVentana v = new VentanaStub();
		c = new Control(v);
		
		c.setConfiguration(7);
		try {
			
			
			
			c.cambiarDataBase(new File("."));
				
			assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Febrero", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Marzo", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Abril", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Mayo", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Junio", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Julio", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Agosto", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Septiembre", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Octubre", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Noviembre", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Diciembre", 2011).getSinAsignarDa().size()==6);
			
			assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Febrero", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Marzo", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Abril", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Mayo", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Junio", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Julio", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Agosto", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Septiembre", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Octubre", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Noviembre", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Diciembre", 2012).getSinAsignarDa().size()==6);
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	
	public void testBorrarMesesDelMismoAo3(){
		
		Mockit.setUpMock(Calendar.class,MyCalendar2.class);
		
		IVentana v = new VentanaStub();
		c = new Control(v);
		
		c.setConfiguration(19);
		try {
			
			
			
			c.cambiarDataBase(new File("."));
				
			assertTrue(c.getMes("Enero", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Febrero", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Marzo", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Abril", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Mayo", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Junio", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Julio", 2010).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Agosto", 2010).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Septiembre", 2010).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Octubre", 2010).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Noviembre", 2010).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Diciembre", 2010).getSinAsignarDa().size()==6);
			
			assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Febrero", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Marzo", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Abril", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Mayo", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Junio", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Julio", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Agosto", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Septiembre", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Octubre", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Noviembre", 2011).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Diciembre", 2011).getSinAsignarDa().size()==6);
			
			assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Febrero", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Marzo", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Abril", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Mayo", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Junio", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Julio", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Agosto", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Septiembre", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Octubre", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Noviembre", 2012).getSinAsignarDa().size()==6);
			assertTrue(c.getMes("Diciembre", 2012).getSinAsignarDa().size()==6);
			
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void testBorrarMesesTSMegativo(){
		
		Mockit.setUpMock(Calendar.class,MyCalendar2.class);
		
		IVentana v = new VentanaStub();
		c = new Control(v);
		
		c.setConfiguration(-19);
		try {
			
			
			
			c.cambiarDataBase(new File("."));
				
			assertTrue(c.getMes("Enero", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Febrero", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Marzo", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Abril", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Mayo", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Junio", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Julio", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Agosto", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Septiembre", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Octubre", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Noviembre", 2010).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Diciembre", 2010).getSinAsignarDa().size()==0);
			
			assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Febrero", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Marzo", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Abril", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Mayo", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Junio", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Julio", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Agosto", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Septiembre", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Octubre", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Noviembre", 2011).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Diciembre", 2011).getSinAsignarDa().size()==0);
			
			assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Febrero", 2012).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Marzo", 2012).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Abril", 2012).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Mayo", 2012).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Junio", 2012).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Julio", 2012).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Agosto", 2012).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Septiembre", 2012).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Octubre", 2012).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Noviembre", 2012).getSinAsignarDa().size()==0);
			assertTrue(c.getMes("Diciembre", 2012).getSinAsignarDa().size()==0);
			
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	private void llamarABorrarData(){
		try{
			Method m = c.getClass().getDeclaredMethod("borrarExtraData");
			m.setAccessible(true);
			m.invoke(c);
		}catch(Exception e){
			fail(e.getMessage());
		}
	}
	
	public void testBorrarMesesTSMegativo2(){
		
		Mockit.setUpMock(Calendar.class,MyCalendar2.class);
		
		IVentana v = new VentanaStub();
		c = new Control(v);
		
		c.setConfiguration(2000*12);
		
		c.addCitaSinFecha(123, "pedro", "", 0, -20140, "Enero");
		
		try {
			
			this.llamarABorrarData();
				
			assertTrue(c.getMes("Enero", -20140).getSinAsignarDa().size()==0);
			
			
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void testBorrarMesesTSMegativo3(){
		
		Mockit.setUpMock(Calendar.class,MyCalendar2.class);
		
		IVentana v = new VentanaStub();
		c = new Control(v);
		
		c.setConfiguration(4044*12);
		
		c.addCitaSinFecha(123, "pedro", "", 0, 1800, "Enero");
		
		try {
			
			this.llamarABorrarData();
				
			assertTrue(c.getMes("Enero", 1800).getSinAsignarDa().size()==1);
			
			
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	
	public void testBorrarMesesTSMegativo4(){
		
		Mockit.setUpMock(Calendar.class,MyCalendar2.class);
		
		IVentana v = new VentanaStub();
		c = new Control(v);
		
		c.setConfiguration(4044*12);
		
		c.addCitaSinFecha(123, "pedro", "", 0, 2032, "Enero");
		
		try {
			
			this.llamarABorrarData();
				
			assertTrue(c.getMes("Enero", 2032).getSinAsignarDa().size()==1);
			
			
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
}
