package pruebas.mutacion.dominio;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.awt.print.PageFormat;
import java.awt.print.Paper;
import java.awt.print.PrinterException;
import java.lang.reflect.Field;
import java.text.AttributedCharacterIterator;
import java.util.Calendar;
import java.util.Vector;

import javax.swing.DebugGraphics;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;

import mockit.Mockit;

import junit.framework.TestCase;

import com.jrefinery.report.Group;
import com.jrefinery.report.GroupHeader;
import com.jrefinery.report.ItemBand;
import com.jrefinery.report.JFreeReport;
import com.jrefinery.report.PageHeader;
import com.jrefinery.report.ShapeElement;
import com.jrefinery.report.TextElement;
import com.jrefinery.report.targets.base.bandlayout.StaticLayoutManager;
import com.jrefinery.report.targets.pageable.PageableReportProcessor;
import com.jrefinery.report.targets.style.ElementStyleSheet;
import com.jrefinery.report.util.PageFormatFactory;

import persistencia.Persistencia;
import pruebas.cobertura.MyCalendar;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;
import pruebas.cobertura.WPrinterJobMy;
import pruebas.cobertura.WPrinterJobMy3;
import pruebas.cobertura.WPrinterJobMy5;
import sun.awt.windows.WPrinterJob;
import sun.print.RasterPrinterJob;
import dominio.Cita;
import dominio.Control;
import dominio.Mes;
import dominio.Printer;
import dominio.reportes.ReportePrinter;

public class TestPrintReports_Mut extends TestCase{

	Control c;
	VentanaStub v;
	
	public void setUp(){
		
		
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		Mockit.setUpMock(Calendar.class,MyCalendar.class);
		c = null;
		v = null;
		
		v = new VentanaStub();
		c = new Control(v);
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		Mockit.tearDownMocks(Calendar.class);
		Mockit.tearDownMocks(WPrinterJob.class);
		Mockit.tearDownMocks(RasterPrinterJob.class);
	}
	
	
	
	
	
	
	
	
	
	public void testPrintOpcionesCitas(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = rp.imprimirMes("Enero", 2011, -1, true, pf,c.getMes("Enero", 2011).getListas().elements().nextElement() );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==0);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void testPrintOpcionesCitas2(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = rp.imprimirMes("Enero", 2011, -2, true, pf,c.getMes("Enero", 2011).getListas().elements().nextElement() );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==0);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	public void testPrintOpcionesCitas3(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = rp.imprimirMes("Enero", 2011, 3, true, pf,c.getMes("Enero", 2011).getListas().elements().nextElement() );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==0);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
public void testPrintOpcionesCitas4(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		
		c.getMes("Enero", 2011).getSinAsignarDaEspecial().put(123, new Cita("pedro", 123, "coment", 0));
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = rp.imprimirMes("Enero", 2011, -1, true, pf,null );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==0);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public void testPrintOpcionesCitas5(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		c.getMes("Enero", 2011).getSinAsignarDaEspecial().put(123, new Cita("pedro", 123, "coment", 0));
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = rp.imprimirMes("Enero", 2011, -2, true, pf,null );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==0);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	public void testPrintOpcionesCitas6(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		ReportePrinter rp = new ReportePrinter(c);
		c.getMes("Enero", 2011).getSinAsignarDaEspecial().put(123, new Cita("pedro", 123, "coment", 0));
		
		PageFormatFactory pff = PageFormatFactory.getInstance();
		Paper paper = pff.createPaper(PageFormatFactory.A4);
		pff.setBordersMm (paper, 25, 25, 25, 25);
		PageFormat pf = pff.createPageFormat (paper, PageFormat.PORTRAIT);
		
		
		boolean ret = rp.imprimirMes("Enero", 2011, 3, true, pf,null );
		assertTrue(ret == true);
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer p = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = p.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(p);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==0);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	
}
