package pruebas.mutacion.presentacion;

import java.awt.Component;
import java.awt.print.PageFormat;
import java.io.IOException;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.Calendar;
import java.util.Properties;
import java.util.Vector;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.table.TableModel;

import mockit.Mock;
import mockit.Mockit;

import org.uispec4j.MenuItem;
import org.uispec4j.Panel;
import org.uispec4j.Spinner;
import org.uispec4j.Table;
import org.uispec4j.TextBox;
import org.uispec4j.Trigger;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.Window;
import org.uispec4j.finder.ComponentMatcher;
import org.uispec4j.interception.BasicHandler;
import org.uispec4j.interception.FileChooserHandler;
import org.uispec4j.interception.WindowHandler;
import org.uispec4j.interception.WindowInterceptor;

import com.jrefinery.report.JFreeReport;
import com.jrefinery.report.targets.pageable.PageableReportProcessor;

import dominio.Cita;
import dominio.Control;
import dominio.Lista;
import dominio.Mes;
import dominio.Printer;

import persistencia.Persistencia;
import presentacion.CitasMEd;
import presentacion.JDiasComponent;
import pruebas.cobertura.MyCalendar;
import pruebas.cobertura.MyControlError;
import pruebas.cobertura.MySystem;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;
import pruebas.cobertura.WPrinterJobMy;
import pruebas.cobertura.WPrinterJobMy3;
import pruebas.cobertura.WindowCloser;
import pruebas.cobertura.presentacion.TestCitasMed;
import sun.awt.windows.WPrinterJob;
import sun.print.RasterPrinterJob;

public class TestCitasMedImprimir_Mut extends UISpecTestCase{

	public Control c;
	public VentanaStub v;
	
	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		Mockit.setUpMock(Calendar.class,MyCalendar.class);
		c= null;
		v = null;
		
		v = new VentanaStub();
		c = new Control(v);
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);

		Mockit.tearDownMocks(Calendar.class);
		Mockit.tearDownMocks(WPrinterJob.class);
		Mockit.tearDownMocks(RasterPrinterJob.class);
		
	}
	
	
	
	public void testMenusImprimir(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
    	
		
		MenuItem m = p.getMenuBar().getMenu("Imprimir");
		MenuItem mp = m.getSubMenu("Imprimir mes");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	        	return window.getButton("Imprimir").triggerClick();
	        }
	      }).run();
		
		
		assertTrue(mpj.b.getNumberOfPages()==3);
		Printer print = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = print.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(print);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==8);
			assertTrue(reporte.getPageHeader().getElement(0).getDataSource().getValue().equals("Enero de 2011"));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		assertTrue(c.getMes("Enero", 2011).getListas().size()==2);
	}
	
	
	public void testMenusImprimirDia(){
		
		WPrinterJobMy3 mpj = new WPrinterJobMy3();
		Mockit.setUpMock(WPrinterJob.class,new WPrinterJobMy());
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
    	
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		MenuItem m = p.getMenuBar().getMenu("Imprimir");
		MenuItem mp = m.getSubMenu("Imprimir da");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	        	return window.getButton("Imprimir").triggerClick();
	        }
	      }).run();
		
		
		assertTrue(mpj.b.getNumberOfPages()==1);
		Printer print = (Printer) mpj.b.getPrintable(0);
		try {
			Field f = print.getClass().getDeclaredField("prp");
			f.setAccessible(true);
			PageableReportProcessor o = (PageableReportProcessor)f.get(print);
			JFreeReport reporte = o.getReport();
			TableModel data = reporte.getData();
			assertTrue(data.getRowCount()==1);
			assertTrue(reporte.getPageHeader().getElement(0).getDataSource().getValue().equals("Enero de 2011"));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		assertTrue(c.getMes("Enero", 2011).getListas().size()==2);
	}
	
}
