package pruebas.mutacion.presentacion;

import java.awt.Component;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import javax.swing.JFrame;
import javax.swing.JTextPane;
import javax.swing.table.TableModel;

import mockit.Mockit;

import org.uispec4j.MenuItem;
import org.uispec4j.Panel;
import org.uispec4j.Table;
import org.uispec4j.TextBox;
import org.uispec4j.Trigger;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.Window;
import org.uispec4j.finder.ComponentMatcher;
import org.uispec4j.interception.WindowHandler;
import org.uispec4j.interception.WindowInterceptor;

import configuracion.Configuracion;

import dominio.Cita;
import dominio.Control;
import dominio.Mes;

import persistencia.Persistencia;
import presentacion.CitasMEd;
import presentacion.JDiasComponent;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.presentacion.TestCitasMed;

public class TestCitasMed_Mut extends UISpecTestCase{

	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));

	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}
	
	public static JFrame getFrame(CitasMEd cm){
		JFrame jf = null;
		
		try {
			Method f = cm.getClass().getDeclaredMethod("getJFrame");
			f.setAccessible(true);
			jf = (JFrame)f.invoke(cm);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		return jf;
	}
	
	
	
	
	/*********************Test para mutacion*************/
	
	public void testBorrarListaUnaCitaEspecial(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaEspecial(134, "test134", "comment134", 0, 2012, "Enero",5);
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Borrar lista");
		mp.click();
		assertTrue(c.getMes("Enero", 2012).getListas().size()==0);
		assertTrue(!cm.getSinDias().getText().contains("citas"));
		
	}
	
	
	
	public void testOrganizarCitasUnaCitaEspecial(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(123, new Cita("test123",123,"comment123",0));
		
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Organizar citas automticamente");
		mp.click();
		
		
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDaEspecial().size()== 1);
		assertTrue(!cm.getSinDias().getText().contains("citas"));
		
	}
	
	public void testBorrarCitaNormalUnaCitaDos(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDa().put(123, new Cita("test123",123,"comment123",0));
		c.getMes("Enero", 2012).getSinAsignarDa().put(143, new Cita("test143",143,"comment143",0));
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePC").selectRow(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Borrar cita");
		mp.click();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()== 1);
		assertTrue(!cm.getSinDias().getText().contains("citas"));
		
	}
	
	public void testCrearCitaCeroCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Nueva cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==0);
		assertTrue(cm.getSinDias().getText().contains("citas"));
		
	}
	
	public void testCrearListaUnaCitaDos(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Crear listas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().size()==0);
		assertTrue(!cm.getSinDias().getText().contains("citas"));
		
	}
	
	
	public void testMoverListaUnaCitaDos(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Mover lista de da");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().containsKey(5));
		assertTrue(!cm.getSinDias().getText().contains("citas"));
		
	}
	
	public void testCambiarMaxUnaCitaDos(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Cambiar el nmero mximo de citas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().get(5).getCantidadMaxima()==10);
		assertTrue(!cm.getSinDias().getText().contains("citas"));
		
	}
	
	public void testCambiarMaxDosCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		c.addCitaSinFecha(135, "test135", "comment135", 0, 2012, "Enero");
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Cambiar el nmero mximo de citas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().get(5).getCantidadMaxima()==10);
		assertTrue(cm.getSinDias().getText().contains("citas"));
		
	}
	
	public void testCambiarMaxCeroCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Cambiar el nmero mximo de citas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().get(5).getCantidadMaxima()==10);
		assertTrue(cm.getSinDias().getText().contains("citas"));
		
	}
	
	
	
	public void testBorrarCrearCitaConDia(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).crearLista(5, 10);
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		

		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Nueva cita");
		WindowInterceptor wi = WindowInterceptor.init(mp.triggerClick());
		wi.process(new WindowHandler() {
			public Trigger process(Window dialog) {
				assertTrue(dialog.titleEquals("Crear una cita"));

				dialog.getTextBox("fieldN").setText("test1");
				dialog.getTextBox("fieldNH").setText("10");
				dialog.getTextBox("fieldC").setText("Comentario1");

				return dialog.getButton("Aceptar").triggerClick();
			}
		}).run();
		
		assertTrue(c.getMes("Enero", 2012).getListas().size()==1);
		assertTrue(c.getMes("Enero", 2012).getListas().get(5).getAsignados().size()==1);
	}
	
	public void testCrearListaCeroCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Crear listas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().size()==0);
		assertTrue(cm.getSinDias().getText().contains("citas"));
		
	}
	
	public void testBorrarListaCeroCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Borrar lista");
		mp.click();
		assertTrue(c.getMes("Enero", 2012).getListas().size()==0);
		assertTrue(cm.getSinDias().getText().contains("citas"));
		
		
	}
	
	public void testAsignarDiaACitaSegunda(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		Table t = p.getTable("tablePC");
		t.selectRow(1);
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Asignar da a cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	        	Panel p2 = window.getPanel(new ComponentMatcher() {
	    			@Override
	    			public boolean matches(Component arg0) {
	    				boolean ret = false;
	    				if(arg0 instanceof JDiasComponent){
	    					ret = true;
	    				}
	    				return ret;
	    			}
	    		});
	    		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
	    		jdc.selectDia("42");
	        	return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()== 5);
		
		
	}
	
	public void testAsignarDiaACitaSegundaEspecial(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		Mes ms = c.getMes("Enero", 2011);
		ms.getSinAsignarDaEspecial().put(768, new Cita("test768", 768, "coment768", 0));
		ms.getSinAsignarDaEspecial().put(769, new Cita("test769", 769, "coment769", 0));
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		Table t = p.getTable("tablePCS");
		t.selectRow(1);
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Asignar da a cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	        	Panel p2 = window.getPanel(new ComponentMatcher() {
	    			@Override
	    			public boolean matches(Component arg0) {
	    				boolean ret = false;
	    				if(arg0 instanceof JDiasComponent){
	    					ret = true;
	    				}
	    				return ret;
	    			}
	    		});
	    		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
	    		jdc.selectDia("42");
	        	return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDaEspecial().size()== 1);
		
		
		
	}
	
	public void testAsignarDiaACitaUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(1234, "test1234", "coment1234", 0, 2012, "Enero");
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Table t = p.getTable("tablePC");
		t.selectRow(0);
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Asignar da a cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	        	
	        	return window.getButton("Cancelar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()== 1);
		assertTrue(cm.getSinDias().getText().equals("1 cita"));
		
	}
	
	
	
	public void testOrganizarCitasCorrectoDeUna(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDa().put(123, new Cita("test123",123,"comment123",0));
		c.getMes("Enero", 2012).crearLista(5, 20);
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Organizar citas automticamente");
		mp.click();
		/*WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();*/
		
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()== 0);
		assertTrue(cm.getSinDias().getText().contains("0 citas"));
		
	}
	
	public void testBorrarCitaNormalDosCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDa().put(123, new Cita("test123",123,"comment123",0));
		c.getMes("Enero", 2012).getSinAsignarDa().put(143, new Cita("test143",143,"comment143",0));
		c.getMes("Enero", 2012).getSinAsignarDa().put(145, new Cita("test145",145,"comment145",0));
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePC").selectRow(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Borrar cita");
		mp.click();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()== 2);
		assertTrue(cm.getSinDias().getText().contains("citas"));
		
	}
	
	public void testBuscarCitaUnaCita2(){
		
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDa().put(123, new Cita("test123",123,"comment123",0));
		
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePC").selectRow(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Buscar cita...");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cerrar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==1);
		assertTrue(!cm.getSinDias().getText().contains("citas"));
	}
	
	
	public void testBorrarCrearCitaConDiaEspecial(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).crearLista(5, 10);
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		

		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Nueva cita especial");
		WindowInterceptor wi = WindowInterceptor.init(mp.triggerClick());
		wi.process(new WindowHandler() {
			public Trigger process(Window dialog) {
				assertTrue(dialog.titleEquals("Crear una cita"));

				dialog.getTextBox("fieldN").setText("test1");
				dialog.getTextBox("fieldNH").setText("10");
				dialog.getTextBox("fieldC").setText("Comentario1");

				return dialog.getButton("Aceptar").triggerClick();
			}
		}).run();
		
		assertTrue(c.getMes("Enero", 2012).getListas().size()==1);
		assertTrue(c.getMes("Enero", 2012).getListas().get(5).getEspeciales().size()==1);
	}
	
	public void testCrearCitaUnaCitaTextAssert(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Nueva cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==1);
		assertTrue(cm.getSinDias().getText().equals("1 cita"));
		
	}
	
	public void testCrearCitaDosCitaTextAssert(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		c.addCitaSinFecha(135, "test135", "comment135", 0, 2012, "Enero");
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Nueva cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==2);
		assertTrue(cm.getSinDias().getText().equals("2 citas"));
		
	}
	
	public void testCrearListaDosCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		c.addCitaSinFecha(135, "test135", "comment135", 0, 2012, "Enero");
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Crear listas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().size()==0);
		assertTrue(cm.getSinDias().getText().equals("2 citas"));
		
	}
	
	public void testMoverListaDosCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		c.addCitaSinFecha(135, "test135", "comment135", 0, 2012, "Enero");
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Mover lista de da");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().containsKey(5));
		assertTrue(cm.getSinDias().getText().equals("2 citas"));
		
		
	}
	
	public void testBorrarListaDosCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		c.addCitaSinFecha(135, "test135", "comment135", 0, 2012, "Enero");
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Borrar lista");
		mp.click();
		assertTrue(c.getMes("Enero", 2012).getListas().size()==0);
		assertTrue(cm.getSinDias().getText().equals("2 citas"));
		
	}
	
	public void testOrganizarCitasUnaCitaTextAssert(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(123, new Cita("test123",123,"comment123",0));
		
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Organizar citas automticamente");
		mp.click();
		
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDaEspecial().size()== 1);
		assertTrue(cm.getSinDias().getText().equals("1 cita"));
		
	}
	
	public void testBorrarCitaSelectTable1(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		Mes ms = c.getMes("Enero", 2011);
		ms.getSinAsignarDaEspecial().put(1234, new Cita("test1234", 1234,"coment1234", 0));
		ms.getSinAsignarDaEspecial().put(12345, new Cita("test12345", 12345,"coment12345", 0));
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePCS").selectRow(1);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Borrar cita");
		mp.click();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDaEspecial().size()== 1);
		
		
	}
	
	public void testBorrarCitaSelectTable1DosCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		Mes ms = c.getMes("Enero", 2011);
		ms.getSinAsignarDaEspecial().put(1234, new Cita("test1234", 1234,"coment1234", 0));
		ms.getSinAsignarDaEspecial().put(12345, new Cita("test12345", 12345,"coment12345", 0));
		ms.getSinAsignarDaEspecial().put(123, new Cita("test123", 123,"coment123", 0));
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePCS").selectRow(1);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Borrar cita");
		mp.click();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDaEspecial().size()== 2);
		assertTrue(cm.getSinDias().getText().equals("8 citas"));
		
	}
	
	public void testBuscarCitaUnaCitaTextAssert(){
		
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDa().put(123, new Cita("test123",123,"comment123",0));
		
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePC").selectRow(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Buscar cita...");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cerrar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==1);
		assertTrue(cm.getSinDias().getText().equals("1 cita"));
	}
	
	public void testBuscarCitaDosCitaTextAssert(){
		
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDa().put(123, new Cita("test123",123,"comment123",0));
		c.getMes("Enero", 2012).getSinAsignarDa().put(1234, new Cita("test1234",1234,"comment1234",0));
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePC").selectRow(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Buscar cita...");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cerrar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==2);
		assertTrue(cm.getSinDias().getText().equals("2 citas"));
	}
	
	public void testAsignarDiaACitaNHNeg(){
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDa().put(-12312356, new Cita("test12312356",-12312356,"comment12312356",0));
		
		c.getMes("Enero", 2012).crearLista(5, 20);
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Table t = p.getTable("tablePC");
		t.selectRow(0);
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Asignar da a cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	        	Panel p2 = window.getPanel(new ComponentMatcher() {
	    			@Override
	    			public boolean matches(Component arg0) {
	    				boolean ret = false;
	    				if(arg0 instanceof JDiasComponent){
	    					ret = true;
	    				}
	    				return ret;
	    			}
	    		});
	    		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
	    		jdc.selectDia("31");
	        	return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()== 0);
		
		
	}
	
	
	public void testCambiarMaxUnaCitaEspecial(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(123, new Cita("Test123",123,"",0));
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Cambiar el nmero mximo de citas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().get(5).getCantidadMaxima()==10);
		assertTrue(cm.getSinDias().getText().equals("1 cita"));
		
	}
	
	
	public void testCrearListaDemasiadasCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		for(int i = 0;i<30;i++){
			c.addCitaSinFecha(1230+i, "test"+i, "coment"+i, 0, 2012, "Enero");
		}
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Crear listas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
			public Trigger process(Window window) {

				window.getSpinner().setValue(5);

				Panel pjd = window.getPanel(new ComponentMatcher(){
					public boolean matches(Component component) {
						boolean ret = false;
						if(component instanceof JDiasComponent){
							ret = true;
						}
						return ret;
					}
				});

				JDiasComponent jdc = (JDiasComponent)pjd.getAwtComponent();
				jdc.selectDia("33");
				window.getButton("Aceptar").click();
				
				return window.getButton("Cancel").triggerClick();
			}
		}).run();
		assertTrue(c.getMes("Enero", 2012).getListas().size()==0);
		assertTrue(cm.getSinDias().getText().contains("citas"));
		
	}
	
	
	public void testCambiarMaxLista(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Cambiar el nmero mximo de citas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          
	        	window.getSpinner().setValue(6);
	        	return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getListas().get(5).getCantidadMaxima()==6);
		assertTrue(cm.getSinDias().getText().contains("1 cita"));
		
	}
	
	public void testCambiarMaxListaNoCierra(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		c.getMes("Enero", 2011).getListas().remove(5);
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Cambiar el nmero mximo de citas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          
	        	
	        	window.getSpinner().setValue(-1);
	        	window.getButton("Aceptar").click();
	        	
	        	return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		//assertTrue(c.getMes("Enero", 2012).getListas().get(5).getCantidadMaxima()==10);
		assertTrue(cm.getSinDias().getText().contains("1 cita"));
		
	}
	
	public void testMpverListaCierra(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Mover lista de da");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          
	        	Panel p2 = window.getPanel(new ComponentMatcher() {
	    			
	    			@Override
	    			public boolean matches(Component arg0) {
	    				boolean ret = false;
	    				if(arg0 instanceof JDiasComponent){
	    					ret = true;
	    				}
	    				return ret;
	    			}
	    		});
	    		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
	    		jdc.selectDia("43");
	        	
	        	return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getListas().containsKey(21));
		
	}

	
	public void testSelectRows(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		
		Table t = p.getTable("tablePC");
		t.selectRow(0);
		TextBox tb = p.getTextBox("textObservaciones");
		assertTrue(tb.getText().equals("Sin preferencias para ser citado.\n\ntestcoment"));
		
		t.selectRow(1);
		assertTrue(tb.getText().equals("Preferencia para ser citado A FINALES.\n\ntestcoment3"));
	}
	
	public void testSelectRows2(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2011).getSinAsignarDaEspecial().put(1234,new Cita("pedro", 1234, "coment1",0));
		c.getMes("Enero", 2011).getSinAsignarDaEspecial().put(1235,new Cita("pedro2", 1235, "coment2",0));
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		
		Table t = p.getTable("tablePCS");
		
		TableModel dm = t.getAwtComponent().getModel();
		
		t.selectRow(0);
		TextBox tb = p.getTextBox("textObservaciones");
		assertTrue(tb.getText().equals("Sin preferencias para ser citado.\n\ncoment2"));
		
		t.selectRow(1);
		assertTrue(tb.getText().equals("Sin preferencias para ser citado.\n\ncoment1"));
	}
	
	public void testSelectRows3(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2011).getSinAsignarDaEspecial().put(1234,new Cita("pedro", 1234, "coment1",-1));
		c.getMes("Enero", 2011).getSinAsignarDaEspecial().put(1235,new Cita("pedro2", 1235, "coment2",-2));
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		
		Table t = p.getTable("tablePCS");
		
		TableModel dm = t.getAwtComponent().getModel();
		
		t.selectRow(0);
		TextBox tb = p.getTextBox("textObservaciones");
		assertTrue(tb.getText().equals("\ncoment2"));
		
		t.selectRow(1);
		assertTrue(tb.getText().equals("\ncoment1"));
	}
	
	public void testBorrarCitaNHNeg(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(-123, "pedro", "coment", 0, 2012, "Enero");
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		
		Table t = p.getTable("tablePC");
		
		t.selectRow(0);
		
		cm.borrarCita();
		
		assertTrue(t.rowCountEquals(0));
	}
	
	
	public void testCrearListasCNE(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(123, "pedro", "coment", 0, 2012, "Enero");
		c.addCitaSinFecha(124, "pedro", "coment", 0, 2012, "Enero");
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(125, new Cita("pedro",125,"coment",0));
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Crear listas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		
		assertTrue(cm.getSinDias().getText().equals("3 citas"));
		
	}
	
	public void testMoverListaCNE(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(123, "pedro", "coment", 0, 2012, "Enero");
		c.addCitaSinFecha(124, "pedro", "coment", 0, 2012, "Enero");
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(125, new Cita("pedro",125,"coment",0));
		
		c.getMes("Enero", 2012).crearLista(13, 10);
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Mover lista");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		
		assertTrue(cm.getSinDias().getText().equals("3 citas"));
		
	}
	
	public void testAsignarDiaACitaCNE(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(123, "pedro", "coment", 0, 2012, "Enero");
		c.addCitaSinFecha(124, "pedro", "coment", 0, 2012, "Enero");
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(125, new Cita("pedro",125,"coment",0));
		
		c.getMes("Enero", 2012).crearLista(13, 10);
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		 
		
		Table t = p.getTable("tablePC");
		t.selectRow(0);
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Asignar da a cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		
		assertTrue(cm.getSinDias().getText().equals("3 citas"));
		
	}
	
	
	public void testBuscarCitaCNE(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(123, "pedro", "coment", 0, 2012, "Enero");
		c.addCitaSinFecha(124, "pedro", "coment", 0, 2012, "Enero");
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(125, new Cita("pedro",125,"coment",0));
		
		c.getMes("Enero", 2012).crearLista(13, 10);
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		 
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Buscar cita...");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cerrar").triggerClick();
	        }
	      }).run();
		
		assertTrue(cm.getSinDias().getText().equals("3 citas"));
		
	}
	
	public void testShowMensaje(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		
		
		class MyTrigger2 implements Trigger{
    		CitasMEd cm;
    		public MyTrigger2(CitasMEd cm){
    			super();
    			this.cm = cm;
    		}
			@Override
			public void run() throws Exception {
				// TODO Auto-generated method stub
				cm.showMensaje("mensaje");
			}
    	}
		
		WindowInterceptor.init(new MyTrigger2(cm)).process(new WindowHandler() {
	        public Trigger process(Window window) {
	        	window.getTextBox("mensaje");
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		
	}
	
	
	public void testMoverListaCNE2(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		
		c.getMes("Enero", 2012).crearLista(13, 10);
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Mover lista");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		
		assertTrue(cm.getSinDias().getText().equals("0 citas"));
		
	}
	
	
	public void testAsignarDiaACitaError(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Asignar da a cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	        	window.getTextBox("Para asignar un da a una cita sedebe seleccionar una cita sin da asignado.");
	        	return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()== 6);
		
		
	}
	
	public void testOrganizarCItasNoOrganizaCNE(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(123, "pedro", "coment", 0, 2012, "Enero");
		c.addCitaSinFecha(124, "pedro", "coment", 0, 2012, "Enero");
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(125, new Cita("pedro",125,"coment",0));
		
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		 
		c.borrarCita("Enero", 2012, 124, false, -1);
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Organizar citas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();
		
		assertTrue(cm.getSinDias().getText().equals("3 citas"));
		
	}
	
	public void testOrganizarCItasOrganizaCNE(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(123, "pedro", "coment", 0, 2012, "Enero");
		c.addCitaSinFecha(124, "pedro", "coment", 0, 2012, "Enero");
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(125, new Cita("pedro",125,"coment",0));
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(126, new Cita("pedro",126,"coment",0));
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(127, new Cita("pedro",127,"coment",0));
		
		c.getMes("Enero", 2012).crearLista(12, 10);
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		 
		c.borrarCita("Enero", 2012, 124, false, -1);
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Organizar citas");
		mp.click();
		
		assertTrue(cm.getSinDias().getText().equals("3 citas"));
		
	}
	
	public void testBorrarCitaSegunda(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePC").selectRow(1);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Borrar cita");
		mp.click();
		assertTrue(c.getMes("Enero", 2011).getSinAsignarDa().size()== 5);
		assertTrue(cm.getSinDias().getText().equals("5 citas"));
		
	}
	
	public void testBorrarCitaNormalUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(125, "p", "cm", 0, 2012, "Enero");
		c.addCitaSinFecha(123, "p2", "cm2", 0, 2012, "Enero");
		c.addCitaSinFecha(124, "p3", "cm3", 0, 2012, "Enero");
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		assertTrue(cm.getSinDias().getText().equals("3 citas"));
		Table t = p.getTable("TablePC");
		t.selectRow(0);
		c.borrarCita("Enero", 2012, 125, false, -1);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Borrar cita");
		mp.click();
		
		assertTrue(cm.getSinDias().getText().equals("3 citas"));
	}
	
	public void testBorrarCitaNormalUnaCitaACero(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(125, "p", "cm", 0, 2012, "Enero");
		
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		assertTrue(cm.getSinDias().getText().equals("1 citas"));
		Table t = p.getTable("TablePC");
		t.selectRow(0);
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Borrar cita");
		mp.click();
		
		assertTrue(cm.getSinDias().getText().equals("0 citas"));
	}
	
	
	
	public void testBuscarCitaCeroCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		 
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Buscar cita...");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cerrar").triggerClick();
	        }
	      }).run();
		
		assertTrue(cm.getSinDias().getText().equals("0 citas"));
		
	}
	
	public void testSelectCitasMalOptions(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2011).getSinAsignarDaEspecial().put(1234,new Cita("pedro", 1234, "coment1",3));
		
		JFrame jf = TestCitasMed.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2011);
		p.getListBox().selectIndex(0);
		
		
		Table t = p.getTable("tablePCS");
		
		TableModel dm = t.getAwtComponent().getModel();
		
		t.selectRow(0);
		TextBox tb = p.getTextBox("textObservaciones");
		assertTrue(tb.getText().equals("\ncoment1"));
		
		
	}
	
	public void testCrearListaUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(123, "pedro", "coment", 0, 2012, "Enero");
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Crear listas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		
		assertTrue(cm.getSinDias().getText().equals("1 cita"));
		
	}
	
	public void testMoverListaUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(123, "pedro", "coment", 0, 2012, "Enero");
		
		c.getMes("Enero", 2012).crearLista(13, 11);
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Mover lista");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		
		assertTrue(cm.getSinDias().getText().equals("1 cita"));
		
	}
	
	public void testCambiarMaxListaUnaCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(123, "pedro", "coment", 0, 2012, "Enero");
		c.addCitaSinFecha(124, "pedro", "coment", 0, 2012, "Enero");
		
		c.getMes("Enero", 2012).crearLista(13, 11);
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("42");
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Cambiar el nmero mximo de citas");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		
		assertTrue(cm.getSinDias().getText().equals("2 citas"));
		
	}
	
	public void testBorrarListaUnaCitas(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).crearLista(5, 10);
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Borrar lista");
		mp.click();
		assertTrue(c.getMes("Enero", 2012).getListas().size()==0);
		assertTrue(cm.getSinDias().getText().equals("1 cita"));
		
	}
	
	public void testBorrarCitaQuedaUna(){
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.addCitaSinFecha(123, "Pedro", "coment", 0, 2012, "Enero");
		c.addCitaSinFecha(124, "Pedro2", "coment2", 0, 2012, "Enero");
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		p.getTable("tablePC").selectRow(0);
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Borrar cita");
		mp.click();
		
		assertTrue(cm.getSinDias().getText().equals("1 cita"));
		
	}
	
	
	public void testCrearCitaDosCitaEsepcialTextAssert(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		c.addCitaSinFecha(134, "test134", "comment134", 0, 2012, "Enero");
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(135, new Cita("test4354",135,"",0));
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Nueva cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDa().size()==1);
		assertTrue(cm.getSinDias().getText().equals("2 citas"));
		
	}
	
	public void testCambiarNombreDataBase() throws SecurityException, NoSuchMethodException, IllegalArgumentException, IllegalAccessException, InvocationTargetException{
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		
		String ti = p.getTitle();
		
		Method m = cm.getClass().getDeclaredMethod("cambiarNombreDataBase");
		m.setAccessible(true);
		m.invoke(cm);
		
		assertTrue(ti.equals(p.getTitle()));
		
	}
	
	public void testCambiarNombreDataBaseTitle() throws SecurityException, NoSuchMethodException, IllegalArgumentException, IllegalAccessException, InvocationTargetException, NoSuchFieldException{
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		
		Field f = c.getClass().getDeclaredField("c");
		f.setAccessible(true);
		Configuracion cnf = (Configuracion)f.get(c);
		
		cnf.setPathBaseCitas("a/b/c");
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		String ti = p.getTitle();
		
		assertTrue(ti,ti.equals("CitasMed - base de datos de citas: c"));
		
		
		
	}
	
	public void testDiaSelected() throws SecurityException, NoSuchMethodException, IllegalArgumentException, IllegalAccessException, InvocationTargetException, NoSuchFieldException{
		
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).crearLista(15, 10);
		c.addCitaConFecha(123, "", "", 0, 2012, "Enero", 15);
		c.addCitaConFecha(124, "", "", 0, 2012, "Enero", 15);
		c.addCitaConFecha(125, "", "", 0, 2012, "Enero", 15);
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		JTextPane jtp = (JTextPane)p.getTextBox("15___________\n\n").getAwtComponent();
		cm.diaSelected(jtp, "15");
		
		assertTrue( p.getTable("tablePC").rowCountEquals(3));
		
	}
	
}
