package pruebas.mutacion.presentacion;

import mockit.Mockit;

import org.uispec4j.Button;
import org.uispec4j.Panel;
import org.uispec4j.Trigger;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.Window;
import org.uispec4j.interception.WindowHandler;
import org.uispec4j.interception.WindowInterceptor;

import dominio.Control;
import dominio.Mes;

import persistencia.Persistencia;
import presentacion.JDCrearCita;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;

public class TestJDCrearCita_Mut extends UISpecTestCase{

	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}
	
	
	
	
	
	public void testNHNeg(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2011);
		int s = m.getListas().get(15).getNumeroTotal();
		
		JDCrearCita jdcc = new JDCrearCita(null, c, 2011, "Enero", true, false, 15);
		Panel p = new Panel(jdcc);
		
		p.getTextBox("fieldN").setText("testX");
		p.getTextBox("fieldNH").setText("-1234");
		p.getTextBox("fieldC").setText("ComentarioX");
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getSinAsignarDa().containsKey(-1234));
	}
	
	
	public void testNHConPref(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2011);
		int s = m.getListas().get(15).getNumeroTotal();
		
		JDCrearCita jdcc = new JDCrearCita(null, c, 2011, "Enero", false, true, 15);
		Panel p = new Panel(jdcc);
		
		p.getTextBox("fieldN").setText("testX");
		p.getTextBox("fieldNH").setText("234");
		p.getTextBox("fieldC").setText("ComentarioX");
		
		p.getRadioButton("A primeros").click();
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getListas().get(15).getAsignados().containsKey(234));
		assertTrue(m.getListas().get(15).getAsignados().get(234).getPreferencia() == 1);
	}
	
	public void testAoNeg(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", -2011);
		m.crearLista(15, 10);
		
		
		JDCrearCita jdcc = new JDCrearCita(null, c, -2011, "Enero", true, false, 15);
		Panel p = new Panel(jdcc);
		
		p.getTextBox("fieldN").setText("testX");
		p.getTextBox("fieldNH").setText("1234");
		p.getTextBox("fieldC").setText("ComentarioX");
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getSinAsignarDa().containsKey(1234));
	}
	
	public void testNHNeg2(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2011);
		int s = m.getListas().get(15).getNumeroTotal();
		
		JDCrearCita jdcc = new JDCrearCita(null, c, 2011, "Enero", true, true, 15);
		Panel p = new Panel(jdcc);
		
		p.getTextBox("fieldN").setText("testX");
		p.getTextBox("fieldNH").setText("-1234");
		p.getTextBox("fieldC").setText("ComentarioX");
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getListas().get(15).getEspeciales().containsKey(-1234));
	}
	
	public void testNHNeg3(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2011);
		int s = m.getListas().get(15).getNumeroTotal();
		
		JDCrearCita jdcc = new JDCrearCita(null, c, 2011, "Enero", false, true, 15);
		Panel p = new Panel(jdcc);
		
		p.getTextBox("fieldN").setText("testX");
		p.getTextBox("fieldNH").setText("-1234");
		p.getTextBox("fieldC").setText("ComentarioX");
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getListas().get(15).getAsignados().containsKey(-1234));
	}
	
}
