package pruebas.mutacion.presentacion;

import java.awt.Component;

import mockit.Mockit;

import org.uispec4j.Button;
import org.uispec4j.Panel;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.finder.ComponentMatcher;

import dominio.Control;
import dominio.Mes;

import persistencia.Persistencia;
import presentacion.JDLists;
import presentacion.JDiasComponent;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;

public class TestJDLists_Mut extends UISpecTestCase{

	
	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}
	
	
	
	
	
	/*************Test para mutacin******************/
	
	
	public void testMaxNeg(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2016);
		JDLists jdl = new JDLists(null, c, m);
		Panel p = new Panel(jdl);
		
		assertTrue(p.getSpinner().valueEquals(15));
		p.getSpinner().setValue(-2);
		assertTrue(p.getSpinner().valueEquals(-2));
		
		Panel pjd = p.getPanel(new ComponentMatcher(){
			  public boolean matches(Component component) {
				  boolean ret = false;
				  if(component instanceof JDiasComponent){
					  ret = true;
				  }
				  return ret;
				  }
				});
		
		JDiasComponent jdc = (JDiasComponent)pjd.getAwtComponent();
		jdc.selectDia("33");
		
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(vs.error);
		assertTrue(m.getListas().size() == 0);
	}
	
	public void testCrearListasNeg(){
		VentanaStub vs = new VentanaStub();
		Control c = new Control(vs);
		Mes m = c.getMes("Enero", 2012);
		JDLists jdl = new JDLists(null, c, m);
		Panel p = new Panel(jdl);
		
		Panel pjd = p.getPanel(new ComponentMatcher(){
			  public boolean matches(Component component) {
				  boolean ret = false;
				  if(component instanceof JDiasComponent){
					  ret = true;
				  }
				  return ret;
				  }
				});
		
		JDiasComponent jdc = (JDiasComponent)pjd.getAwtComponent();
		jdc.selectDia("42");
		jdc.selectDia("52");
		
		Button b = p.getButton("Aceptar");
		b.click();
		
		assertTrue(m.getListas().size() == 2);
		assertTrue(m.getListas().containsKey(13));
		assertTrue(m.getListas().containsKey(14));
		
	}
	
}
