package pruebas.mutacion.presentacion;


import java.awt.Dialog;
import java.awt.Window;

import org.uispec4j.Button;
import org.uispec4j.Panel;
import org.uispec4j.UISpecTestCase;

import dominio.Lista;
import mockit.Mockit;
import persistencia.Persistencia;
import presentacion.JDPrint;
import pruebas.cobertura.ControlStub;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;
import pruebas.cobertura.WPrinterJobMy2;
import sun.print.RasterPrinterJob;

public class TestJDPrint_mut extends UISpecTestCase{

	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		Mockit.tearDownMocks(RasterPrinterJob.class);
		
	}
	
	
	/**************************Para mutacin************************/
	
	public void testPrintDiaOp2(){
		
		VentanaStub vs = new VentanaStub();
		ControlStub c = new ControlStub(vs);
		Lista l = c.getMes("Enero", 2011).getListas().get(15);
		JDPrint jdp = new JDPrint(null, c, "Enero", 2011,l);
		Panel p = new Panel(jdp);
	
		p.getRadioButton("Citas especiales").click();
		
		Button b = p.getButton("Imprimir");
		b.click();
		
		assertTrue(!c.mes);
		assertTrue(!c.comments);
		assertTrue(c.citasOp == ControlStub.CITAS_ESPECIALES);
	}
	
	
	
	public void testAoNeg(){
		WPrinterJobMy2 mpj = new WPrinterJobMy2();
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		
		VentanaStub vs = new VentanaStub();
		ControlStub c = new ControlStub(vs);
		JDPrint jdp = new JDPrint(null, c, "Enero", -2011,c.getMes("Enero", 2011).getListas().get(15));
		Panel p = new Panel(jdp);
		
		
		Button b = p.getButton("Imprimir");
		b.click();
		
		assertTrue(!mpj.printed);
		
	}
	
	public void testAoNeg2(){
		WPrinterJobMy2 mpj = new WPrinterJobMy2();
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		
		VentanaStub vs = new VentanaStub();
		ControlStub c = new ControlStub(vs);
		JDPrint jdp = new JDPrint(null, c, "Enero", -2011);
		Panel p = new Panel(jdp);
		
		
		Button b = p.getButton("Imprimir");
		b.click();
		
		assertTrue(!mpj.printed);
		
	}
	
	public void testOwner(){
		WPrinterJobMy2 mpj = new WPrinterJobMy2();
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		
		VentanaStub vs = new VentanaStub();
		ControlStub c = new ControlStub(vs);
		
		Window w = null;
		Dialog d = new Dialog(w);
		JDPrint jdp = new JDPrint(d, c, "Enero", -2011);
		assertTrue(jdp.getOwner() == d);
		
	}
	
	public void testOwner2(){
		WPrinterJobMy2 mpj = new WPrinterJobMy2();
		Mockit.setUpMock(RasterPrinterJob.class,mpj);
		
		VentanaStub vs = new VentanaStub();
		ControlStub c = new ControlStub(vs);
		
		Window w = null;
		Dialog d = new Dialog(w);
		JDPrint jdp = new JDPrint(d, c, "Enero", -2011,c.getMes("Enero", 2011).getListas().get(15));
		assertTrue(jdp.getOwner() == d);
		
	}
}
