package pruebas.mutacion.presentacion;


import java.lang.reflect.Field;

import javax.swing.JTextPane;

import mockit.Mockit;

import org.uispec4j.Panel;
import org.uispec4j.UISpecTestCase;

import persistencia.Persistencia;
import presentacion.JDiasComponent;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.contenedorDiasStub;

import dominio.Cita;
import dominio.Mes;
import dominio.exceptions.CitaConFechaNoAsignadaException;
import dominio.exceptions.CitaYaAsigndaException;

public class TestJDiasComponent_Mut extends UISpecTestCase{

	
	//Window window; 
	
	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}


	
	
	
	/*********************Extra para cubrir mutacin**************************/
	
	

	
	
	public void testJDiasComponentMCUnaCitaSoloEspecialCL(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, true);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERLISTAMODE);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText().endsWith("____\n\n 1 cita"));
		}
		
		
		
	}
	
	
	public void testJDiasComponentMCUnaCitaSoloEspecialML(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.CREARLISTASMODE);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText().startsWith(i+"___________"));
			assertTrue(tp.getText().endsWith("____\n\n 1 cita"));
		}
		
		
		
	}
	
	public void testJDiasComponentGetDiaNeg(){

		Mes m = new Mes("Enero", 2011);
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.CREARLISTASMODE);
		
		JTextPane p = jdc.getPanel(-1);
		assertTrue(p==null);
		
		
	}
	
	public void testJDiasComponentMCDosCitaSoloEspecialML(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				m.asignarCitaConFecha(new Cita("test2", 200+i, "testcoment2", 0), i, false);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.CREARLISTASMODE);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText().startsWith(i+"___________"));
			assertTrue(tp.getText().endsWith("____\n\n 2 citas"));
		}
		
		
		
	}
	
	public void testJDiasComponentMCCeroCitaSoloEspecialML(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.CREARLISTASMODE);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText().startsWith(i+"___________"));
			assertTrue(tp.getText().endsWith("____\n\n 0 citas"));
		}
		
		
		
	}
	
	public void testJDiasComponentMCDosCitaSoloEspecialCL(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, true);
				m.asignarCitaConFecha(new Cita("test2", 200+i, "testcoment2", 0), i, true);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERLISTAMODE);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText().endsWith("____\n\n 2 citas"));
		}
		
		
		
	}
	
	public void testJDiasComponentMCCeroCitaSoloEspecialCL(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERLISTAMODE);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText().endsWith("____\n\n 0 citas"));
		}
		
		
		
	}
	
	public void testJDiasComponentMoverCitaCero(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERCITAMODE);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText().endsWith("____\n\n 0 citas"));
		}
		
		
		
	}
	
	public void testJDiasComponentMoverCitaDos(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, true);
				m.asignarCitaConFecha(new Cita("test2", 200+i, "testcoment2", 0), i, true);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERCITAMODE);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText().endsWith("____\n\n 2 citas"));
		}
		
		
		
	}
	
	public void testJDiasComponentMoverCitaUna(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, true);
				
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.MOVERCITAMODE);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText().endsWith("____\n\n 1 cita"));
		}
		
		
		
	}
	
	
	public void testJDiasComponentModeNeg(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, true);
				m.asignarCitaConFecha(new Cita("test2", 200+i, "testcoment2", 0), i, true);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), -4);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertFalse(tp.getText().endsWith("____\n\n 2 citas"));
		}
		
		
		
	}
	
	
	public void testJDiasComponentMaxListaNeg(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				m.asignarCitaConFecha(new Cita("test2", 200+i, "testcoment2", 0), i, false);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		for(int i = 1;i<25;i++){
			m.getListas().get(i).setCantidadMaxima(-10);
		}
		
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), 1);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText(),tp.getText().endsWith("____\n\n 2/-10 citas\n0 citas esp."));
		}
		
		
		
	}
	
	public void testJDiasComponentMaxListaNeg2(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		for(int i = 1;i<25;i++){
			m.getListas().get(i).setCantidadMaxima(-10);
		}
		
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), 1);
		Panel panel = new Panel(jdc);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText(),tp.getText().endsWith("____\n\n 1/-10 cita\n0 citas esp."));
		}
		
		
		
	}
	
	public void testJDiasComponentEvaluarBein(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		for(int i = 1;i<25;i++){
			m.getListas().get(i).setCantidadMaxima(-10);
		}
		
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), 1);
	
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			if(i<5){
				assertTrue(tp.getText(),tp.getText().startsWith(i+"____________\n\n"));
			}else{
				assertTrue(tp.getText(),tp.getText().startsWith(i+"___________\n\n"));
			}
			
		}
		
		
		
	}
	
	public void testJDiasComponentUnaCItaEspecial(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, true);
				
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), 1);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText(),tp.getText().endsWith("____\n\n 0/10 citas\n1 cita esp."));
		}
		
		
		
	}
	
	public void testJDiasComponentDosCItasEspeciales(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, true);
				m.asignarCitaConFecha(new Cita("test", 200+i, "testcoment", 0), i, true);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), 1);
		
		
		for(int i = 1;i<25;i++){
			JTextPane tp = jdc.getPanel(i);
			assertTrue(tp.getText(),tp.getText().endsWith("____\n\n 0/10 citas\n2 citas esp."));
		}
		
		
		
	}
	
	public void testJDiasComponentDosCItasEspecialesNoEnero() throws SecurityException, NoSuchFieldException, IllegalArgumentException, IllegalAccessException{

		Mes m = new Mes("Diciembre", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, true);
				m.asignarCitaConFecha(new Cita("test", 200+i, "testcoment", 0), i, true);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), 1);
		
		
		Field f = jdc.getClass().getDeclaredField("paneles");
		f.setAccessible(true);
		JTextPane[][] paneles = (JTextPane[][])f.get(jdc);
		
		assertTrue(paneles[3][0].getText(),paneles[3][0].getText().startsWith("1_"));
		
		
		
	}
}
