package pruebas.sobran.dominio;


import java.util.Calendar;
import java.util.Vector;

import junit.framework.TestCase;

import mockit.Mockit;


import persistencia.Persistencia;
import pruebas.cobertura.MyCalendar;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.VentanaStub;
import dominio.Cita;
import dominio.Control;
import dominio.Mes;
import dominio.ResultadoBusqueda;
import dominio.exceptions.CitaYaAsigndaException;

public class InitialTests_Mut extends TestCase{

		
	Control c;
	VentanaStub v;
	
	public void setUp(){
		
		
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		Mockit.setUpMock(Calendar.class,MyCalendar.class);
		c= null;
		v = null;
		
		v = new VentanaStub();
		c = new Control(v);
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		Mockit.tearDownMocks(Calendar.class);
	}
	
	
	
	
	
	/***********************ParaMutacion********************/
	
	
	
	
	public void testCambiarListaDeDia2(){


		c.cambiarListaDeDa(2011, "Enero", 15, 27);
		
		assertTrue(c.getMes("Enero", 2011).getListas().containsKey(27));
		assertTrue(!c.getMes("Enero", 2011).getListas().containsKey(15));
	}
	
	public void testCambiarListaDeDia3(){


		c.getMes("Enero", 2011).getListas().remove(15);
		
		c.cambiarListaDeDa(2011, "Enero", 14, 16);
		
		assertTrue(c.getMes("Enero", 2011).getListas().containsKey(16));
		assertTrue(!c.getMes("Enero", 2011).getListas().containsKey(14));
	}
	
	
}
