package pruebas.sobran.presentacion;

import java.awt.Component;
import java.lang.reflect.Method;

import javax.swing.JFrame;

import mockit.Mockit;

import org.uispec4j.MenuItem;
import org.uispec4j.Panel;
import org.uispec4j.Table;
import org.uispec4j.Trigger;
import org.uispec4j.UISpecTestCase;
import org.uispec4j.Window;
import org.uispec4j.finder.ComponentMatcher;
import org.uispec4j.interception.WindowHandler;
import org.uispec4j.interception.WindowInterceptor;

import dominio.Cita;
import dominio.Control;
import dominio.Mes;

import persistencia.Persistencia;
import presentacion.CitasMEd;
import presentacion.JDiasComponent;
import pruebas.cobertura.PersistenciaStubsInterface;

public class TestCitasMed_Mut extends UISpecTestCase{

	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));

	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}
	
	public static JFrame getFrame(CitasMEd cm){
		JFrame jf = null;
		
		try {
			Method f = cm.getClass().getDeclaredMethod("getJFrame");
			f.setAccessible(true);
			jf = (JFrame)f.invoke(cm);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		return jf;
	}
	
	
	
	
	public void testBorrarListaCeroCita(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		c.getMes("Enero", 2012).crearLista(5, 10);
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		Panel p2 = p.getPanel(new ComponentMatcher() {
			
			@Override
			public boolean matches(Component arg0) {
				boolean ret = false;
				if(arg0 instanceof JDiasComponent){
					ret = true;
				}
				return ret;
			}
		});
		JDiasComponent jdc = (JDiasComponent)p2.getAwtComponent();
		jdc.selectDia("31");
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Listas");
		MenuItem mp = m.getSubMenu("Borrar lista");
		mp.click();
		assertTrue(c.getMes("Enero", 2012).getListas().size()==0);
		assertTrue(cm.getSinDias().getText().contains("citas"));
		
		
	}
	
	
	
	public void testCrearCitaUnaCitaEspecial(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(123, new Cita("Test123",123,"",0));
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Nueva cita");
		WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Cancel").triggerClick();
	        }
	      }).run();
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDaEspecial().size()==1);
		assertTrue(cm.getSinDias().getText().equals("1 cita"));
		
	}
	
	public void testOrganizarCitasError(){
		CitasMEd cm = new CitasMEd();
		Control c = new Control(cm);
		cm.setControl(c);
		
		c.getMes("Enero", 2012).getSinAsignarDaEspecial().put(123, new Cita("test123",123,"comment123",0));
		
		
		JFrame jf = TestCitasMed_Mut.getFrame(cm);
		Window p = new Window(jf);
		p.getSpinner().setValue(2012);
		p.getListBox().selectIndex(0);
		
		
		
		MenuItem m = p.getMenuBar().getMenu("Citas");
		MenuItem mp = m.getSubMenu("Organizar citas automticamente");
		mp.click();
		/*WindowInterceptor.init(mp.triggerClick()).process(new WindowHandler() {
	        public Trigger process(Window window) {
	          return window.getButton("Aceptar").triggerClick();
	        }
	      }).run();*/
		
		assertTrue(c.getMes("Enero", 2012).getSinAsignarDaEspecial().size()== 1);
		assertTrue(!cm.getSinDias().getText().contains("citas"));
		
	}
	
	
}
