package pruebas.sobran.presentacion;


import javax.swing.JTextPane;

import mockit.Mockit;

import org.uispec4j.Panel;
import org.uispec4j.UISpecTestCase;

import persistencia.Persistencia;
import presentacion.JDiasComponent;
import pruebas.cobertura.PersistenciaStubsInterface;
import pruebas.cobertura.contenedorDiasStub;

import dominio.Cita;
import dominio.Mes;
import dominio.exceptions.CitaConFechaNoAsignadaException;
import dominio.exceptions.CitaYaAsigndaException;

public class TestJDiasComponent_Mut extends UISpecTestCase{

	
	//Window window; 
	
	public void setUp(){
		Mockit.setUpMock(Persistencia.class,PersistenciaStubsInterface.class);
		//setAdapter(new MainClassAdapter(CitasMEd.class, new String[0]));
		
		
	}
	
	public void tearDown(){
		Mockit.tearDownMocks(Persistencia.class);
		
	}


	
	
	
	/*********************Extra para cubrir mutacin**************************/
	
	public void testJDiasComponentMCUnaCitaSoloEspecial(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, true);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE);
		Panel panel = new Panel(jdc);
		
		JTextPane tp = jdc.getPanel(10);
		assertTrue(tp.getText().endsWith("cita esp."));
		
		
	}
	
	
	public void testJDiasComponentMCUnaCitaSoloNormal(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			try {
				m.asignarCitaConFecha(new Cita("test", 100+i, "testcoment", 0), i, false);
				
			} catch (CitaConFechaNoAsignadaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (CitaYaAsigndaException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE);
		Panel panel = new Panel(jdc);
		
		JTextPane tp = jdc.getPanel(10);
		
		
		assertTrue(tp.getText().endsWith("cita\n0 citas esp."));
	
	}
	
	public void testJDiasComponentMCCeroCitaSoloNormal(){

		Mes m = new Mes("Enero", 2011);
		for(int i = 1;i<25;i++){
			m.crearLista(i, 10);
			
		}
		JDiasComponent jdc = new JDiasComponent(m, new contenedorDiasStub(), JDiasComponent.NORMALMODE);
		Panel panel = new Panel(jdc);
		
		JTextPane tp = jdc.getPanel(10);
		
		assertTrue(tp.getText().endsWith("citas\n0 citas esp."));
	
	}
	
	
	
	public void testSElectDia20(){
		Mes m = new Mes("Enero", 2011);
		contenedorDiasStub cd = new contenedorDiasStub();
		JDiasComponent jdc = new JDiasComponent(m, cd, JDiasComponent.NORMALMODE);
		Panel panel = new Panel(jdc);
		
		jdc.selectDia("33");
		
		assertTrue(cd.jtp.getText().startsWith("20_"));
		assertTrue(cd.dia.equals("20"));
	}
	
	
	
}
